/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Identity properties of the Api Management service resource.
 *
 */
class ApiManagementServiceIdentity {
  /**
   * Create a ApiManagementServiceIdentity.
   * @property {string} type The type of identity used for the resource. The
   * type 'SystemAssigned, UserAssigned' includes both an implicitly created
   * identity and a set of user assigned identities. The type 'None' will
   * remove any identities from the service. Possible values include:
   * 'SystemAssigned', 'UserAssigned', 'SystemAssigned, UserAssigned', 'None'
   * @property {uuid} [principalId] The principal id of the identity.
   * @property {uuid} [tenantId] The client tenant id of the identity.
   * @property {object} [userAssignedIdentities] The list of user identities
   * associated with the resource. The user identity
   * dictionary key references will be ARM resource ids in the form:
   * '/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/
   * providers/Microsoft.ManagedIdentity/userAssignedIdentities/{identityName}'.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApiManagementServiceIdentity
   *
   * @returns {object} metadata of ApiManagementServiceIdentity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiManagementServiceIdentity',
      type: {
        name: 'Composite',
        className: 'ApiManagementServiceIdentity',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          principalId: {
            required: false,
            readOnly: true,
            serializedName: 'principalId',
            type: {
              name: 'String'
            }
          },
          tenantId: {
            required: false,
            readOnly: true,
            serializedName: 'tenantId',
            type: {
              name: 'String'
            }
          },
          userAssignedIdentities: {
            required: false,
            serializedName: 'userAssignedIdentities',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'UserIdentityPropertiesElementType',
                  type: {
                    name: 'Composite',
                    className: 'UserIdentityProperties'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ApiManagementServiceIdentity;
