/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Api Version set base parameters
 *
 */
class ApiVersionSetEntityBase {
  /**
   * Create a ApiVersionSetEntityBase.
   * @property {string} [description] Description of API Version Set.
   * @property {string} [versionQueryName] Name of query parameter that
   * indicates the API Version if versioningScheme is set to `query`.
   * @property {string} [versionHeaderName] Name of HTTP header parameter that
   * indicates the API Version if versioningScheme is set to `header`.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApiVersionSetEntityBase
   *
   * @returns {object} metadata of ApiVersionSetEntityBase
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiVersionSetEntityBase',
      type: {
        name: 'Composite',
        className: 'ApiVersionSetEntityBase',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          versionQueryName: {
            required: false,
            serializedName: 'versionQueryName',
            constraints: {
              MaxLength: 100,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          versionHeaderName: {
            required: false,
            serializedName: 'versionHeaderName',
            constraints: {
              MaxLength: 100,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ApiVersionSetEntityBase;
