/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Reconnect request parameters.
 *
 * @extends models['Resource']
 */
class BackendReconnectContract extends models['Resource'] {
  /**
   * Create a BackendReconnectContract.
   * @property {moment.duration} [after] Duration in ISO8601 format after which
   * reconnect will be initiated. Minimum duration of the Reconnect is PT2M.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BackendReconnectContract
   *
   * @returns {object} metadata of BackendReconnectContract
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackendReconnectContract',
      type: {
        name: 'Composite',
        className: 'BackendReconnectContract',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          after: {
            required: false,
            serializedName: 'properties.after',
            type: {
              name: 'TimeSpan'
            }
          }
        }
      }
    };
  }
}

module.exports = BackendReconnectContract;
