/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Error Body contract.
 *
 */
class ErrorResponseBody {
  /**
   * Create a ErrorResponseBody.
   * @property {string} [code] Service-defined error code. This code serves as
   * a sub-status for the HTTP error code specified in the response.
   * @property {string} [message] Human-readable representation of the error.
   * @property {array} [details] The list of invalid fields send in request, in
   * case of validation error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorResponseBody
   *
   * @returns {object} metadata of ErrorResponseBody
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ErrorResponseBody',
      type: {
        name: 'Composite',
        className: 'ErrorResponseBody',
        modelProperties: {
          code: {
            required: false,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ErrorFieldContractElementType',
                  type: {
                    name: 'Composite',
                    className: 'ErrorFieldContract'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorResponseBody;
