/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Custom hostname configuration.
 *
 */
class HostnameConfigurationOld {
  /**
   * Create a HostnameConfigurationOld.
   * @member {string} type Hostname type. Possible values include: 'Proxy',
   * 'Portal', 'Management', 'Scm'
   * @member {string} hostname Hostname to configure.
   * @member {object} certificate Certificate information.
   * @member {date} [certificate.expiry] Expiration date of the certificate.
   * The date conforms to the following format: `yyyy-MM-ddTHH:mm:ssZ` as
   * specified by the ISO 8601 standard.
   * @member {string} [certificate.thumbprint] Thumbprint of the certificate.
   * @member {string} [certificate.subject] Subject of the certificate.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HostnameConfigurationOld
   *
   * @returns {object} metadata of HostnameConfigurationOld
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HostnameConfigurationOld',
      type: {
        name: 'Composite',
        className: 'HostnameConfigurationOld',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'Enum',
              allowedValues: [ 'Proxy', 'Portal', 'Management', 'Scm' ]
            }
          },
          hostname: {
            required: true,
            serializedName: 'hostname',
            type: {
              name: 'String'
            }
          },
          certificate: {
            required: true,
            serializedName: 'certificate',
            type: {
              name: 'Composite',
              className: 'CertificateInformation'
            }
          }
        }
      }
    };
  }
}

module.exports = HostnameConfigurationOld;
