/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Issue contract Base Properties.
 *
 */
class IssueContractBaseProperties {
  /**
   * Create a IssueContractBaseProperties.
   * @property {date} [createdDate] Date and time when the issue was created.
   * @property {string} [state] Status of the issue. Possible values include:
   * 'proposed', 'open', 'removed', 'resolved', 'closed'
   * @property {string} [apiId] A resource identifier for the API the issue was
   * created for.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IssueContractBaseProperties
   *
   * @returns {object} metadata of IssueContractBaseProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IssueContractBaseProperties',
      type: {
        name: 'Composite',
        className: 'IssueContractBaseProperties',
        modelProperties: {
          createdDate: {
            required: false,
            serializedName: 'createdDate',
            type: {
              name: 'DateTime'
            }
          },
          state: {
            required: false,
            serializedName: 'state',
            type: {
              name: 'String'
            }
          },
          apiId: {
            required: false,
            serializedName: 'apiId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IssueContractBaseProperties;
