/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The performance counter info
 *
 */
class EventsPerformanceCounterInfo {
  /**
   * Create a EventsPerformanceCounterInfo.
   * @member {number} [value] The value of the performance counter
   * @member {string} [name] The name of the performance counter
   * @member {string} [category] The category of the performance counter
   * @member {string} [counter] The counter of the performance counter
   * @member {string} [instanceName] The instance name of the performance
   * counter
   * @member {string} [instance] The instance of the performance counter
   */
  constructor() {
  }

  /**
   * Defines the metadata of EventsPerformanceCounterInfo
   *
   * @returns {object} metadata of EventsPerformanceCounterInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'eventsPerformanceCounterInfo',
      type: {
        name: 'Composite',
        className: 'EventsPerformanceCounterInfo',
        modelProperties: {
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'Number'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          category: {
            required: false,
            serializedName: 'category',
            type: {
              name: 'String'
            }
          },
          counter: {
            required: false,
            serializedName: 'counter',
            type: {
              name: 'String'
            }
          },
          instanceName: {
            required: false,
            serializedName: 'instanceName',
            type: {
              name: 'String'
            }
          },
          instance: {
            required: false,
            serializedName: 'instance',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EventsPerformanceCounterInfo;
