/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Classic Administrators
 *
 */
class ClassicAdministrator {
  /**
   * Create a ClassicAdministrator.
   * @property {string} [id] The ID of the administrator.
   * @property {string} [name] The name of the administrator.
   * @property {string} [type] The type of the administrator.
   * @property {string} [emailAddress] The email address of the administrator.
   * @property {string} [role] The role of the administrator.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClassicAdministrator
   *
   * @returns {object} metadata of ClassicAdministrator
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClassicAdministrator',
      type: {
        name: 'Composite',
        className: 'ClassicAdministrator',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          emailAddress: {
            required: false,
            serializedName: 'properties.emailAddress',
            type: {
              name: 'String'
            }
          },
          role: {
            required: false,
            serializedName: 'properties.role',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ClassicAdministrator;
