/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The response model for the list dsc nodes operation.
 */
class DscNodeListResult extends Array {
  /**
   * Create a DscNodeListResult.
   * @member {string} [nextLink] Gets or sets the next link.
   * @member {number} [totalCount] Gets the total number of nodes matching
   * filter criteria.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DscNodeListResult
   *
   * @returns {object} metadata of DscNodeListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DscNodeListResult',
      type: {
        name: 'Composite',
        className: 'DscNodeListResult',
        modelProperties: {
          value: {
            required: false,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DscNodeElementType',
                  type: {
                    name: 'Composite',
                    className: 'DscNode'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          },
          totalCount: {
            required: false,
            serializedName: 'totalCount',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = DscNodeListResult;
