/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Customer subcription.
 *
 * @extends models['Resource']
 */
class CustomerSubscription extends models['Resource'] {
  /**
   * Create a CustomerSubscription.
   * @member {string} [tenantId] Tenant Id.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of CustomerSubscription
   *
   * @returns {object} metadata of CustomerSubscription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CustomerSubscription',
      type: {
        name: 'Composite',
        className: 'CustomerSubscription',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            isConstant: true,
            serializedName: 'location',
            defaultValue: 'global',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          tenantId: {
            required: false,
            serializedName: 'properties.tenantId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CustomerSubscription;
