/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * OS disk image.
 *
 */
class OsDiskImage {
  /**
   * Create a OsDiskImage.
   * @member {string} [operatingSystem] OS operating system type. Possible
   * values include: 'None', 'Windows', 'Linux'
   * @member {string} [sourceBlobSasUri] SAS key for source blob.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OsDiskImage
   *
   * @returns {object} metadata of OsDiskImage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OsDiskImage',
      type: {
        name: 'Composite',
        className: 'OsDiskImage',
        modelProperties: {
          operatingSystem: {
            required: false,
            readOnly: true,
            serializedName: 'operatingSystem',
            type: {
              name: 'String'
            }
          },
          sourceBlobSasUri: {
            required: false,
            readOnly: true,
            serializedName: 'sourceBlobSasUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = OsDiskImage;
