/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Registration information.
 *
 * @extends models['Resource']
 */
class Registration extends models['Resource'] {
  /**
   * Create a Registration.
   * @member {string} [objectId] The object identifier associated with the
   * Azure Stack connecting to Azure.
   * @member {string} [cloudId] The identifier of the registered Azure Stack.
   * @member {string} [billingModel] Specifies the billing mode for the Azure
   * Stack registration.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Registration
   *
   * @returns {object} metadata of Registration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Registration',
      type: {
        name: 'Composite',
        className: 'Registration',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            isConstant: true,
            serializedName: 'location',
            defaultValue: 'global',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          etag: {
            required: false,
            serializedName: 'etag',
            type: {
              name: 'String'
            }
          },
          objectId: {
            required: false,
            serializedName: 'properties.objectId',
            type: {
              name: 'String'
            }
          },
          cloudId: {
            required: false,
            serializedName: 'properties.cloudId',
            type: {
              name: 'String'
            }
          },
          billingModel: {
            required: false,
            serializedName: 'properties.billingModel',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Registration;
