/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Product information.
 *
 */
class VirtualMachineExtensionProductProperties {
  /**
   * Create a VirtualMachineExtensionProductProperties.
   * @member {string} [computeRole] Specifies kind of compute role inclided in
   * the package. Possible values include: 'None', 'IaaS', 'PaaS'
   * @member {boolean} [isSystemExtension] Specifies if product is a Virtual
   * Machine Extension.
   * @member {string} [uri] The URI.
   * @member {boolean} [supportMultipleExtensions] Indicates if specified
   * product supports multiple extensions.
   * @member {string} [version] Specifies product version.
   * @member {string} [vmOsType] Specifies operating system used by the
   * product. Possible values include: 'None', 'Windows', 'Linux'
   * @member {boolean} [vmScaleSetEnabled] Indicates if virtual machine Scale
   * Set is enabled in the specified product.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineExtensionProductProperties
   *
   * @returns {object} metadata of VirtualMachineExtensionProductProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineExtensionProductProperties',
      type: {
        name: 'Composite',
        className: 'VirtualMachineExtensionProductProperties',
        modelProperties: {
          computeRole: {
            required: false,
            readOnly: true,
            serializedName: 'computeRole',
            type: {
              name: 'String'
            }
          },
          isSystemExtension: {
            required: false,
            readOnly: true,
            serializedName: 'isSystemExtension',
            type: {
              name: 'Boolean'
            }
          },
          uri: {
            required: false,
            readOnly: true,
            serializedName: 'sourceBlob.uri',
            type: {
              name: 'String'
            }
          },
          supportMultipleExtensions: {
            required: false,
            readOnly: true,
            serializedName: 'supportMultipleExtensions',
            type: {
              name: 'Boolean'
            }
          },
          version: {
            required: false,
            readOnly: true,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          },
          vmOsType: {
            required: false,
            readOnly: true,
            serializedName: 'vmOsType',
            type: {
              name: 'String'
            }
          },
          vmScaleSetEnabled: {
            required: false,
            readOnly: true,
            serializedName: 'vmScaleSetEnabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineExtensionProductProperties;
