/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary A locality hint that can be used by the Batch service to select a
 * Compute Node on which to start a Task.
  *
 */
class AffinityInformation {
  /**
   * Create a AffinityInformation.
   * @property {string} affinityId An opaque string representing the location
   * of a Compute Node or a Task that has run previously. You can pass the
   * affinityId of a Node to indicate that this Task needs to run on that
   * Compute Node. Note that this is just a soft affinity. If the target
   * Compute Node is busy or unavailable at the time the Task is scheduled,
   * then the Task will be scheduled elsewhere.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AffinityInformation
   *
   * @returns {object} metadata of AffinityInformation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AffinityInformation',
      type: {
        name: 'Composite',
        className: 'AffinityInformation',
        modelProperties: {
          affinityId: {
            required: true,
            serializedName: 'affinityId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AffinityInformation;
