/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary The settings for an authentication token that the Task can use to
 * perform Batch service operations.
  *
 */
class AuthenticationTokenSettings {
  /**
   * Create a AuthenticationTokenSettings.
   * @property {array} [access] The Batch resources to which the token grants
   * access. The authentication token grants access to a limited set of Batch
   * service operations. Currently the only supported value for the access
   * property is 'job', which grants access to all operations related to the
   * Job which contains the Task.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AuthenticationTokenSettings
   *
   * @returns {object} metadata of AuthenticationTokenSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AuthenticationTokenSettings',
      type: {
        name: 'Composite',
        className: 'AuthenticationTokenSettings',
        modelProperties: {
          access: {
            required: false,
            serializedName: 'access',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AccessScopeElementType',
                  type: {
                    name: 'Enum',
                    allowedValues: [ 'job' ]
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AuthenticationTokenSettings;
