/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary A range of exit codes and how the Batch service should respond to
 * exit codes within that range.
  *
 */
class ExitCodeRangeMapping {
  /**
   * Create a ExitCodeRangeMapping.
   * @property {number} start The first exit code in the range.
   * @property {number} end The last exit code in the range.
   * @property {object} exitOptions How the Batch service should respond if the
   * Task exits with an exit code in the range start to end (inclusive).
   * @property {string} [exitOptions.jobAction] The default is none for exit
   * code 0 and terminate for all other exit conditions. If the Job's
   * onTaskFailed property is noaction, then specifying this property returns
   * an error and the add Task request fails with an invalid property value
   * error; if you are calling the REST API directly, the HTTP status code is
   * 400 (Bad Request). Possible values include: 'none', 'disable', 'terminate'
   * @property {string} [exitOptions.dependencyAction] Possible values are
   * 'satisfy' (allowing dependent tasks to progress) and 'block' (dependent
   * tasks continue to wait). Batch does not yet support cancellation of
   * dependent tasks. Possible values include: 'satisfy', 'block'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExitCodeRangeMapping
   *
   * @returns {object} metadata of ExitCodeRangeMapping
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExitCodeRangeMapping',
      type: {
        name: 'Composite',
        className: 'ExitCodeRangeMapping',
        modelProperties: {
          start: {
            required: true,
            serializedName: 'start',
            type: {
              name: 'Number'
            }
          },
          end: {
            required: true,
            serializedName: 'end',
            type: {
              name: 'Number'
            }
          },
          exitOptions: {
            required: true,
            serializedName: 'exitOptions',
            type: {
              name: 'Composite',
              className: 'ExitOptions'
            }
          }
        }
      }
    };
  }
}

module.exports = ExitCodeRangeMapping;
