/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Options for rebooting a Compute Node.
  *
 */
class NodeRebootParameter {
  /**
   * Create a NodeRebootParameter.
   * @property {string} [nodeRebootOption] When to reboot the Compute Node and
   * what to do with currently running Tasks. The default value is requeue.
   * Possible values include: 'requeue', 'terminate', 'taskCompletion',
   * 'retainedData'
   */
  constructor() {
  }

  /**
   * Defines the metadata of NodeRebootParameter
   *
   * @returns {object} metadata of NodeRebootParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NodeRebootParameter',
      type: {
        name: 'Composite',
        className: 'NodeRebootParameter',
        modelProperties: {
          nodeRebootOption: {
            required: false,
            serializedName: 'nodeRebootOption',
            type: {
              name: 'Enum',
              allowedValues: [ 'requeue', 'terminate', 'taskCompletion', 'retainedData' ]
            }
          }
        }
      }
    };
  }
}

module.exports = NodeRebootParameter;
