/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Usage metrics for a Pool across an aggregation interval.
  *
 */
class PoolUsageMetrics {
  /**
   * Create a PoolUsageMetrics.
   * @property {string} poolId The ID of the Pool whose metrics are aggregated
   * in this entry.
   * @property {date} startTime The start time of the aggregation interval
   * covered by this entry.
   * @property {date} endTime The end time of the aggregation interval covered
   * by this entry.
   * @property {string} vmSize The size of virtual machines in the Pool. All
   * VMs in a Pool are the same size. For information about available sizes of
   * virtual machines in Pools, see Choose a VM size for Compute Nodes in an
   * Azure Batch Pool
   * (https://docs.microsoft.com/azure/batch/batch-pool-vm-sizes).
   * @property {number} totalCoreHours The total core hours used in the Pool
   * during this aggregation interval.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PoolUsageMetrics
   *
   * @returns {object} metadata of PoolUsageMetrics
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PoolUsageMetrics',
      type: {
        name: 'Composite',
        className: 'PoolUsageMetrics',
        modelProperties: {
          poolId: {
            required: true,
            serializedName: 'poolId',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: true,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: true,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          vmSize: {
            required: true,
            serializedName: 'vmSize',
            type: {
              name: 'String'
            }
          },
          totalCoreHours: {
            required: true,
            serializedName: 'totalCoreHours',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = PoolUsageMetrics;
