/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary A range of Task IDs that a Task can depend on. All Tasks with IDs
 * in the range must complete successfully before the dependent Task can be
 * scheduled.
  *
 * The start and end of the range are inclusive. For example, if a range has
 * start 9 and end 12, then it represents Tasks '9', '10', '11' and '12'.
 *
 */
class TaskIdRange {
  /**
   * Create a TaskIdRange.
   * @property {number} start The first Task ID in the range.
   * @property {number} end The last Task ID in the range.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TaskIdRange
   *
   * @returns {object} metadata of TaskIdRange
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TaskIdRange',
      type: {
        name: 'Composite',
        className: 'TaskIdRange',
        modelProperties: {
          start: {
            required: true,
            serializedName: 'start',
            type: {
              name: 'Number'
            }
          },
          end: {
            required: true,
            serializedName: 'end',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = TaskIdRange;
