/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @summary Specifies how Tasks should be distributed across Compute Nodes.
  *
 */
class TaskSchedulingPolicy {
  /**
   * Create a TaskSchedulingPolicy.
   * @property {string} nodeFillType How Tasks are distributed across Compute
   * Nodes in a Pool. If not specified, the default is spread. Possible values
   * include: 'spread', 'pack'
   */
  constructor() {
  }

  /**
   * Defines the metadata of TaskSchedulingPolicy
   *
   * @returns {object} metadata of TaskSchedulingPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TaskSchedulingPolicy',
      type: {
        name: 'Composite',
        className: 'TaskSchedulingPolicy',
        modelProperties: {
          nodeFillType: {
            required: true,
            serializedName: 'nodeFillType',
            type: {
              name: 'Enum',
              allowedValues: [ 'spread', 'pack' ]
            }
          }
        }
      }
    };
  }
}

module.exports = TaskSchedulingPolicy;
