/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Azure Blob Storage Container mounting configuration.
 *
 */
class AzureBlobFileSystemReference {
  /**
   * Create a AzureBlobFileSystemReference.
   * @member {string} accountName Account name. Name of the Azure storage
   * account.
   * @member {string} containerName Container name. Name of the Azure Blob
   * Storage container to mount on the cluster.
   * @member {object} credentials Credentials. Information about the Azure
   * storage credentials.
   * @member {string} [credentials.accountKey] Storage account key. One of
   * accountKey or accountKeySecretReference must be specified.
   * @member {object} [credentials.accountKeySecretReference] Information about
   * KeyVault secret storing the storage account key. One of accountKey or
   * accountKeySecretReference must be specified.
   * @member {object} [credentials.accountKeySecretReference.sourceVault] Fully
   * qualified resource indentifier of the Key Vault.
   * @member {string} [credentials.accountKeySecretReference.sourceVault.id]
   * The ID of the resource
   * @member {string} [credentials.accountKeySecretReference.secretUrl] The URL
   * referencing a secret in the Key Vault.
   * @member {string} relativeMountPath Relative mount path. The relative path
   * on the compute node where the Azure File container will be mounted. Note
   * that all cluster level containers will be mounted under
   * $AZ_BATCHAI_MOUNT_ROOT location and all job level containers will be
   * mounted under $AZ_BATCHAI_JOB_MOUNT_ROOT.
   * @member {string} [mountOptions] Mount options. Mount options for mounting
   * blobfuse file system.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureBlobFileSystemReference
   *
   * @returns {object} metadata of AzureBlobFileSystemReference
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureBlobFileSystemReference',
      type: {
        name: 'Composite',
        className: 'AzureBlobFileSystemReference',
        modelProperties: {
          accountName: {
            required: true,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          },
          containerName: {
            required: true,
            serializedName: 'containerName',
            type: {
              name: 'String'
            }
          },
          credentials: {
            required: true,
            serializedName: 'credentials',
            type: {
              name: 'Composite',
              className: 'AzureStorageCredentialsInfo'
            }
          },
          relativeMountPath: {
            required: true,
            serializedName: 'relativeMountPath',
            type: {
              name: 'String'
            }
          },
          mountOptions: {
            required: false,
            serializedName: 'mountOptions',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureBlobFileSystemReference;
