/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Azure storage account credentials.
 *
 */
class AzureStorageCredentialsInfo {
  /**
   * Create a AzureStorageCredentialsInfo.
   * @member {string} [accountKey] Account key. Storage account key. One of
   * accountKey or accountKeySecretReference must be specified.
   * @member {object} [accountKeySecretReference] Account key secret reference.
   * Information about KeyVault secret storing the storage account key. One of
   * accountKey or accountKeySecretReference must be specified.
   * @member {object} [accountKeySecretReference.sourceVault] Fully qualified
   * resource indentifier of the Key Vault.
   * @member {string} [accountKeySecretReference.sourceVault.id] The ID of the
   * resource
   * @member {string} [accountKeySecretReference.secretUrl] The URL referencing
   * a secret in the Key Vault.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureStorageCredentialsInfo
   *
   * @returns {object} metadata of AzureStorageCredentialsInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureStorageCredentialsInfo',
      type: {
        name: 'Composite',
        className: 'AzureStorageCredentialsInfo',
        modelProperties: {
          accountKey: {
            required: false,
            serializedName: 'accountKey',
            type: {
              name: 'String'
            }
          },
          accountKeySecretReference: {
            required: false,
            serializedName: 'accountKeySecretReference',
            type: {
              name: 'Composite',
              className: 'KeyVaultSecretReference'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureStorageCredentialsInfo;
