/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const moment = require('moment');

/**
 * Constraints associated with the Job.
 *
 */
class JobPropertiesConstraints {
  /**
   * Create a JobPropertiesConstraints.
   * @member {moment.duration} [maxWallClockTime] Max wall clock time. Max time
   * the job can run. Default value: 1 week. Default value:
   * moment.duration('7.00:00:00') .
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobPropertiesConstraints
   *
   * @returns {object} metadata of JobPropertiesConstraints
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobProperties_constraints',
      type: {
        name: 'Composite',
        className: 'JobPropertiesConstraints',
        modelProperties: {
          maxWallClockTime: {
            required: false,
            serializedName: 'maxWallClockTime',
            defaultValue: moment.duration('7.00:00:00'),
            type: {
              name: 'TimeSpan'
            }
          }
        }
      }
    };
  }
}

module.exports = JobPropertiesConstraints;
