/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Personal Identifier Information details.
 *
 */
class PII {
  /**
   * Create a PII.
   * @property {array} [email]
   * @property {array} [sSN]
   * @property {array} [iPA]
   * @property {array} [phone]
   * @property {array} [address]
   */
  constructor() {
  }

  /**
   * Defines the metadata of PII
   *
   * @returns {object} metadata of PII
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PII',
      type: {
        name: 'Composite',
        className: 'PII',
        modelProperties: {
          email: {
            required: false,
            serializedName: 'Email',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'EmailElementType',
                  type: {
                    name: 'Composite',
                    className: 'Email'
                  }
              }
            }
          },
          sSN: {
            required: false,
            serializedName: 'SSN',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SSNElementType',
                  type: {
                    name: 'Composite',
                    className: 'SSN'
                  }
              }
            }
          },
          iPA: {
            required: false,
            serializedName: 'IPA',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'IPAElementType',
                  type: {
                    name: 'Composite',
                    className: 'IPA'
                  }
              }
            }
          },
          phone: {
            required: false,
            serializedName: 'Phone',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PhoneElementType',
                  type: {
                    name: 'Composite',
                    className: 'Phone'
                  }
              }
            }
          },
          address: {
            required: false,
            serializedName: 'Address',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AddressElementType',
                  type: {
                    name: 'Composite',
                    className: 'Address'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PII;
