/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties describing hair attributes.
 *
 */
class Hair {
  /**
   * Create a Hair.
   * @property {number} [bald] A number describing confidence level of whether
   * the person is bald.
   * @property {boolean} [invisible] A boolean value describing whether the
   * hair is visible in the image.
   * @property {array} [hairColor] An array of candidate colors and confidence
   * level in the presence of each.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Hair
   *
   * @returns {object} metadata of Hair
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Hair',
      type: {
        name: 'Composite',
        className: 'Hair',
        modelProperties: {
          bald: {
            required: false,
            nullable: false,
            serializedName: 'bald',
            type: {
              name: 'Number'
            }
          },
          invisible: {
            required: false,
            nullable: false,
            serializedName: 'invisible',
            type: {
              name: 'Boolean'
            }
          },
          hairColor: {
            required: false,
            serializedName: 'hairColor',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'HairColorElementType',
                  type: {
                    name: 'Composite',
                    className: 'HairColor'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Hair;
