/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * All possible faces that may qualify.
 *
 */
class IdentifyCandidate {
  /**
   * Create a IdentifyCandidate.
   * @property {uuid} personId Id of candidate
   * @property {number} confidence Confidence threshold of identification, used
   * to judge whether one face belong to one person. The range of
   * confidenceThreshold is [0, 1] (default specified by algorithm).
   */
  constructor() {
  }

  /**
   * Defines the metadata of IdentifyCandidate
   *
   * @returns {object} metadata of IdentifyCandidate
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IdentifyCandidate',
      type: {
        name: 'Composite',
        className: 'IdentifyCandidate',
        modelProperties: {
          personId: {
            required: true,
            serializedName: 'personId',
            type: {
              name: 'String'
            }
          },
          confidence: {
            required: true,
            serializedName: 'confidence',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = IdentifyCandidate;
