/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties describing occlusions on a given face.
 *
 */
class Occlusion {
  /**
   * Create a Occlusion.
   * @property {boolean} [foreheadOccluded] A boolean value indicating whether
   * forehead is occluded.
   * @property {boolean} [eyeOccluded] A boolean value indicating whether eyes
   * are occluded.
   * @property {boolean} [mouthOccluded] A boolean value indicating whether the
   * mouth is occluded.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Occlusion
   *
   * @returns {object} metadata of Occlusion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Occlusion',
      type: {
        name: 'Composite',
        className: 'Occlusion',
        modelProperties: {
          foreheadOccluded: {
            required: false,
            nullable: false,
            serializedName: 'foreheadOccluded',
            type: {
              name: 'Boolean'
            }
          },
          eyeOccluded: {
            required: false,
            nullable: false,
            serializedName: 'eyeOccluded',
            type: {
              name: 'Boolean'
            }
          },
          mouthOccluded: {
            required: false,
            nullable: false,
            serializedName: 'mouthOccluded',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = Occlusion;
