/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Person object.
 *
 * @extends models['NameAndUserDataContract']
 */
class Person extends models['NameAndUserDataContract'] {
  /**
   * Create a Person.
   * @property {uuid} personId PersonId of the target face list.
   * @property {array} [persistedFaceIds] PersistedFaceIds of registered faces
   * in the person. These persistedFaceIds are returned from Person - Add a
   * Person Face, and will not expire.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Person
   *
   * @returns {object} metadata of Person
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Person',
      type: {
        name: 'Composite',
        className: 'Person',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            constraints: {
              MaxLength: 128
            },
            type: {
              name: 'String'
            }
          },
          userData: {
            required: false,
            serializedName: 'userData',
            constraints: {
              MaxLength: 16384
            },
            type: {
              name: 'String'
            }
          },
          personId: {
            required: true,
            serializedName: 'personId',
            type: {
              name: 'String'
            }
          },
          persistedFaceIds: {
            required: false,
            serializedName: 'persistedFaceIds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UuidElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Person;
