/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Person group object.
 *
 * @extends models['MetaDataContract']
 */
class PersonGroup extends models['MetaDataContract'] {
  /**
   * Create a PersonGroup.
   * @property {string} personGroupId PersonGroupId of the target person group.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PersonGroup
   *
   * @returns {object} metadata of PersonGroup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PersonGroup',
      type: {
        name: 'Composite',
        className: 'PersonGroup',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            constraints: {
              MaxLength: 128
            },
            type: {
              name: 'String'
            }
          },
          userData: {
            required: false,
            serializedName: 'userData',
            constraints: {
              MaxLength: 16384
            },
            type: {
              name: 'String'
            }
          },
          recognitionModel: {
            required: false,
            nullable: false,
            serializedName: 'recognitionModel',
            defaultValue: 'recognition_01',
            type: {
              name: 'String'
            }
          },
          personGroupId: {
            required: true,
            serializedName: 'personGroupId',
            constraints: {
              MaxLength: 64,
              Pattern: /^[a-z0-9-_]+$/
            },
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PersonGroup;
