/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes an available Cognitive Services SKU.
 *
 */
class ResourceSku {
  /**
   * Create a ResourceSku.
   * @property {string} [resourceType] The type of resource the SKU applies to.
   * @property {string} [name] The name of SKU.
   * @property {string} [tier] Specifies the tier of Cognitive Services
   * account.
   * @property {string} [kind] The Kind of resources that are supported in this
   * SKU.
   * @property {array} [locations] The set of locations that the SKU is
   * available.
   * @property {array} [restrictions] The restrictions because of which SKU
   * cannot be used. This is empty if there are no restrictions.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceSku
   *
   * @returns {object} metadata of ResourceSku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceSku',
      type: {
        name: 'Composite',
        className: 'ResourceSku',
        modelProperties: {
          resourceType: {
            required: false,
            readOnly: true,
            serializedName: 'resourceType',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tier: {
            required: false,
            readOnly: true,
            serializedName: 'tier',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: false,
            readOnly: true,
            serializedName: 'kind',
            type: {
              name: 'String'
            }
          },
          locations: {
            required: false,
            readOnly: true,
            serializedName: 'locations',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          restrictions: {
            required: false,
            readOnly: true,
            serializedName: 'restrictions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ResourceSkuRestrictionsElementType',
                  type: {
                    name: 'Composite',
                    className: 'ResourceSkuRestrictions'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceSku;
