/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Post body schema for CreateKb operation.
 *
 */
class CreateKbDTO {
  /**
   * Create a CreateKbDTO.
   * @property {string} name Friendly name for the knowledgebase.
   * @property {array} [qnaList] List of Q-A (QnADTO) to be added to the
   * knowledgebase. Q-A Ids are assigned by the service and should be omitted.
   * @property {array} [urls] List of URLs to be used for extracting Q-A.
   * @property {array} [files] List of files from which to Extract Q-A.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateKbDTO
   *
   * @returns {object} metadata of CreateKbDTO
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateKbDTO',
      type: {
        name: 'Composite',
        className: 'CreateKbDTO',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            constraints: {
              MaxLength: 100,
              MinLength: 1
            },
            type: {
              name: 'String'
            }
          },
          qnaList: {
            required: false,
            serializedName: 'qnaList',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'QnADTOElementType',
                  type: {
                    name: 'Composite',
                    className: 'QnADTO'
                  }
              }
            }
          },
          urls: {
            required: false,
            serializedName: 'urls',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          files: {
            required: false,
            serializedName: 'files',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'FileDTOElementType',
                  type: {
                    name: 'Composite',
                    className: 'FileDTO'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CreateKbDTO;
