/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The error object.
 *
 * @extends models['ErrorModel']
 */
class ErrorResponseError extends models['ErrorModel'] {
  /**
   * Create a ErrorResponseError.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ErrorResponseError
   *
   * @returns {object} metadata of ErrorResponseError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ErrorResponse_error',
      type: {
        name: 'Composite',
        className: 'ErrorResponseError',
        modelProperties: {
          code: {
            required: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ErrorModelElementType',
                  type: {
                    name: 'Composite',
                    className: 'ErrorModel'
                  }
              }
            }
          },
          innerError: {
            required: false,
            serializedName: 'innerError',
            type: {
              name: 'Composite',
              className: 'InnerErrorModel'
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorResponseError;
