/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * PATCH body schema for Update operation in Update Kb
 *
 */
class UpdateKbContentsDTO {
  /**
   * Create a UpdateKbContentsDTO.
   * @property {string} [name] Friendly name for the knowledgebase.
   * @property {array} [qnaList] List of Q-A (UpdateQnaDTO) to be added to the
   * knowledgebase.
   * @property {array} [urls] List of existing URLs to be refreshed. The
   * content will be extracted again and re-indexed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateKbContentsDTO
   *
   * @returns {object} metadata of UpdateKbContentsDTO
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateKbContentsDTO',
      type: {
        name: 'Composite',
        className: 'UpdateKbContentsDTO',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          qnaList: {
            required: false,
            serializedName: 'qnaList',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UpdateQnaDTOElementType',
                  type: {
                    name: 'Composite',
                    className: 'UpdateQnaDTO'
                  }
              }
            }
          },
          urls: {
            required: false,
            serializedName: 'urls',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateKbContentsDTO;
