/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object describing identified category.
 *
 */
class Category {
  /**
   * Create a Category.
   * @property {string} [name] Name of the category.
   * @property {number} [score] Scoring of the category.
   * @property {object} [detail] Details of the identified category.
   * @property {array} [detail.celebrities] An array of celebrities if any
   * identified.
   * @property {array} [detail.landmarks] An array of landmarks if any
   * identified.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Category
   *
   * @returns {object} metadata of Category
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Category',
      type: {
        name: 'Composite',
        className: 'Category',
        modelProperties: {
          name: {
            required: false,
            nullable: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          score: {
            required: false,
            nullable: false,
            serializedName: 'score',
            type: {
              name: 'Number'
            }
          },
          detail: {
            required: false,
            serializedName: 'detail',
            type: {
              name: 'Composite',
              className: 'CategoryDetail'
            }
          }
        }
      }
    };
  }
}

module.exports = Category;
