/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object describing supported model by name and categories.
 *
 */
class ModelDescription {
  /**
   * Create a ModelDescription.
   * @property {string} [name] The name of the model.
   * @property {array} [categories] Categories of the model.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ModelDescription
   *
   * @returns {object} metadata of ModelDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ModelDescription',
      type: {
        name: 'Composite',
        className: 'ModelDescription',
        modelProperties: {
          name: {
            required: false,
            nullable: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          categories: {
            required: false,
            nullable: true,
            serializedName: 'categories',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ModelDescription;
