/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object detected inside an image.
 *
 */
class ObjectHierarchy {
  /**
   * Create a ObjectHierarchy.
   * @property {string} [object] Label for the object.
   * @property {number} [confidence] Confidence score of having observed the
   * object in the image, as a value ranging from 0 to 1.
   * @property {object} [parent] The parent object, from a taxonomy
   * perspective.
   * The parent object is a more generic form of this object.  For example, a
   * 'bulldog' would have a parent of 'dog'.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ObjectHierarchy
   *
   * @returns {object} metadata of ObjectHierarchy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ObjectHierarchy',
      type: {
        name: 'Composite',
        className: 'ObjectHierarchy',
        modelProperties: {
          object: {
            required: false,
            nullable: true,
            serializedName: 'object',
            type: {
              name: 'String'
            }
          },
          confidence: {
            required: false,
            nullable: false,
            serializedName: 'confidence',
            type: {
              name: 'Number'
            }
          },
          parent: {
            required: false,
            serializedName: 'parent',
            type: {
              name: 'Composite',
              className: 'ObjectHierarchy'
            }
          }
        }
      }
    };
  }
}

module.exports = ObjectHierarchy;
