/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A region consists of multiple lines (e.g. a column of text in a multi-column
 * document).
 *
 */
class OcrRegion {
  /**
   * Create a OcrRegion.
   * @property {string} [boundingBox] Bounding box of a recognized region. The
   * four integers represent the x-coordinate of the left edge, the
   * y-coordinate of the top edge, width, and height of the bounding box, in
   * the coordinate system of the input image, after it has been rotated around
   * its center according to the detected text angle (see textAngle property),
   * with the origin at the top-left corner, and the y-axis pointing down.
   * @property {array} [lines] An array of recognized lines of text.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OcrRegion
   *
   * @returns {object} metadata of OcrRegion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OcrRegion',
      type: {
        name: 'Composite',
        className: 'OcrRegion',
        modelProperties: {
          boundingBox: {
            required: false,
            nullable: true,
            serializedName: 'boundingBox',
            type: {
              name: 'String'
            }
          },
          lines: {
            required: false,
            nullable: true,
            serializedName: 'lines',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'OcrLineElementType',
                  type: {
                    name: 'Composite',
                    className: 'OcrLine'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = OcrRegion;
