/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The properties of the charge summary.
 *
 */
class ChargeSummaryProperties {
  /**
   * Create a ChargeSummaryProperties.
   * @member {string} [billingPeriodId] The id of the billing period resource
   * that the charge belongs to.
   * @member {string} [usageStart] Usage start date.
   * @member {string} [usageEnd] Usage end date.
   * @member {number} [azureCharges] Azure Charges.
   * @member {number} [chargesBilledSeparately] Charges Billed separately.
   * @member {number} [marketplaceCharges] Marketplace Charges.
   * @member {string} [currency] Currency Code
   */
  constructor() {
  }

  /**
   * Defines the metadata of ChargeSummaryProperties
   *
   * @returns {object} metadata of ChargeSummaryProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ChargeSummaryProperties',
      type: {
        name: 'Composite',
        className: 'ChargeSummaryProperties',
        modelProperties: {
          billingPeriodId: {
            required: false,
            readOnly: true,
            serializedName: 'billingPeriodId',
            type: {
              name: 'String'
            }
          },
          usageStart: {
            required: false,
            readOnly: true,
            serializedName: 'usageStart',
            type: {
              name: 'String'
            }
          },
          usageEnd: {
            required: false,
            readOnly: true,
            serializedName: 'usageEnd',
            type: {
              name: 'String'
            }
          },
          azureCharges: {
            required: false,
            readOnly: true,
            serializedName: 'azureCharges',
            type: {
              name: 'Number'
            }
          },
          chargesBilledSeparately: {
            required: false,
            readOnly: true,
            serializedName: 'chargesBilledSeparately',
            type: {
              name: 'Number'
            }
          },
          marketplaceCharges: {
            required: false,
            readOnly: true,
            serializedName: 'marketplaceCharges',
            type: {
              name: 'Number'
            }
          },
          currency: {
            required: false,
            readOnly: true,
            serializedName: 'currency',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ChargeSummaryProperties;
