/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * May be used to filter budgets by resource group, resource, or meter.
 *
 */
class Filters {
  /**
   * Create a Filters.
   * @member {array} [resourceGroups] The list of filters on resource groups,
   * allowed at subscription level only.
   * @member {array} [resources] The list of filters on resources.
   * @member {array} [meters] The list of filters on meters (GUID), mandatory
   * for budgets of usage category.
   * @member {object} [tags] The dictionary of filters on tags.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Filters
   *
   * @returns {object} metadata of Filters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Filters',
      type: {
        name: 'Composite',
        className: 'Filters',
        modelProperties: {
          resourceGroups: {
            required: false,
            serializedName: 'resourceGroups',
            constraints: {
              MaxItems: 10,
              MinItems: 0
            },
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          resources: {
            required: false,
            serializedName: 'resources',
            constraints: {
              MaxItems: 10,
              MinItems: 0
            },
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          meters: {
            required: false,
            serializedName: 'meters',
            constraints: {
              MaxItems: 10,
              MinItems: 0
            },
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UuidElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'ArrayElementType',
                  type: {
                    name: 'Sequence',
                    element: {
                        required: false,
                        serializedName: 'StringElementType',
                        type: {
                          name: 'String'
                        }
                    }
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Filters;
