/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * An pricesheet resource.
 *
 * @extends models['Resource']
 */
class PriceSheetResult extends models['Resource'] {
  /**
   * Create a PriceSheetResult.
   * @member {array} [pricesheets] Price sheet
   * @member {string} [nextLink] The link (url) to the next page of results.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PriceSheetResult
   *
   * @returns {object} metadata of PriceSheetResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PriceSheetResult',
      type: {
        name: 'Composite',
        className: 'PriceSheetResult',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            readOnly: true,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          pricesheets: {
            required: false,
            readOnly: true,
            serializedName: 'properties.pricesheets',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PriceSheetPropertiesElementType',
                  type: {
                    name: 'Composite',
                    className: 'PriceSheetProperties'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            readOnly: true,
            serializedName: 'properties.nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PriceSheetResult;
