/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Build step resource properties
 *
 * @extends models['ProxyResource']
 */
class BuildStep extends models['ProxyResource'] {
  /**
   * Create a BuildStep.
   * @member {object} [properties] The properties of a build step.
   * @member {string} [properties.provisioningState] The provisioning state of
   * the build step. Possible values include: 'Creating', 'Updating',
   * 'Deleting', 'Succeeded', 'Failed', 'Canceled'
   * @member {string} [properties.type] Polymorphic Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BuildStep
   *
   * @returns {object} metadata of BuildStep
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BuildStep',
      type: {
        name: 'Composite',
        className: 'BuildStep',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'type',
                clientName: 'type'
              },
              uberParent: 'BuildStepProperties',
              className: 'BuildStepProperties'
            }
          }
        }
      }
    };
  }
}

module.exports = BuildStep;
