/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties for a registry image.
 *
 */
class ImageDescriptor {
  /**
   * Create a ImageDescriptor.
   * @property {string} [registry] The registry login server.
   * @property {string} [repository] The repository name.
   * @property {string} [tag] The tag name.
   * @property {string} [digest] The sha256-based digest of the image manifest.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageDescriptor
   *
   * @returns {object} metadata of ImageDescriptor
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageDescriptor',
      type: {
        name: 'Composite',
        className: 'ImageDescriptor',
        modelProperties: {
          registry: {
            required: false,
            serializedName: 'registry',
            type: {
              name: 'String'
            }
          },
          repository: {
            required: false,
            serializedName: 'repository',
            type: {
              name: 'String'
            }
          },
          tag: {
            required: false,
            serializedName: 'tag',
            type: {
              name: 'String'
            }
          },
          digest: {
            required: false,
            serializedName: 'digest',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ImageDescriptor;
