/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The network rule set for a container registry.
 *
 */
class NetworkRuleSet {
  /**
   * Create a NetworkRuleSet.
   * @property {string} defaultAction The default action of allow or deny when
   * no other rules match. Possible values include: 'Allow', 'Deny'. Default
   * value: 'Allow' .
   * @property {array} [virtualNetworkRules] The virtual network rules.
   * @property {array} [ipRules] The IP ACL rules.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkRuleSet
   *
   * @returns {object} metadata of NetworkRuleSet
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkRuleSet',
      type: {
        name: 'Composite',
        className: 'NetworkRuleSet',
        modelProperties: {
          defaultAction: {
            required: true,
            serializedName: 'defaultAction',
            defaultValue: 'Allow',
            type: {
              name: 'String'
            }
          },
          virtualNetworkRules: {
            required: false,
            serializedName: 'virtualNetworkRules',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'VirtualNetworkRuleElementType',
                  type: {
                    name: 'Composite',
                    className: 'VirtualNetworkRule'
                  }
              }
            }
          },
          ipRules: {
            required: false,
            serializedName: 'ipRules',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'IPRuleElementType',
                  type: {
                    name: 'Composite',
                    className: 'IPRule'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkRuleSet;
