/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The properties for updating the source code repository configuration.
 *
 */
class SourceRepositoryUpdateParameters {
  /**
   * Create a SourceRepositoryUpdateParameters.
   * @member {object} [sourceControlAuthProperties] The authorization
   * properties for accessing the source code repository.
   * @member {string} [sourceControlAuthProperties.tokenType] The type of Auth
   * token. Possible values include: 'PAT', 'OAuth'
   * @member {string} [sourceControlAuthProperties.token] The access token used
   * to access the source control provider.
   * @member {string} [sourceControlAuthProperties.refreshToken] The refresh
   * token used to refresh the access token.
   * @member {string} [sourceControlAuthProperties.scope] The scope of the
   * access token.
   * @member {number} [sourceControlAuthProperties.expiresIn] Time in seconds
   * that the token remains valid
   * @member {boolean} [isCommitTriggerEnabled] The value of this property
   * indicates whether the source control commit trigger is enabled or not.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SourceRepositoryUpdateParameters
   *
   * @returns {object} metadata of SourceRepositoryUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SourceRepositoryUpdateParameters',
      type: {
        name: 'Composite',
        className: 'SourceRepositoryUpdateParameters',
        modelProperties: {
          sourceControlAuthProperties: {
            required: false,
            serializedName: 'sourceControlAuthProperties',
            type: {
              name: 'Composite',
              className: 'SourceControlAuthInfo'
            }
          },
          isCommitTriggerEnabled: {
            required: false,
            serializedName: 'isCommitTriggerEnabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = SourceRepositoryUpdateParameters;
