/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Managed cluster Access Profile.
 *
 * @extends models['Resource']
 */
class ManagedClusterAccessProfile extends models['Resource'] {
  /**
   * Create a ManagedClusterAccessProfile.
   * @property {buffer} [kubeConfig] Base64-encoded Kubernetes configuration
   * file.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ManagedClusterAccessProfile
   *
   * @returns {object} metadata of ManagedClusterAccessProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagedClusterAccessProfile',
      type: {
        name: 'Composite',
        className: 'ManagedClusterAccessProfile',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          kubeConfig: {
            required: false,
            serializedName: 'properties.kubeConfig',
            type: {
              name: 'ByteArray'
            }
          }
        }
      }
    };
  }
}

module.exports = ManagedClusterAccessProfile;
