/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a Domain.
 */
class Domain {
  /**
   * Create a Domain.
   * @property {uuid} [id]
   * @property {string} [name]
   * @property {string} [type] Possible values include: 'Classification',
   * 'ObjectDetection'
   * @property {boolean} [exportable]
   * @property {boolean} [enabled]
   */
  constructor() {
  }

  /**
   * Defines the metadata of Domain
   *
   * @returns {object} metadata of Domain
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Domain',
      type: {
        name: 'Composite',
        className: 'Domain',
        modelProperties: {
          id: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          exportable: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'exportable',
            type: {
              name: 'Boolean'
            }
          },
          enabled: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'enabled',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = Domain;
