/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Entry associating a region to an image.
 *
 */
class ImageRegionCreateEntry {
  /**
   * Create a ImageRegionCreateEntry.
   * @property {uuid} imageId Id of the image.
   * @property {uuid} tagId Id of the tag associated with this region.
   * @property {number} left Coordinate of the left boundary.
   * @property {number} top Coordinate of the top boundary.
   * @property {number} width Width.
   * @property {number} height Height.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageRegionCreateEntry
   *
   * @returns {object} metadata of ImageRegionCreateEntry
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageRegionCreateEntry',
      type: {
        name: 'Composite',
        className: 'ImageRegionCreateEntry',
        modelProperties: {
          imageId: {
            required: true,
            nullable: false,
            serializedName: 'imageId',
            type: {
              name: 'String'
            }
          },
          tagId: {
            required: true,
            nullable: false,
            serializedName: 'tagId',
            type: {
              name: 'String'
            }
          },
          left: {
            required: true,
            nullable: false,
            serializedName: 'left',
            type: {
              name: 'Number'
            }
          },
          top: {
            required: true,
            nullable: false,
            serializedName: 'top',
            type: {
              name: 'Number'
            }
          },
          width: {
            required: true,
            nullable: false,
            serializedName: 'width',
            type: {
              name: 'Number'
            }
          },
          height: {
            required: true,
            nullable: false,
            serializedName: 'height',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ImageRegionCreateEntry;
