/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ImageRegionProposal.
 */
class ImageRegionProposal {
  /**
   * Create a ImageRegionProposal.
   * @property {uuid} [projectId]
   * @property {uuid} [imageId]
   * @property {array} [proposals]
   */
  constructor() {
  }

  /**
   * Defines the metadata of ImageRegionProposal
   *
   * @returns {object} metadata of ImageRegionProposal
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ImageRegionProposal',
      type: {
        name: 'Composite',
        className: 'ImageRegionProposal',
        modelProperties: {
          projectId: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'projectId',
            type: {
              name: 'String'
            }
          },
          imageId: {
            required: false,
            nullable: false,
            readOnly: true,
            serializedName: 'imageId',
            type: {
              name: 'String'
            }
          },
          proposals: {
            required: false,
            readOnly: true,
            serializedName: 'proposals',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'RegionProposalElementType',
                  type: {
                    name: 'Composite',
                    className: 'RegionProposal'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ImageRegionProposal;
