/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents settings associated with a project.
 *
 */
class ProjectSettings {
  /**
   * Create a ProjectSettings.
   * @property {uuid} [domainId] Gets or sets the id of the Domain to use with
   * this project.
   * @property {string} [classificationType] Gets or sets the classification
   * type of the project. Possible values include: 'Multiclass', 'Multilabel'
   * @property {array} [targetExportPlatforms] A list of ExportPlatform that
   * the trained model should be able to support.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ProjectSettings
   *
   * @returns {object} metadata of ProjectSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProjectSettings',
      type: {
        name: 'Composite',
        className: 'ProjectSettings',
        modelProperties: {
          domainId: {
            required: false,
            nullable: false,
            serializedName: 'domainId',
            type: {
              name: 'String'
            }
          },
          classificationType: {
            required: false,
            nullable: true,
            serializedName: 'classificationType',
            type: {
              name: 'String'
            }
          },
          targetExportPlatforms: {
            required: false,
            serializedName: 'targetExportPlatforms',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ProjectSettings;
