/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Response of the GetServiceHealth api.
 *
 */
class ServiceHealthResponse {
  /**
   * Create a ServiceHealthResponse.
   * @member {string} [connectorType] Name of the connector.
   * @member {date} [startTime] Time when the action was triggered.
   * @member {date} [endTime] Time when the action got completed.
   * @member {boolean} [status] Status of the service.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServiceHealthResponse
   *
   * @returns {object} metadata of ServiceHealthResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceHealthResponse',
      type: {
        name: 'Composite',
        className: 'ServiceHealthResponse',
        modelProperties: {
          connectorType: {
            required: false,
            serializedName: 'connectorType',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          status: {
            required: false,
            serializedName: 'status',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceHealthResponse;
