/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Shipment pick up response.
 *
 */
class ShipmentPickUpResponse {
  /**
   * Create a ShipmentPickUpResponse.
   * @member {string} [confirmationNumber] Confirmation number for the pick up
   * request.
   * @member {date} [readyByTime] Time by which shipment should be ready for
   * pick up, this is in local time of pick up area.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ShipmentPickUpResponse
   *
   * @returns {object} metadata of ShipmentPickUpResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ShipmentPickUpResponse',
      type: {
        name: 'Composite',
        className: 'ShipmentPickUpResponse',
        modelProperties: {
          confirmationNumber: {
            required: false,
            readOnly: true,
            serializedName: 'confirmationNumber',
            type: {
              name: 'String'
            }
          },
          readyByTime: {
            required: false,
            readOnly: true,
            serializedName: 'readyByTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = ShipmentPickUpResponse;
