/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Sku.
 *
 */
class Sku {
  /**
   * Create a Sku.
   * @member {string} name The sku name. Possible values include: 'DataBox',
   * 'DataBoxDisk', 'DataBoxHeavy'
   * @member {string} [displayName] The display name of the sku.
   * @member {string} [family] The sku family.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Sku
   *
   * @returns {object} metadata of Sku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Sku',
      type: {
        name: 'Composite',
        className: 'Sku',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'Enum',
              allowedValues: [ 'DataBox', 'DataBoxDisk', 'DataBoxHeavy' ]
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          family: {
            required: false,
            serializedName: 'family',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Sku;
