/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The filters for showing the available skus.
 *
 */
class AvailableSkuRequest {
  /**
   * Create a AvailableSkuRequest.
   * @member {string} country ISO country code. Country for hardware shipment.
   * For codes check:
   * https://en.wikipedia.org/wiki/ISO_3166-1_alpha-2#Officially_assigned_code_elements
   * @member {string} location Location for data transfer. For locations check:
   * https://management.azure.com/subscriptions/SUBSCRIPTIONID/locations?api-version=2018-01-01
   * @member {array} [skuNames] Sku Names to filter for available skus
   */
  constructor() {
  }

  /**
   * Defines the metadata of AvailableSkuRequest
   *
   * @returns {object} metadata of AvailableSkuRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AvailableSkuRequest',
      type: {
        name: 'Composite',
        className: 'AvailableSkuRequest',
        modelProperties: {
          transferType: {
            required: true,
            isConstant: true,
            serializedName: 'transferType',
            defaultValue: 'ImportToAzure',
            type: {
              name: 'String'
            }
          },
          country: {
            required: true,
            serializedName: 'country',
            type: {
              name: 'String'
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          skuNames: {
            required: false,
            serializedName: 'skuNames',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SkuNameElementType',
                  type: {
                    name: 'Enum',
                    allowedValues: [ 'DataBox', 'DataBoxDisk', 'DataBoxHeavy' ]
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AvailableSkuRequest;
