/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.ShareCredentialDetails = require('./shareCredentialDetails');
exports.AccountCredentialDetails = require('./accountCredentialDetails');
exports.ShippingAddress = require('./shippingAddress');
exports.AddressValidationOutput = require('./addressValidationOutput');
exports.ApplianceNetworkConfiguration = require('./applianceNetworkConfiguration');
exports.ArmBaseObject = require('./armBaseObject');
exports.AvailableSkuRequest = require('./availableSkuRequest');
exports.Sku = require('./sku');
exports.DestinationToServiceLocationMap = require('./destinationToServiceLocationMap');
exports.SkuCapacity = require('./skuCapacity');
exports.SkuCost = require('./skuCost');
exports.SkuInformation = require('./skuInformation');
exports.CancellationReason = require('./cancellationReason');
exports.NotificationPreference = require('./notificationPreference');
exports.ContactDetails = require('./contactDetails');
exports.CopyLogDetails = require('./copyLogDetails');
exports.CopyProgress = require('./copyProgress');
exports.DataBoxAccountCopyLogDetails = require('./dataBoxAccountCopyLogDetails');
exports.DataBoxDiskCopyLogDetails = require('./dataBoxDiskCopyLogDetails');
exports.DataBoxDiskCopyProgress = require('./dataBoxDiskCopyProgress');
exports.JobDetails = require('./jobDetails');
exports.DataBoxDiskJobDetails = require('./dataBoxDiskJobDetails');
exports.DiskSecret = require('./diskSecret');
exports.JobSecrets = require('./jobSecrets');
exports.DataBoxDiskJobSecrets = require('./dataBoxDiskJobSecrets');
exports.DataBoxHeavyAccountCopyLogDetails = require('./dataBoxHeavyAccountCopyLogDetails');
exports.DataBoxHeavyJobDetails = require('./dataBoxHeavyJobDetails');
exports.DataBoxHeavySecret = require('./dataBoxHeavySecret');
exports.DataBoxHeavyJobSecrets = require('./dataBoxHeavyJobSecrets');
exports.DataBoxJobDetails = require('./dataBoxJobDetails');
exports.DataBoxSecret = require('./dataBoxSecret');
exports.DataboxJobSecrets = require('./databoxJobSecrets');
exports.DestinationAccountDetails = require('./destinationAccountDetails');
exports.ErrorModel = require('./errorModel');
exports.JobErrorDetails = require('./jobErrorDetails');
exports.JobStages = require('./jobStages');
exports.PackageShippingDetails = require('./packageShippingDetails');
exports.Preferences = require('./preferences');
exports.Resource = require('./resource');
exports.JobResource = require('./jobResource');
exports.UpdateJobDetails = require('./updateJobDetails');
exports.JobResourceUpdateParameter = require('./jobResourceUpdateParameter');
exports.OperationDisplay = require('./operationDisplay');
exports.Operation = require('./operation');
exports.ShipmentPickUpRequest = require('./shipmentPickUpRequest');
exports.ShipmentPickUpResponse = require('./shipmentPickUpResponse');
exports.UnencryptedCredentials = require('./unencryptedCredentials');
exports.ValidateAddress = require('./validateAddress');
exports.OperationList = require('./operationList');
exports.JobResourceList = require('./jobResourceList');
exports.UnencryptedCredentialsList = require('./unencryptedCredentialsList');
exports.AvailableSkusResult = require('./availableSkusResult');
exports.discriminators = {
  'CopyLogDetails' : exports.CopyLogDetails,
  'CopyLogDetails.DataBox' : exports.DataBoxAccountCopyLogDetails,
  'CopyLogDetails.DataBoxDisk' : exports.DataBoxDiskCopyLogDetails,
  'JobDetails.DataBoxDisk' : exports.DataBoxDiskJobDetails,
  'JobSecrets.DataBoxDisk' : exports.DataBoxDiskJobSecrets,
  'CopyLogDetails.DataBoxHeavy' : exports.DataBoxHeavyAccountCopyLogDetails,
  'JobDetails.DataBoxHeavy' : exports.DataBoxHeavyJobDetails,
  'JobSecrets.DataBoxHeavy' : exports.DataBoxHeavyJobSecrets,
  'JobDetails.DataBox' : exports.DataBoxJobDetails,
  'JobSecrets.DataBox' : exports.DataboxJobSecrets,
  'JobDetails' : exports.JobDetails,
  'JobSecrets' : exports.JobSecrets
};
