/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Job Error Details for providing the information and recommended action.
 *
 */
class JobErrorDetails {
  /**
   * Create a JobErrorDetails.
   * @member {string} [errorMessage] Message for the error.
   * @member {number} [errorCode] Code for the error.
   * @member {string} [recommendedAction] Recommended action for the error.
   * @member {string} [exceptionMessage] Contains the non localized exception
   * message
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobErrorDetails
   *
   * @returns {object} metadata of JobErrorDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobErrorDetails',
      type: {
        name: 'Composite',
        className: 'JobErrorDetails',
        modelProperties: {
          errorMessage: {
            required: false,
            readOnly: true,
            serializedName: 'errorMessage',
            type: {
              name: 'String'
            }
          },
          errorCode: {
            required: false,
            readOnly: true,
            serializedName: 'errorCode',
            type: {
              name: 'Number'
            }
          },
          recommendedAction: {
            required: false,
            readOnly: true,
            serializedName: 'recommendedAction',
            type: {
              name: 'String'
            }
          },
          exceptionMessage: {
            required: false,
            readOnly: true,
            serializedName: 'exceptionMessage',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JobErrorDetails;
