/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The workspace provider authorization.
 *
 */
class WorkspaceProviderAuthorization {
  /**
   * Create a WorkspaceProviderAuthorization.
   * @member {uuid} principalId The provider's principal identifier. This is
   * the identity that the provider will use to call ARM to manage the
   * workspace resources.
   * @member {uuid} roleDefinitionId The provider's role definition identifier.
   * This role will define all the permissions that the provider must have on
   * the workspace's container resource group. This role definition cannot have
   * permission to delete the resource group.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WorkspaceProviderAuthorization
   *
   * @returns {object} metadata of WorkspaceProviderAuthorization
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WorkspaceProviderAuthorization',
      type: {
        name: 'Composite',
        className: 'WorkspaceProviderAuthorization',
        modelProperties: {
          principalId: {
            required: true,
            serializedName: 'principalId',
            type: {
              name: 'String'
            }
          },
          roleDefinitionId: {
            required: true,
            serializedName: 'roleDefinitionId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WorkspaceProviderAuthorization;
