/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * DatabricksSparkJar activity.
 *
 * @extends models['ExecutionActivity']
 */
class DatabricksSparkJarActivity extends models['ExecutionActivity'] {
  /**
   * Create a DatabricksSparkJarActivity.
   * @member {object} mainClassName The full name of the class containing the
   * main method to be executed. This class must be contained in a JAR provided
   * as a library. Type: string (or Expression with resultType string).
   * @member {array} [parameters] Parameters that will be passed to the main
   * method.
   * @member {array} [libraries] A list of libraries to be installed on the
   * cluster that will execute the job.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DatabricksSparkJarActivity
   *
   * @returns {object} metadata of DatabricksSparkJarActivity
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DatabricksSparkJar',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'Activity',
        className: 'DatabricksSparkJarActivity',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          dependsOn: {
            required: false,
            serializedName: 'dependsOn',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ActivityDependencyElementType',
                  type: {
                    name: 'Composite',
                    additionalProperties: {
                      type: {
                        name: 'Dictionary',
                        value: {
                            required: false,
                            serializedName: 'ObjectElementType',
                            type: {
                              name: 'Object'
                            }
                        }
                      }
                    },
                    className: 'ActivityDependency'
                  }
              }
            }
          },
          userProperties: {
            required: false,
            serializedName: 'userProperties',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'UserPropertyElementType',
                  type: {
                    name: 'Composite',
                    className: 'UserProperty'
                  }
              }
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          linkedServiceName: {
            required: false,
            serializedName: 'linkedServiceName',
            type: {
              name: 'Composite',
              className: 'LinkedServiceReference'
            }
          },
          policy: {
            required: false,
            serializedName: 'policy',
            type: {
              name: 'Composite',
              additionalProperties: {
                type: {
                  name: 'Dictionary',
                  value: {
                      required: false,
                      serializedName: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              className: 'ActivityPolicy'
            }
          },
          mainClassName: {
            required: true,
            serializedName: 'typeProperties.mainClassName',
            type: {
              name: 'Object'
            }
          },
          parameters: {
            required: false,
            serializedName: 'typeProperties.parameters',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Object'
                  }
              }
            }
          },
          libraries: {
            required: false,
            serializedName: 'typeProperties.libraries',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ObjectElementType',
                  type: {
                    name: 'Dictionary',
                    value: {
                        required: false,
                        serializedName: 'ObjectElementType',
                        type: {
                          name: 'Object'
                        }
                    }
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DatabricksSparkJarActivity;
