/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The linked integration runtime information.
 *
 */
class LinkedIntegrationRuntime {
  /**
   * Create a LinkedIntegrationRuntime.
   * @member {string} [name] The name of the linked integration runtime.
   * @member {string} [subscriptionId] The subscription ID for which the linked
   * integration runtime belong to.
   * @member {string} [dataFactoryName] The name of the data factory for which
   * the linked integration runtime belong to.
   * @member {string} [dataFactoryLocation] The location of the data factory
   * for which the linked integration runtime belong to.
   * @member {date} [createTime] The creating time of the linked integration
   * runtime.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LinkedIntegrationRuntime
   *
   * @returns {object} metadata of LinkedIntegrationRuntime
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LinkedIntegrationRuntime',
      type: {
        name: 'Composite',
        className: 'LinkedIntegrationRuntime',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          subscriptionId: {
            required: false,
            readOnly: true,
            serializedName: 'subscriptionId',
            type: {
              name: 'String'
            }
          },
          dataFactoryName: {
            required: false,
            readOnly: true,
            serializedName: 'dataFactoryName',
            type: {
              name: 'String'
            }
          },
          dataFactoryLocation: {
            required: false,
            readOnly: true,
            serializedName: 'dataFactoryLocation',
            type: {
              name: 'String'
            }
          },
          createTime: {
            required: false,
            readOnly: true,
            serializedName: 'createTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = LinkedIntegrationRuntime;
