/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The role based access control (RBAC) authorization type integration runtime.
 *
 * @extends models['LinkedIntegrationRuntimeType']
 */
class LinkedIntegrationRuntimeRbacAuthorization extends models['LinkedIntegrationRuntimeType'] {
  /**
   * Create a LinkedIntegrationRuntimeRbacAuthorization.
   * @member {string} resourceId The resource identifier of the integration
   * runtime to be shared.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LinkedIntegrationRuntimeRbacAuthorization
   *
   * @returns {object} metadata of LinkedIntegrationRuntimeRbacAuthorization
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RBAC',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'authorizationType',
          clientName: 'authorizationType'
        },
        uberParent: 'LinkedIntegrationRuntimeType',
        className: 'LinkedIntegrationRuntimeRbacAuthorization',
        modelProperties: {
          authorizationType: {
            required: true,
            serializedName: 'authorizationType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: true,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LinkedIntegrationRuntimeRbacAuthorization;
