/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * SSIS property override.
 *
 */
class SSISPropertyOverride {
  /**
   * Create a SSISPropertyOverride.
   * @member {object} value SSIS package property override value. Type: string
   * (or Expression with resultType string).
   * @member {boolean} [isSensitive] Whether SSIS package property override
   * value is sensitive data. Value will be encrypted in SSISDB if it is true
   */
  constructor() {
  }

  /**
   * Defines the metadata of SSISPropertyOverride
   *
   * @returns {object} metadata of SSISPropertyOverride
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SSISPropertyOverride',
      type: {
        name: 'Composite',
        className: 'SSISPropertyOverride',
        modelProperties: {
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'Object'
            }
          },
          isSensitive: {
            required: false,
            serializedName: 'isSensitive',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = SSISPropertyOverride;
