/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Azure Data Factory secure string definition. The string value will be masked
 * with asterisks '*' during Get or List API calls.
 *
 * @extends models['SecretBase']
 */
class SecureString extends models['SecretBase'] {
  /**
   * Create a SecureString.
   * @member {string} value Value of secure string.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SecureString
   *
   * @returns {object} metadata of SecureString
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SecureString',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'SecretBase',
        className: 'SecureString',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SecureString;
