/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Update integration runtime node request.
 *
 */
class UpdateIntegrationRuntimeNodeRequest {
  /**
   * Create a UpdateIntegrationRuntimeNodeRequest.
   * @member {number} [concurrentJobsLimit] The number of concurrent jobs
   * permitted to run on the integration runtime node. Values between 1 and
   * maxConcurrentJobs(inclusive) are allowed.
   */
  constructor() {
  }

  /**
   * Defines the metadata of UpdateIntegrationRuntimeNodeRequest
   *
   * @returns {object} metadata of UpdateIntegrationRuntimeNodeRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UpdateIntegrationRuntimeNodeRequest',
      type: {
        name: 'Composite',
        className: 'UpdateIntegrationRuntimeNodeRequest',
        modelProperties: {
          concurrentJobsLimit: {
            required: false,
            serializedName: 'concurrentJobsLimit',
            constraints: {
              InclusiveMinimum: 1
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = UpdateIntegrationRuntimeNodeRequest;
