/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines the properties to access the artifacts using an Azure Storage SAS
 * URI.
 *
 * @extends models['Authentication']
 */
class SasAuthentication extends models['Authentication'] {
  /**
   * Create a SasAuthentication.
   * @member {string} sasUri The SAS URI to the Azure Storage blob container.
   * Any offset from the root of the container to where the artifacts are
   * located can be defined in the artifactRoot.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SasAuthentication
   *
   * @returns {object} metadata of SasAuthentication
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Sas',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'type',
          clientName: 'type'
        },
        uberParent: 'Authentication',
        className: 'SasAuthentication',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          sasUri: {
            required: true,
            serializedName: 'properties.sasUri',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SasAuthentication;
