/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a service.
 *
 * @extends models['ServiceProperties']
 */
class Service extends models['ServiceProperties'] {
  /**
   * Create a Service.
   * @member {string} [name] Name of the service.
   * @member {array} [serviceUnits] The detailed information about the units
   * that make up the service.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Service
   *
   * @returns {object} metadata of Service
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Service',
      type: {
        name: 'Composite',
        className: 'Service',
        modelProperties: {
          targetLocation: {
            required: true,
            serializedName: 'targetLocation',
            type: {
              name: 'String'
            }
          },
          targetSubscriptionId: {
            required: true,
            serializedName: 'targetSubscriptionId',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          serviceUnits: {
            required: false,
            serializedName: 'serviceUnits',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ServiceUnitElementType',
                  type: {
                    name: 'Composite',
                    className: 'ServiceUnit'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = Service;
