/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties for creating a custom image from a VHD.
 *
 */
class CustomImagePropertiesCustomFragment {
  /**
   * Create a CustomImagePropertiesCustomFragment.
   * @property {string} [imageName] The image name.
   * @property {boolean} [sysPrep] Indicates whether sysprep has been run on
   * the VHD.
   * @property {string} [osType] The OS type of the custom image (i.e. Windows,
   * Linux). Possible values include: 'Windows', 'Linux', 'None'
   */
  constructor() {
  }

  /**
   * Defines the metadata of CustomImagePropertiesCustomFragment
   *
   * @returns {object} metadata of CustomImagePropertiesCustomFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CustomImagePropertiesCustomFragment',
      type: {
        name: 'Composite',
        className: 'CustomImagePropertiesCustomFragment',
        modelProperties: {
          imageName: {
            required: false,
            serializedName: 'imageName',
            type: {
              name: 'String'
            }
          },
          sysPrep: {
            required: false,
            serializedName: 'sysPrep',
            type: {
              name: 'Boolean'
            }
          },
          osType: {
            required: false,
            serializedName: 'osType',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = CustomImagePropertiesCustomFragment;
