/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Description of name availability.
 *
 */
class NameAvailabilityInfo {
  /**
   * Create a NameAvailabilityInfo.
   * @member {boolean} [nameAvailable] specifies if a name is available or not
   * @member {string} [reason] specifies the reason a name is unavailable.
   * Possible values include: 'Invalid', 'AlreadyExists'
   * @member {string} [message] message containing a etailed reason name is
   * unavailable
   */
  constructor() {
  }

  /**
   * Defines the metadata of NameAvailabilityInfo
   *
   * @returns {object} metadata of NameAvailabilityInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NameAvailabilityInfo',
      type: {
        name: 'Composite',
        className: 'NameAvailabilityInfo',
        modelProperties: {
          nameAvailable: {
            required: false,
            serializedName: 'nameAvailable',
            type: {
              name: 'Boolean'
            }
          },
          reason: {
            required: false,
            serializedName: 'reason',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NameAvailabilityInfo;
