/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Domain Security Settings
 *
 */
class DomainSecuritySettings {
  /**
   * Create a DomainSecuritySettings.
   * @member {string} [ntlmV1] A flag to determine whether or not NtlmV1 is
   * enabled or disabled. Possible values include: 'Enabled', 'Disabled'
   * @member {string} [tlsV1] A flag to determine whether or not TlsV1 is
   * enabled or disabled. Possible values include: 'Enabled', 'Disabled'
   * @member {string} [syncNtlmPasswords] A flag to determine whether or not
   * SyncNtlmPasswords is enabled or disabled. Possible values include:
   * 'Enabled', 'Disabled'
   */
  constructor() {
  }

  /**
   * Defines the metadata of DomainSecuritySettings
   *
   * @returns {object} metadata of DomainSecuritySettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DomainSecuritySettings',
      type: {
        name: 'Composite',
        className: 'DomainSecuritySettings',
        modelProperties: {
          ntlmV1: {
            required: false,
            serializedName: 'ntlmV1',
            type: {
              name: 'String'
            }
          },
          tlsV1: {
            required: false,
            serializedName: 'tlsV1',
            type: {
              name: 'String'
            }
          },
          syncNtlmPasswords: {
            required: false,
            serializedName: 'syncNtlmPasswords',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DomainSecuritySettings;
