/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Settings for notification
 *
 */
class NotificationSettings {
  /**
   * Create a NotificationSettings.
   * @member {string} [notifyGlobalAdmins] Should global admins be notified.
   * Possible values include: 'Enabled', 'Disabled'
   * @member {string} [notifyDcAdmins] Should domain controller admins be
   * notified. Possible values include: 'Enabled', 'Disabled'
   * @member {array} [additionalRecipients] The list of additional recipients
   */
  constructor() {
  }

  /**
   * Defines the metadata of NotificationSettings
   *
   * @returns {object} metadata of NotificationSettings
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NotificationSettings',
      type: {
        name: 'Composite',
        className: 'NotificationSettings',
        modelProperties: {
          notifyGlobalAdmins: {
            required: false,
            serializedName: 'notifyGlobalAdmins',
            type: {
              name: 'String'
            }
          },
          notifyDcAdmins: {
            required: false,
            serializedName: 'notifyDcAdmins',
            type: {
              name: 'String'
            }
          },
          additionalRecipients: {
            required: false,
            serializedName: 'additionalRecipients',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = NotificationSettings;
