/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The content of the event request message.
 *
 */
class ContainerRegistryArtifactEventData {
  /**
   * Create a ContainerRegistryArtifactEventData.
   * @member {string} [id] The event ID.
   * @member {date} [timestamp] The time at which the event occurred.
   * @member {string} [action] The action that encompasses the provided event.
   * @member {object} [target] The target of the event.
   * @member {string} [target.mediaType] The MIME type of the artifact.
   * @member {number} [target.size] The size in bytes of the artifact.
   * @member {string} [target.digest] The digest of the artifact.
   * @member {string} [target.repository] The repository name of the artifact.
   * @member {string} [target.tag] The tag of the artifact.
   * @member {string} [target.name] The name of the artifact.
   * @member {string} [target.version] The version of the artifact.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerRegistryArtifactEventData
   *
   * @returns {object} metadata of ContainerRegistryArtifactEventData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerRegistryArtifactEventData',
      type: {
        name: 'Composite',
        className: 'ContainerRegistryArtifactEventData',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          timestamp: {
            required: false,
            serializedName: 'timestamp',
            type: {
              name: 'DateTime'
            }
          },
          action: {
            required: false,
            serializedName: 'action',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            serializedName: 'target',
            type: {
              name: 'Composite',
              className: 'ContainerRegistryArtifactEventTarget'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerRegistryArtifactEventData;
