/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The target of the event.
 *
 */
class ContainerRegistryArtifactEventTarget {
  /**
   * Create a ContainerRegistryArtifactEventTarget.
   * @member {string} [mediaType] The MIME type of the artifact.
   * @member {number} [size] The size in bytes of the artifact.
   * @member {string} [digest] The digest of the artifact.
   * @member {string} [repository] The repository name of the artifact.
   * @member {string} [tag] The tag of the artifact.
   * @member {string} [name] The name of the artifact.
   * @member {string} [version] The version of the artifact.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerRegistryArtifactEventTarget
   *
   * @returns {object} metadata of ContainerRegistryArtifactEventTarget
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerRegistryArtifactEventTarget',
      type: {
        name: 'Composite',
        className: 'ContainerRegistryArtifactEventTarget',
        modelProperties: {
          mediaType: {
            required: false,
            serializedName: 'mediaType',
            type: {
              name: 'String'
            }
          },
          size: {
            required: false,
            serializedName: 'size',
            type: {
              name: 'Number'
            }
          },
          digest: {
            required: false,
            serializedName: 'digest',
            type: {
              name: 'String'
            }
          },
          repository: {
            required: false,
            serializedName: 'repository',
            type: {
              name: 'String'
            }
          },
          tag: {
            required: false,
            serializedName: 'tag',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          version: {
            required: false,
            serializedName: 'version',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerRegistryArtifactEventTarget;
