/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.StorageBlobCreatedEventData = require('./storageBlobCreatedEventData');
exports.StorageBlobDeletedEventData = require('./storageBlobDeletedEventData');
exports.EventHubCaptureFileCreatedEventData = require('./eventHubCaptureFileCreatedEventData');
exports.ResourceWriteSuccessData = require('./resourceWriteSuccessData');
exports.ResourceWriteFailureData = require('./resourceWriteFailureData');
exports.ResourceWriteCancelData = require('./resourceWriteCancelData');
exports.ResourceDeleteSuccessData = require('./resourceDeleteSuccessData');
exports.ResourceDeleteFailureData = require('./resourceDeleteFailureData');
exports.ResourceDeleteCancelData = require('./resourceDeleteCancelData');
exports.ResourceActionSuccessData = require('./resourceActionSuccessData');
exports.ResourceActionFailureData = require('./resourceActionFailureData');
exports.ResourceActionCancelData = require('./resourceActionCancelData');
exports.EventGridEvent = require('./eventGridEvent');
exports.SubscriptionValidationEventData = require('./subscriptionValidationEventData');
exports.SubscriptionValidationResponse = require('./subscriptionValidationResponse');
exports.SubscriptionDeletedEventData = require('./subscriptionDeletedEventData');
exports.DeviceLifeCycleEventProperties = require('./deviceLifeCycleEventProperties');
exports.IotHubDeviceCreatedEventData = require('./iotHubDeviceCreatedEventData');
exports.IotHubDeviceDeletedEventData = require('./iotHubDeviceDeletedEventData');
exports.DeviceConnectionStateEventProperties = require('./deviceConnectionStateEventProperties');
exports.IotHubDeviceConnectedEventData = require('./iotHubDeviceConnectedEventData');
exports.IotHubDeviceDisconnectedEventData = require('./iotHubDeviceDisconnectedEventData');
exports.DeviceTelemetryEventProperties = require('./deviceTelemetryEventProperties');
exports.IotHubDeviceTelemetryEventData = require('./iotHubDeviceTelemetryEventData');
exports.DeviceTwinMetadata = require('./deviceTwinMetadata');
exports.DeviceTwinProperties = require('./deviceTwinProperties');
exports.DeviceTwinInfoProperties = require('./deviceTwinInfoProperties');
exports.DeviceTwinInfoX509Thumbprint = require('./deviceTwinInfoX509Thumbprint');
exports.DeviceTwinInfo = require('./deviceTwinInfo');
exports.DeviceConnectionStateEventInfo = require('./deviceConnectionStateEventInfo');
exports.ContainerRegistryEventData = require('./containerRegistryEventData');
exports.ContainerRegistryImagePushedEventData = require('./containerRegistryImagePushedEventData');
exports.ContainerRegistryImageDeletedEventData = require('./containerRegistryImageDeletedEventData');
exports.ContainerRegistryArtifactEventData = require('./containerRegistryArtifactEventData');
exports.ContainerRegistryChartPushedEventData = require('./containerRegistryChartPushedEventData');
exports.ContainerRegistryChartDeletedEventData = require('./containerRegistryChartDeletedEventData');
exports.ContainerRegistryEventTarget = require('./containerRegistryEventTarget');
exports.ContainerRegistryEventRequest = require('./containerRegistryEventRequest');
exports.ContainerRegistryEventActor = require('./containerRegistryEventActor');
exports.ContainerRegistryEventSource = require('./containerRegistryEventSource');
exports.ContainerRegistryArtifactEventTarget = require('./containerRegistryArtifactEventTarget');
exports.ServiceBusActiveMessagesAvailableWithNoListenersEventData = require('./serviceBusActiveMessagesAvailableWithNoListenersEventData');
exports.ServiceBusDeadletterMessagesAvailableWithNoListenersEventData = require('./serviceBusDeadletterMessagesAvailableWithNoListenersEventData');
exports.MediaJobStateChangeEventData = require('./mediaJobStateChangeEventData');
exports.MediaJobErrorDetail = require('./mediaJobErrorDetail');
exports.MediaJobError = require('./mediaJobError');
exports.MediaJobOutput = require('./mediaJobOutput');
exports.MediaJobOutputAsset = require('./mediaJobOutputAsset');
exports.MediaJobOutputProgressEventData = require('./mediaJobOutputProgressEventData');
exports.MediaJobOutputStateChangeEventData = require('./mediaJobOutputStateChangeEventData');
exports.MediaJobScheduledEventData = require('./mediaJobScheduledEventData');
exports.MediaJobProcessingEventData = require('./mediaJobProcessingEventData');
exports.MediaJobCancelingEventData = require('./mediaJobCancelingEventData');
exports.MediaJobFinishedEventData = require('./mediaJobFinishedEventData');
exports.MediaJobCanceledEventData = require('./mediaJobCanceledEventData');
exports.MediaJobErroredEventData = require('./mediaJobErroredEventData');
exports.MediaJobOutputCanceledEventData = require('./mediaJobOutputCanceledEventData');
exports.MediaJobOutputCancelingEventData = require('./mediaJobOutputCancelingEventData');
exports.MediaJobOutputErroredEventData = require('./mediaJobOutputErroredEventData');
exports.MediaJobOutputFinishedEventData = require('./mediaJobOutputFinishedEventData');
exports.MediaJobOutputProcessingEventData = require('./mediaJobOutputProcessingEventData');
exports.MediaJobOutputScheduledEventData = require('./mediaJobOutputScheduledEventData');
exports.MediaLiveEventEncoderConnectedEventData = require('./mediaLiveEventEncoderConnectedEventData');
exports.MediaLiveEventConnectionRejectedEventData = require('./mediaLiveEventConnectionRejectedEventData');
exports.MediaLiveEventEncoderDisconnectedEventData = require('./mediaLiveEventEncoderDisconnectedEventData');
exports.MediaLiveEventIncomingStreamReceivedEventData = require('./mediaLiveEventIncomingStreamReceivedEventData');
exports.MediaLiveEventIncomingStreamsOutOfSyncEventData = require('./mediaLiveEventIncomingStreamsOutOfSyncEventData');
exports.MediaLiveEventIncomingVideoStreamsOutOfSyncEventData = require('./mediaLiveEventIncomingVideoStreamsOutOfSyncEventData');
exports.MediaLiveEventIncomingDataChunkDroppedEventData = require('./mediaLiveEventIncomingDataChunkDroppedEventData');
exports.MediaLiveEventIngestHeartbeatEventData = require('./mediaLiveEventIngestHeartbeatEventData');
exports.MediaLiveEventTrackDiscontinuityDetectedEventData = require('./mediaLiveEventTrackDiscontinuityDetectedEventData');
exports.MapsGeofenceEventProperties = require('./mapsGeofenceEventProperties');
exports.MapsGeofenceEnteredEventData = require('./mapsGeofenceEnteredEventData');
exports.MapsGeofenceExitedEventData = require('./mapsGeofenceExitedEventData');
exports.MapsGeofenceResultEventData = require('./mapsGeofenceResultEventData');
exports.MapsGeofenceGeometry = require('./mapsGeofenceGeometry');
exports.AppConfigurationKeyValueModifiedEventData = require('./appConfigurationKeyValueModifiedEventData');
exports.AppConfigurationKeyValueDeletedEventData = require('./appConfigurationKeyValueDeletedEventData');
exports.discriminators = {
  'MediaJobOutput' : exports.MediaJobOutput,
  'MediaJobOutput.#Microsoft.Media.JobOutputAsset' : exports.MediaJobOutputAsset
};
