/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Event data for Microsoft.Devices.DeviceConnected event.
 *
 * @extends models['DeviceConnectionStateEventProperties']
 */
class IotHubDeviceConnectedEventData extends models['DeviceConnectionStateEventProperties'] {
  /**
   * Create a IotHubDeviceConnectedEventData.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of IotHubDeviceConnectedEventData
   *
   * @returns {object} metadata of IotHubDeviceConnectedEventData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IotHubDeviceConnectedEventData',
      type: {
        name: 'Composite',
        className: 'IotHubDeviceConnectedEventData',
        modelProperties: {
          deviceId: {
            required: false,
            serializedName: 'deviceId',
            type: {
              name: 'String'
            }
          },
          moduleId: {
            required: false,
            serializedName: 'moduleId',
            type: {
              name: 'String'
            }
          },
          hubName: {
            required: false,
            serializedName: 'hubName',
            type: {
              name: 'String'
            }
          },
          deviceConnectionStateEventInfo: {
            required: false,
            serializedName: 'deviceConnectionStateEventInfo',
            type: {
              name: 'Composite',
              className: 'DeviceConnectionStateEventInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = IotHubDeviceConnectedEventData;
