/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Schema of the Data property of an EventGridEvent for a
 * Microsoft.Maps.GeofenceEntered event.
 *
 * @extends models['MapsGeofenceEventProperties']
 */
class MapsGeofenceEnteredEventData extends models['MapsGeofenceEventProperties'] {
  /**
   * Create a MapsGeofenceEnteredEventData.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of MapsGeofenceEnteredEventData
   *
   * @returns {object} metadata of MapsGeofenceEnteredEventData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MapsGeofenceEnteredEventData',
      type: {
        name: 'Composite',
        className: 'MapsGeofenceEnteredEventData',
        modelProperties: {
          expiredGeofenceGeometryId: {
            required: false,
            serializedName: 'expiredGeofenceGeometryId',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          geometries: {
            required: false,
            serializedName: 'geometries',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'MapsGeofenceGeometryElementType',
                  type: {
                    name: 'Composite',
                    className: 'MapsGeofenceGeometry'
                  }
              }
            }
          },
          invalidPeriodGeofenceGeometryId: {
            required: false,
            serializedName: 'invalidPeriodGeofenceGeometryId',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          isEventPublished: {
            required: false,
            serializedName: 'isEventPublished',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = MapsGeofenceEnteredEventData;
