/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Encoder connect event data.
 *
 */
class MediaLiveEventEncoderConnectedEventData {
  /**
   * Create a MediaLiveEventEncoderConnectedEventData.
   * @member {string} [ingestUrl] Gets the ingest URL provided by the live
   * event.
   * @member {string} [streamId] Gets the stream Id.
   * @member {string} [encoderIp] Gets the remote IP.
   * @member {string} [encoderPort] Gets the remote port.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MediaLiveEventEncoderConnectedEventData
   *
   * @returns {object} metadata of MediaLiveEventEncoderConnectedEventData
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MediaLiveEventEncoderConnectedEventData',
      type: {
        name: 'Composite',
        className: 'MediaLiveEventEncoderConnectedEventData',
        modelProperties: {
          ingestUrl: {
            required: false,
            readOnly: true,
            serializedName: 'ingestUrl',
            type: {
              name: 'String'
            }
          },
          streamId: {
            required: false,
            readOnly: true,
            serializedName: 'streamId',
            type: {
              name: 'String'
            }
          },
          encoderIp: {
            required: false,
            readOnly: true,
            serializedName: 'encoderIp',
            type: {
              name: 'String'
            }
          },
          encoderPort: {
            required: false,
            readOnly: true,
            serializedName: 'encoderPort',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MediaLiveEventEncoderConnectedEventData;
