/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * To complete an event subscription validation handshake, a subscriber can use
 * either the validationCode or the validationUrl received in a
 * SubscriptionValidationEvent. When the validationCode is used, the
 * SubscriptionValidationResponse can be used to build the response.
 *
 */
class SubscriptionValidationResponse {
  /**
   * Create a SubscriptionValidationResponse.
   * @member {string} [validationResponse] The validation response sent by the
   * subscriber to Azure Event Grid to complete the validation of an event
   * subscription.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SubscriptionValidationResponse
   *
   * @returns {object} metadata of SubscriptionValidationResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SubscriptionValidationResponse',
      type: {
        name: 'Composite',
        className: 'SubscriptionValidationResponse',
        modelProperties: {
          validationResponse: {
            required: false,
            serializedName: 'validationResponse',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SubscriptionValidationResponse;
