/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about the dead letter destination for an event subscription. To
 * configure a deadletter destination, do not directly instantiate an object of
 * this class. Instead, instantiate an object of a derived class. Currently,
 * StorageBlobDeadLetterDestination is the only class that derives from this
 * class.
 *
 */
class DeadLetterDestination {
  /**
   * Create a DeadLetterDestination.
   * @property {string} endpointType Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of DeadLetterDestination
   *
   * @returns {object} metadata of DeadLetterDestination
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DeadLetterDestination',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'endpointType',
          clientName: 'endpointType'
        },
        uberParent: 'DeadLetterDestination',
        className: 'DeadLetterDestination',
        modelProperties: {
          endpointType: {
            required: true,
            serializedName: 'endpointType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DeadLetterDestination;
