/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Information about the storage blob based dead letter destination.
 *
 * @extends models['DeadLetterDestination']
 */
class StorageBlobDeadLetterDestination extends models['DeadLetterDestination'] {
  /**
   * Create a StorageBlobDeadLetterDestination.
   * @property {string} [resourceId] The Azure Resource ID of the storage
   * account that is the destination of the deadletter events
   * @property {string} [blobContainerName] The name of the Storage blob
   * container that is the destination of the deadletter events
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StorageBlobDeadLetterDestination
   *
   * @returns {object} metadata of StorageBlobDeadLetterDestination
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageBlob',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'endpointType',
          clientName: 'endpointType'
        },
        uberParent: 'DeadLetterDestination',
        className: 'StorageBlobDeadLetterDestination',
        modelProperties: {
          endpointType: {
            required: true,
            serializedName: 'endpointType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: false,
            serializedName: 'properties.resourceId',
            type: {
              name: 'String'
            }
          },
          blobContainerName: {
            required: false,
            serializedName: 'properties.blobContainerName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageBlobDeadLetterDestination;
