/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Result of the request to list load balancing settings. It contains a list of
 * load balancing settings objects and a URL link to get the the next set of
 * results.
 */
class LoadBalancingSettingsListResult extends Array {
  /**
   * Create a LoadBalancingSettingsListResult.
   * @member {string} [nextLink] URL to get the next set of
   * LoadBalancingSettings objects if there are any.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LoadBalancingSettingsListResult
   *
   * @returns {object} metadata of LoadBalancingSettingsListResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LoadBalancingSettingsListResult',
      type: {
        name: 'Composite',
        className: 'LoadBalancingSettingsListResult',
        modelProperties: {
          value: {
            required: false,
            readOnly: true,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'LoadBalancingSettingsModelElementType',
                  type: {
                    name: 'Composite',
                    className: 'LoadBalancingSettingsModel'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LoadBalancingSettingsListResult;
