/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Load balancing settings for a backend pool
 *
 * @extends models['SubResource']
 */
class LoadBalancingSettingsModel extends models['SubResource'] {
  /**
   * Create a LoadBalancingSettingsModel.
   * @member {number} [sampleSize] The number of samples to consider for load
   * balancing decisions
   * @member {number} [successfulSamplesRequired] The number of samples within
   * the sample period that must succeed
   * @member {number} [additionalLatencyMilliseconds] The additional latency in
   * milliseconds for probes to fall into the lowest latency bucket
   * @member {string} [resourceState] Resource status. Possible values include:
   * 'Creating', 'Enabling', 'Enabled', 'Disabling', 'Disabled', 'Deleting'
   * @member {string} [name] Resource name.
   * @member {string} [type] Resource type.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LoadBalancingSettingsModel
   *
   * @returns {object} metadata of LoadBalancingSettingsModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LoadBalancingSettingsModel',
      type: {
        name: 'Composite',
        className: 'LoadBalancingSettingsModel',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          sampleSize: {
            required: false,
            serializedName: 'properties.sampleSize',
            type: {
              name: 'Number'
            }
          },
          successfulSamplesRequired: {
            required: false,
            serializedName: 'properties.successfulSamplesRequired',
            type: {
              name: 'Number'
            }
          },
          additionalLatencyMilliseconds: {
            required: false,
            serializedName: 'properties.additionalLatencyMilliseconds',
            type: {
              name: 'Number'
            }
          },
          resourceState: {
            required: false,
            serializedName: 'properties.resourceState',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LoadBalancingSettingsModel;
