/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Active Directory group information.
 *
 * @extends models['DirectoryObject']
 */
class ADGroup extends models['DirectoryObject'] {
  /**
   * Create a ADGroup.
   * @member {string} [displayName] The display name of the group.
   * @member {boolean} [mailEnabled] Whether the group is mail-enabled. Must be
   * false. This is because only pure security groups can be created using the
   * Graph API.
   * @member {string} [mailNickname] The mail alias for the group.
   * @member {boolean} [securityEnabled] Whether the group is security-enable.
   * @member {string} [mail] The primary email address of the group.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ADGroup
   *
   * @returns {object} metadata of ADGroup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Group',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'objectType',
          clientName: 'objectType'
        },
        uberParent: 'DirectoryObject',
        className: 'ADGroup',
        modelProperties: {
          objectId: {
            required: false,
            readOnly: true,
            serializedName: 'objectId',
            type: {
              name: 'String'
            }
          },
          deletionTimestamp: {
            required: false,
            readOnly: true,
            serializedName: 'deletionTimestamp',
            type: {
              name: 'DateTime'
            }
          },
          objectType: {
            required: true,
            serializedName: 'objectType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          displayName: {
            required: false,
            serializedName: 'displayName',
            type: {
              name: 'String'
            }
          },
          mailEnabled: {
            required: false,
            serializedName: 'mailEnabled',
            type: {
              name: 'Boolean'
            }
          },
          mailNickname: {
            required: false,
            serializedName: 'mailNickname',
            type: {
              name: 'String'
            }
          },
          securityEnabled: {
            required: false,
            serializedName: 'securityEnabled',
            type: {
              name: 'Boolean'
            }
          },
          mail: {
            required: false,
            serializedName: 'mail',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ADGroup;
