/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies the disk information fo the HANA instance
 *
 */
class Disk {
  /**
   * Create a Disk.
   * @property {string} [name] The disk name.
   * @property {number} [diskSizeGB] Specifies the size of an empty data disk
   * in gigabytes.
   * @property {number} [lun] Specifies the logical unit number of the data
   * disk. This value is used to identify data disks within the VM and
   * therefore must be unique for each data disk attached to a VM.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Disk
   *
   * @returns {object} metadata of Disk
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Disk',
      type: {
        name: 'Composite',
        className: 'Disk',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          diskSizeGB: {
            required: false,
            serializedName: 'diskSizeGB',
            type: {
              name: 'Number'
            }
          },
          lun: {
            required: false,
            readOnly: true,
            serializedName: 'lun',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = Disk;
