/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies the network settings for the HANA instance disks.
 *
 */
class NetworkProfile {
  /**
   * Create a NetworkProfile.
   * @property {array} [networkInterfaces] Specifies the network interfaces for
   * the HANA instance.
   * @property {string} [circuitId] Specifies the circuit id for connecting to
   * express route.
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkProfile
   *
   * @returns {object} metadata of NetworkProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkProfile',
      type: {
        name: 'Composite',
        className: 'NetworkProfile',
        modelProperties: {
          networkInterfaces: {
            required: false,
            serializedName: 'networkInterfaces',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'IpAddressElementType',
                  type: {
                    name: 'Composite',
                    className: 'IpAddress'
                  }
              }
            }
          },
          circuitId: {
            required: false,
            readOnly: true,
            serializedName: 'circuitId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkProfile;
