/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The Operations Management Suite (OMS) status response
 *
 */
class ClusterMonitoringResponse {
  /**
   * Create a ClusterMonitoringResponse.
   * @property {boolean} [clusterMonitoringEnabled] The status of the
   * Operations Management Suite (OMS) on the HDInsight cluster.
   * @property {string} [workspaceId] The workspace ID of the Operations
   * Management Suite (OMS) on the HDInsight cluster.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ClusterMonitoringResponse
   *
   * @returns {object} metadata of ClusterMonitoringResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClusterMonitoringResponse',
      type: {
        name: 'Composite',
        className: 'ClusterMonitoringResponse',
        modelProperties: {
          clusterMonitoringEnabled: {
            required: false,
            serializedName: 'clusterMonitoringEnabled',
            type: {
              name: 'Boolean'
            }
          },
          workspaceId: {
            required: false,
            serializedName: 'workspaceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ClusterMonitoringResponse;
