/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The data disks groups for the role.
 *
 */
class DataDisksGroups {
  /**
   * Create a DataDisksGroups.
   * @property {number} [disksPerNode] The number of disks per node.
   * @property {string} [storageAccountType] ReadOnly. The storage account
   * type. Do not set this value.
   * @property {number} [diskSizeGB] ReadOnly. The DiskSize in GB. Do not set
   * this value.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DataDisksGroups
   *
   * @returns {object} metadata of DataDisksGroups
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataDisksGroups',
      type: {
        name: 'Composite',
        className: 'DataDisksGroups',
        modelProperties: {
          disksPerNode: {
            required: false,
            serializedName: 'disksPerNode',
            type: {
              name: 'Number'
            }
          },
          storageAccountType: {
            required: false,
            readOnly: true,
            serializedName: 'storageAccountType',
            type: {
              name: 'String'
            }
          },
          diskSizeGB: {
            required: false,
            readOnly: true,
            serializedName: 'diskSizeGB',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = DataDisksGroups;
