/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The storage Account.
 *
 */
class StorageAccount {
  /**
   * Create a StorageAccount.
   * @property {string} [name] The name of the storage account.
   * @property {boolean} [isDefault] Whether or not the storage account is the
   * default storage account.
   * @property {string} [container] The container in the storage account, only
   * to be specified for WASB storage accounts.
   * @property {string} [fileSystem] The filesystem, only to be specified for
   * Azure Data Lake Storage type Gen 2.
   * @property {string} [key] The storage account access key.
   * @property {string} [resourceId] The resource ID of storage account, only
   * to be specified for Azure Data Lake Storage Gen 2.
   * @property {string} [msiResourceId] The managed identity (MSI) that is
   * allowed to access the storage account, only to be specified for Azure Data
   * Lake Storage Gen 2.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StorageAccount
   *
   * @returns {object} metadata of StorageAccount
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageAccount',
      type: {
        name: 'Composite',
        className: 'StorageAccount',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          isDefault: {
            required: false,
            serializedName: 'isDefault',
            type: {
              name: 'Boolean'
            }
          },
          container: {
            required: false,
            serializedName: 'container',
            type: {
              name: 'String'
            }
          },
          fileSystem: {
            required: false,
            serializedName: 'fileSystem',
            type: {
              name: 'String'
            }
          },
          key: {
            required: false,
            serializedName: 'key',
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: false,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          msiResourceId: {
            required: false,
            serializedName: 'msiResourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageAccount;
