/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The details about the usage of a particular limited resource.
 *
 */
class Usage {
  /**
   * Create a Usage.
   * @property {string} [unit] The type of measurement for usage.
   * @property {number} [currentValue] The current usage.
   * @property {number} [limit] The maximum allowed usage.
   * @property {object} [name] The details about the localizable name of the
   * used resource.
   * @property {string} [name.value] The name of the used resource.
   * @property {string} [name.localizedValue] The localized name of the used
   * resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Usage
   *
   * @returns {object} metadata of Usage
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Usage',
      type: {
        name: 'Composite',
        className: 'Usage',
        modelProperties: {
          unit: {
            required: false,
            serializedName: 'unit',
            type: {
              name: 'String'
            }
          },
          currentValue: {
            required: false,
            serializedName: 'currentValue',
            type: {
              name: 'Number'
            }
          },
          limit: {
            required: false,
            serializedName: 'limit',
            type: {
              name: 'Number'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'Composite',
              className: 'LocalizedName'
            }
          }
        }
      }
    };
  }
}

module.exports = Usage;
