/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines a cooking recipe.
 *
 * @extends models['CreativeWork']
 */
class Recipe extends models['CreativeWork'] {
  /**
   * Create a Recipe.
   * @property {string} [cookTime] The amount of time the food takes to cook.
   * For example, PT25M. For information about the time format, see
   * http://en.wikipedia.org/wiki/ISO_8601#Durations.
   * @property {string} [prepTime] The amount of time required to prepare the
   * ingredients. For example, PT15M. For information about the time format,
   * see http://en.wikipedia.org/wiki/ISO_8601#Durations.
   * @property {string} [totalTime] The total amount of time it takes to
   * prepare and cook the recipe. For example, PT45M. For information about the
   * time format, see http://en.wikipedia.org/wiki/ISO_8601#Durations.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Recipe
   *
   * @returns {object} metadata of Recipe
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Recipe',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '_type',
          clientName: '_type'
        },
        uberParent: 'ResponseBase',
        className: 'Recipe',
        modelProperties: {
          _type: {
            required: true,
            serializedName: '_type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          readLink: {
            required: false,
            readOnly: true,
            serializedName: 'readLink',
            type: {
              name: 'String'
            }
          },
          webSearchUrl: {
            required: false,
            readOnly: true,
            serializedName: 'webSearchUrl',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          url: {
            required: false,
            readOnly: true,
            serializedName: 'url',
            type: {
              name: 'String'
            }
          },
          image: {
            required: false,
            readOnly: true,
            serializedName: 'image',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: '_type',
                clientName: '_type'
              },
              uberParent: 'ResponseBase',
              className: 'ImageObject'
            }
          },
          description: {
            required: false,
            readOnly: true,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          alternateName: {
            required: false,
            readOnly: true,
            serializedName: 'alternateName',
            type: {
              name: 'String'
            }
          },
          bingId: {
            required: false,
            readOnly: true,
            serializedName: 'bingId',
            type: {
              name: 'String'
            }
          },
          thumbnailUrl: {
            required: false,
            readOnly: true,
            serializedName: 'thumbnailUrl',
            type: {
              name: 'String'
            }
          },
          provider: {
            required: false,
            readOnly: true,
            serializedName: 'provider',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ThingElementType',
                  type: {
                    name: 'Composite',
                    polymorphicDiscriminator: {
                      serializedName: '_type',
                      clientName: '_type'
                    },
                    uberParent: 'ResponseBase',
                    className: 'Thing'
                  }
              }
            }
          },
          datePublished: {
            required: false,
            readOnly: true,
            serializedName: 'datePublished',
            type: {
              name: 'String'
            }
          },
          text: {
            required: false,
            readOnly: true,
            serializedName: 'text',
            type: {
              name: 'String'
            }
          },
          cookTime: {
            required: false,
            readOnly: true,
            serializedName: 'cookTime',
            type: {
              name: 'String'
            }
          },
          prepTime: {
            required: false,
            readOnly: true,
            serializedName: 'prepTime',
            type: {
              name: 'String'
            }
          },
          totalTime: {
            required: false,
            readOnly: true,
            serializedName: 'totalTime',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Recipe;
