/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Represents an environment instance
 *
 * @extends models['Resource']
 */
class EnvironmentFragment extends models['Resource'] {
  /**
   * Create a EnvironmentFragment.
   * @property {object} [resourceSets] The set of a VM and the setting id it
   * was created for
   * @property {string} [resourceSets.vmResourceId] VM resource Id for the
   * environment
   * @property {string} [resourceSets.resourceSettingId] resourceSettingId for
   * the environment
   * @property {string} [provisioningState] The provisioning status of the
   * resource.
   * @property {string} [uniqueIdentifier] The unique immutable identifier of a
   * resource (Guid).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of EnvironmentFragment
   *
   * @returns {object} metadata of EnvironmentFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EnvironmentFragment',
      type: {
        name: 'Composite',
        className: 'EnvironmentFragment',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          resourceSets: {
            required: false,
            serializedName: 'properties.resourceSets',
            type: {
              name: 'Composite',
              className: 'ResourceSetFragment'
            }
          },
          provisioningState: {
            required: false,
            serializedName: 'properties.provisioningState',
            type: {
              name: 'String'
            }
          },
          uniqueIdentifier: {
            required: false,
            serializedName: 'properties.uniqueIdentifier',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EnvironmentFragment;
