/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents a size category supported by this Lab Account (small, medium or
 * large)
 *
 */
class EnvironmentSizeFragment {
  /**
   * Create a EnvironmentSizeFragment.
   * @property {string} [name] The size category. Possible values include:
   * 'Basic', 'Standard', 'Performance'
   * @property {array} [vmSizes] Represents a set of compute sizes that can
   * serve this given size type
   */
  constructor() {
  }

  /**
   * Defines the metadata of EnvironmentSizeFragment
   *
   * @returns {object} metadata of EnvironmentSizeFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EnvironmentSizeFragment',
      type: {
        name: 'Composite',
        className: 'EnvironmentSizeFragment',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          vmSizes: {
            required: false,
            serializedName: 'vmSizes',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SizeInfoFragmentElementType',
                  type: {
                    name: 'Composite',
                    className: 'SizeInfoFragment'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = EnvironmentSizeFragment;
