/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Network details of the environment
 *
 */
class NetworkInterface {
  /**
   * Create a NetworkInterface.
   * @property {string} [privateIpAddress] PrivateIp address of the Compute VM
   * @property {string} [sshAuthority] Connection information for Linux
   * @property {string} [rdpAuthority] Connection information for Windows
   * @property {string} [username] Username of the VM
   */
  constructor() {
  }

  /**
   * Defines the metadata of NetworkInterface
   *
   * @returns {object} metadata of NetworkInterface
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'NetworkInterface',
      type: {
        name: 'Composite',
        className: 'NetworkInterface',
        modelProperties: {
          privateIpAddress: {
            required: false,
            readOnly: true,
            serializedName: 'privateIpAddress',
            type: {
              name: 'String'
            }
          },
          sshAuthority: {
            required: false,
            readOnly: true,
            serializedName: 'sshAuthority',
            type: {
              name: 'String'
            }
          },
          rdpAuthority: {
            required: false,
            readOnly: true,
            serializedName: 'rdpAuthority',
            type: {
              name: 'String'
            }
          },
          username: {
            required: false,
            readOnly: true,
            serializedName: 'username',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = NetworkInterface;
