/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents the payload for resetting passwords.
 *
 */
class ResetPasswordPayload {
  /**
   * Create a ResetPasswordPayload.
   * @property {string} environmentId The resourceId of the environment
   * @property {string} [username] The username for which the password will be
   * reset.
   * @property {string} [password] The password to assign to the user specified
   * in
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResetPasswordPayload
   *
   * @returns {object} metadata of ResetPasswordPayload
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResetPasswordPayload',
      type: {
        name: 'Composite',
        className: 'ResetPasswordPayload',
        modelProperties: {
          environmentId: {
            required: true,
            serializedName: 'environmentId',
            type: {
              name: 'String'
            }
          },
          username: {
            required: false,
            serializedName: 'username',
            type: {
              name: 'String'
            }
          },
          password: {
            required: false,
            serializedName: 'password',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ResetPasswordPayload;
