/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents resource specific settings
 *
 */
class ResourceSettingsFragment {
  /**
   * Create a ResourceSettingsFragment.
   * @property {string} [galleryImageResourceId] The resource id of the gallery
   * image used for creating the virtual machine
   * @property {string} [size] The size of the virtual machine. Possible values
   * include: 'Basic', 'Standard', 'Performance'
   * @property {object} [referenceVm] Details specific to Reference Vm
   * @property {string} [referenceVm.userName] The username of the virtual
   * machine
   * @property {string} [referenceVm.password] The password of the virtual
   * machine. This will be set to null in GET resource API
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceSettingsFragment
   *
   * @returns {object} metadata of ResourceSettingsFragment
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceSettingsFragment',
      type: {
        name: 'Composite',
        className: 'ResourceSettingsFragment',
        modelProperties: {
          galleryImageResourceId: {
            required: false,
            serializedName: 'galleryImageResourceId',
            type: {
              name: 'String'
            }
          },
          size: {
            required: false,
            serializedName: 'size',
            type: {
              name: 'String'
            }
          },
          referenceVm: {
            required: false,
            serializedName: 'referenceVm',
            type: {
              name: 'Composite',
              className: 'ReferenceVmFragment'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceSettingsFragment;
