/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Details of the backing virtual machine.
 *
 */
class VirtualMachineDetails {
  /**
   * Create a VirtualMachineDetails.
   * @property {string} [provisioningState] Provisioning state of the Dtl VM
   * @property {string} [rdpAuthority] Connection information for Windows
   * @property {string} [sshAuthority] Connection information for Linux
   * @property {string} [privateIpAddress] PrivateIp address of the compute VM
   * @property {string} [userName] Compute VM login user name
   * @property {string} [lastKnownPowerState] Last known compute power state
   * captured in DTL
   */
  constructor() {
  }

  /**
   * Defines the metadata of VirtualMachineDetails
   *
   * @returns {object} metadata of VirtualMachineDetails
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VirtualMachineDetails',
      type: {
        name: 'Composite',
        className: 'VirtualMachineDetails',
        modelProperties: {
          provisioningState: {
            required: false,
            readOnly: true,
            serializedName: 'provisioningState',
            type: {
              name: 'String'
            }
          },
          rdpAuthority: {
            required: false,
            readOnly: true,
            serializedName: 'rdpAuthority',
            type: {
              name: 'String'
            }
          },
          sshAuthority: {
            required: false,
            readOnly: true,
            serializedName: 'sshAuthority',
            type: {
              name: 'String'
            }
          },
          privateIpAddress: {
            required: false,
            readOnly: true,
            serializedName: 'privateIpAddress',
            type: {
              name: 'String'
            }
          },
          userName: {
            required: false,
            readOnly: true,
            serializedName: 'userName',
            type: {
              name: 'String'
            }
          },
          lastKnownPowerState: {
            required: false,
            readOnly: true,
            serializedName: 'lastKnownPowerState',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = VirtualMachineDetails;
