/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing a LocationBasedServicesOperationsValueItem.
 */
class LocationBasedServicesOperationsValueItem {
  /**
   * Create a LocationBasedServicesOperationsValueItem.
   * @member {string} [name] Operation name: {provider}/{resource}/{operation}.
   * @member {object} [display] The human-readable description of the
   * operation.
   * @member {string} [display.provider] Service provider: Microsoft Location
   * Based Services.
   * @member {string} [display.resource] Resource on which the operation is
   * performed.
   * @member {string} [display.operation] The action that users can perform,
   * based on their permission level.
   * @member {string} [display.description] The description of the operation.
   * @member {string} [origin] The origin of the operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LocationBasedServicesOperationsValueItem
   *
   * @returns {object} metadata of LocationBasedServicesOperationsValueItem
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LocationBasedServicesOperations_valueItem',
      type: {
        name: 'Composite',
        className: 'LocationBasedServicesOperationsValueItem',
        modelProperties: {
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'LocationBasedServicesOperationsValueItemDisplay'
            }
          },
          origin: {
            required: false,
            readOnly: true,
            serializedName: 'origin',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LocationBasedServicesOperationsValueItem;
