/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An error response from the Logic App service.
 *
 */
class ApiError {
  /**
   * Create a ApiError.
   * @member {object} [error]
   * @member {string} [error.code] An identifier for the error. Codes are
   * invariant and are intended to be consumed programmatically.
   * @member {string} [error.message] A message describing the error, intended
   * to be suitable for display in a user interface.
   * @member {string} [error.target] The target of the particular error. For
   * example, the name of the property in error.
   * @member {array} [error.details] A list of additional details about the
   * error.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApiError
   *
   * @returns {object} metadata of ApiError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApiError',
      type: {
        name: 'Composite',
        className: 'ApiError',
        modelProperties: {
          error: {
            required: false,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'ApiErrorBody'
            }
          }
        }
      }
    };
  }
}

module.exports = ApiError;
