/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Object model for publishing a specific application version.
 *
 */
class ApplicationPublishObject {
  /**
   * Create a ApplicationPublishObject.
   * @property {string} [versionId] The version ID to publish.
   * @property {boolean} [isStaging] Indicates if the staging slot should be
   * used, instead of the Production one. Default value: false .
   */
  constructor() {
  }

  /**
   * Defines the metadata of ApplicationPublishObject
   *
   * @returns {object} metadata of ApplicationPublishObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ApplicationPublishObject',
      type: {
        name: 'Composite',
        className: 'ApplicationPublishObject',
        modelProperties: {
          versionId: {
            required: false,
            serializedName: 'versionId',
            type: {
              name: 'String'
            }
          },
          isStaging: {
            required: false,
            serializedName: 'isStaging',
            defaultValue: false,
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = ApplicationPublishObject;
