/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines the azure account information object.
 *
 */
class AzureAccountInfoObject {
  /**
   * Create a AzureAccountInfoObject.
   * @property {string} azureSubscriptionId The id for the azure subscription.
   * @property {string} resourceGroup The azure resource group name.
   * @property {string} accountName The azure account name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureAccountInfoObject
   *
   * @returns {object} metadata of AzureAccountInfoObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureAccountInfoObject',
      type: {
        name: 'Composite',
        className: 'AzureAccountInfoObject',
        modelProperties: {
          azureSubscriptionId: {
            required: true,
            serializedName: 'azureSubscriptionId',
            type: {
              name: 'String'
            }
          },
          resourceGroup: {
            required: true,
            serializedName: 'resourceGroup',
            type: {
              name: 'String'
            }
          },
          accountName: {
            required: true,
            serializedName: 'accountName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureAccountInfoObject;
