/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A suggested entity.
 *
 */
class EntityPrediction {
  /**
   * Create a EntityPrediction.
   * @property {string} entityName The entity's name
   * @property {number} startTokenIndex The index within the utterance where
   * the extracted entity starts.
   * @property {number} endTokenIndex The index within the utterance where the
   * extracted entity ends.
   * @property {string} phrase The actual token(s) that comprise the entity.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EntityPrediction
   *
   * @returns {object} metadata of EntityPrediction
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EntityPrediction',
      type: {
        name: 'Composite',
        className: 'EntityPrediction',
        modelProperties: {
          entityName: {
            required: true,
            serializedName: 'entityName',
            type: {
              name: 'String'
            }
          },
          startTokenIndex: {
            required: true,
            serializedName: 'startTokenIndex',
            type: {
              name: 'Number'
            }
          },
          endTokenIndex: {
            required: true,
            serializedName: 'endTokenIndex',
            type: {
              name: 'Number'
            }
          },
          phrase: {
            required: true,
            serializedName: 'phrase',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EntityPrediction;
