/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Prebuilt Domain.
 *
 */
class PrebuiltDomain {
  /**
   * Create a PrebuiltDomain.
   * @property {string} [name]
   * @property {string} [culture]
   * @property {string} [description]
   * @property {string} [examples]
   * @property {array} [intents]
   * @property {array} [entities]
   */
  constructor() {
  }

  /**
   * Defines the metadata of PrebuiltDomain
   *
   * @returns {object} metadata of PrebuiltDomain
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PrebuiltDomain',
      type: {
        name: 'Composite',
        className: 'PrebuiltDomain',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          culture: {
            required: false,
            serializedName: 'culture',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          examples: {
            required: false,
            serializedName: 'examples',
            type: {
              name: 'String'
            }
          },
          intents: {
            required: false,
            serializedName: 'intents',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PrebuiltDomainItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'PrebuiltDomainItem'
                  }
              }
            }
          },
          entities: {
            required: false,
            serializedName: 'entities',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'PrebuiltDomainItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'PrebuiltDomainItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = PrebuiltDomain;
