/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Sublist of items for a Closed list.
 *
 * @extends models['SubClosedList']
 */
class SubClosedListResponse extends models['SubClosedList'] {
  /**
   * Create a SubClosedListResponse.
   * @property {number} [id] The sublist ID
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SubClosedListResponse
   *
   * @returns {object} metadata of SubClosedListResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SubClosedListResponse',
      type: {
        name: 'Composite',
        className: 'SubClosedListResponse',
        modelProperties: {
          canonicalForm: {
            required: false,
            serializedName: 'canonicalForm',
            type: {
              name: 'String'
            }
          },
          list: {
            required: false,
            serializedName: 'list',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          id: {
            required: false,
            nullable: false,
            serializedName: 'id',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = SubClosedListResponse;
