/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Object model for updating one of the closed list's sublists.
 *
 */
class WordListBaseUpdateObject {
  /**
   * Create a WordListBaseUpdateObject.
   * @property {string} [canonicalForm] The standard form that the list
   * represents.
   * @property {array} [list] List of synonym words.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WordListBaseUpdateObject
   *
   * @returns {object} metadata of WordListBaseUpdateObject
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WordListBaseUpdateObject',
      type: {
        name: 'Composite',
        className: 'WordListBaseUpdateObject',
        modelProperties: {
          canonicalForm: {
            required: false,
            serializedName: 'canonicalForm',
            type: {
              name: 'String'
            }
          },
          list: {
            required: false,
            serializedName: 'list',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = WordListBaseUpdateObject;
