/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters for updating a machine learning project.
 *
 */
class ProjectUpdateParameters {
  /**
   * Create a ProjectUpdateParameters.
   * @member {object} [tags] The resource tags for the machine learning
   * project.
   * @member {string} [friendlyName] The friendly name for this project.
   * @member {string} [description] The description of this project.
   * @member {string} [gitrepo] The reference to git repo for this project.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ProjectUpdateParameters
   *
   * @returns {object} metadata of ProjectUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProjectUpdateParameters',
      type: {
        name: 'Composite',
        className: 'ProjectUpdateParameters',
        modelProperties: {
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          friendlyName: {
            required: false,
            serializedName: 'properties.friendlyName',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          gitrepo: {
            required: false,
            serializedName: 'properties.gitrepo',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ProjectUpdateParameters;
