/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Wrapper for error response to follow ARM guidelines.
 *
 */
class MachineLearningServiceError {
  /**
   * Create a MachineLearningServiceError.
   * @member {object} [error] The error response.
   * @member {string} [error.code] Error code.
   * @member {string} [error.message] Error message.
   * @member {array} [error.details] An array of error detail objects.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MachineLearningServiceError
   *
   * @returns {object} metadata of MachineLearningServiceError
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MachineLearningServiceError',
      type: {
        name: 'Composite',
        className: 'MachineLearningServiceError',
        modelProperties: {
          error: {
            required: false,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'ErrorResponse'
            }
          }
        }
      }
    };
  }
}

module.exports = MachineLearningServiceError;
