/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Paginated list of Machine Learning compute objects wrapped in ARM resource
 * envelope.
 */
class PaginatedComputeResourcesList extends Array {
  /**
   * Create a PaginatedComputeResourcesList.
   * @member {string} [nextLink] A continuation link (absolute URI) to the next
   * page of results in the list.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PaginatedComputeResourcesList
   *
   * @returns {object} metadata of PaginatedComputeResourcesList
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PaginatedComputeResourcesList',
      type: {
        name: 'Composite',
        className: 'PaginatedComputeResourcesList',
        modelProperties: {
          value: {
            required: false,
            serializedName: '',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ComputeResourceElementType',
                  type: {
                    name: 'Composite',
                    className: 'ComputeResource'
                  }
              }
            }
          },
          nextLink: {
            required: false,
            serializedName: 'nextLink',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PaginatedComputeResourcesList;
