/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Parameters used to create a new Maps Account.
 *
 */
class MapsAccountCreateParameters {
  /**
   * Create a MapsAccountCreateParameters.
   * @member {string} location The location of the resource.
   * @member {object} [tags] Gets or sets a list of key value pairs that
   * describe the resource. These tags can be used in viewing and grouping this
   * resource (across resource groups). A maximum of 15 tags can be provided
   * for a resource. Each tag must have a key no greater than 128 characters
   * and value no greater than 256 characters.
   * @member {object} sku The SKU of this account.
   * @member {string} [sku.name] The name of the SKU, in standard format (such
   * as S0).
   * @member {string} [sku.tier] Gets the sku tier. This is based on the SKU
   * name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MapsAccountCreateParameters
   *
   * @returns {object} metadata of MapsAccountCreateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MapsAccountCreateParameters',
      type: {
        name: 'Composite',
        className: 'MapsAccountCreateParameters',
        modelProperties: {
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          sku: {
            required: true,
            serializedName: 'sku',
            type: {
              name: 'Composite',
              className: 'Sku'
            }
          }
        }
      }
    };
  }
}

module.exports = MapsAccountCreateParameters;
