/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Akamai Signature Header authentication key.
 *
 */
class AkamaiSignatureHeaderAuthenticationKey {
  /**
   * Create a AkamaiSignatureHeaderAuthenticationKey.
   * @property {string} [identifier] identifier of the key
   * @property {string} [base64Key] authentication key
   * @property {date} [expiration] The expiration time of the authentication
   * key.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AkamaiSignatureHeaderAuthenticationKey
   *
   * @returns {object} metadata of AkamaiSignatureHeaderAuthenticationKey
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AkamaiSignatureHeaderAuthenticationKey',
      type: {
        name: 'Composite',
        className: 'AkamaiSignatureHeaderAuthenticationKey',
        modelProperties: {
          identifier: {
            required: false,
            serializedName: 'identifier',
            type: {
              name: 'String'
            }
          },
          base64Key: {
            required: false,
            serializedName: 'base64Key',
            type: {
              name: 'String'
            }
          },
          expiration: {
            required: false,
            serializedName: 'expiration',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = AkamaiSignatureHeaderAuthenticationKey;
