/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Defines the common properties for all audio codecs.
 *
 * @extends models['Codec']
 */
class Audio extends models['Codec'] {
  /**
   * Create a Audio.
   * @property {number} [channels] The number of channels in the audio.
   * @property {number} [samplingRate] The sampling rate to use for encoding in
   * hertz.
   * @property {number} [bitrate] The bitrate, in bits per second, of the
   * output encoded audio.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Audio
   *
   * @returns {object} metadata of Audio
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Media.Audio',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '@odata.type',
          clientName: 'odatatype'
        },
        uberParent: 'Codec',
        className: 'Audio',
        modelProperties: {
          label: {
            required: false,
            serializedName: 'label',
            type: {
              name: 'String'
            }
          },
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          channels: {
            required: false,
            serializedName: 'channels',
            type: {
              name: 'Number'
            }
          },
          samplingRate: {
            required: false,
            serializedName: 'samplingRate',
            type: {
              name: 'Number'
            }
          },
          bitrate: {
            required: false,
            serializedName: 'bitrate',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = Audio;
