/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes a built-in preset for encoding the input video with the Standard
 * Encoder.
 *
 * @extends models['Preset']
 */
class BuiltInStandardEncoderPreset extends models['Preset'] {
  /**
   * Create a BuiltInStandardEncoderPreset.
   * @property {string} presetName The built-in preset to be used for encoding
   * videos. Possible values include: 'H264SingleBitrateSD',
   * 'H264SingleBitrate720p', 'H264SingleBitrate1080p', 'AdaptiveStreaming',
   * 'AACGoodQualityAudio', 'ContentAwareEncodingExperimental',
   * 'H264MultipleBitrate1080p', 'H264MultipleBitrate720p',
   * 'H264MultipleBitrateSD'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BuiltInStandardEncoderPreset
   *
   * @returns {object} metadata of BuiltInStandardEncoderPreset
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: '#Microsoft.Media.BuiltInStandardEncoderPreset',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '@odata.type',
          clientName: 'odatatype'
        },
        uberParent: 'Preset',
        className: 'BuiltInStandardEncoderPreset',
        modelProperties: {
          odatatype: {
            required: true,
            serializedName: '@odata\\.type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          presetName: {
            required: true,
            serializedName: 'presetName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BuiltInStandardEncoderPreset;
