/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Configures the Explicit Analog Television Output Restriction control bits.
 * For further details see the PlayReady Compliance Rules.
 *
 */
class ContentKeyPolicyPlayReadyExplicitAnalogTelevisionRestriction {
  /**
   * Create a ContentKeyPolicyPlayReadyExplicitAnalogTelevisionRestriction.
   * @property {boolean} bestEffort Indicates whether this restriction is
   * enforced on a Best Effort basis.
   * @property {number} configurationData Configures the restriction control
   * bits. Must be between 0 and 3 inclusive.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContentKeyPolicyPlayReadyExplicitAnalogTelevisionRestriction
   *
   * @returns {object} metadata of ContentKeyPolicyPlayReadyExplicitAnalogTelevisionRestriction
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContentKeyPolicyPlayReadyExplicitAnalogTelevisionRestriction',
      type: {
        name: 'Composite',
        className: 'ContentKeyPolicyPlayReadyExplicitAnalogTelevisionRestriction',
        modelProperties: {
          bestEffort: {
            required: true,
            serializedName: 'bestEffort',
            type: {
              name: 'Boolean'
            }
          },
          configurationData: {
            required: true,
            serializedName: 'configurationData',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ContentKeyPolicyPlayReadyExplicitAnalogTelevisionRestriction;
