/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The response from the check name availability request.
 *
 */
class EntityNameAvailabilityCheckOutput {
  /**
   * Create a EntityNameAvailabilityCheckOutput.
   * @property {boolean} nameAvailable Specifies if the name is available.
   * @property {string} [reason] Specifies the reason if the name is not
   * available.
   * @property {string} [message] Specifies the detailed reason if the name is
   * not available.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EntityNameAvailabilityCheckOutput
   *
   * @returns {object} metadata of EntityNameAvailabilityCheckOutput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EntityNameAvailabilityCheckOutput',
      type: {
        name: 'Composite',
        className: 'EntityNameAvailabilityCheckOutput',
        modelProperties: {
          nameAvailable: {
            required: true,
            serializedName: 'nameAvailable',
            type: {
              name: 'Boolean'
            }
          },
          reason: {
            required: false,
            serializedName: 'reason',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = EntityNameAvailabilityCheckOutput;
