/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The parameters to the list SAS request.
 *
 */
class ListContainerSasInput {
  /**
   * Create a ListContainerSasInput.
   * @property {string} [permissions] The permissions to set on the SAS URL.
   * Possible values include: 'Read', 'ReadWrite', 'ReadWriteDelete'
   * @property {date} [expiryTime] The SAS URL expiration time.  This must be
   * less than 24 hours from the current time.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ListContainerSasInput
   *
   * @returns {object} metadata of ListContainerSasInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ListContainerSasInput',
      type: {
        name: 'Composite',
        className: 'ListContainerSasInput',
        modelProperties: {
          permissions: {
            required: false,
            serializedName: 'permissions',
            type: {
              name: 'String'
            }
          },
          expiryTime: {
            required: false,
            serializedName: 'expiryTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = ListContainerSasInput;
