/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class of response for listPaths action
 *
 */
class ListPathsResponse {
  /**
   * Create a ListPathsResponse.
   * @property {array} [streamingPaths] Streaming Paths supported by current
   * Streaming Locator
   * @property {array} [downloadPaths] Download Paths supported by current
   * Streaming Locator
   */
  constructor() {
  }

  /**
   * Defines the metadata of ListPathsResponse
   *
   * @returns {object} metadata of ListPathsResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ListPathsResponse',
      type: {
        name: 'Composite',
        className: 'ListPathsResponse',
        modelProperties: {
          streamingPaths: {
            required: false,
            serializedName: 'streamingPaths',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StreamingPathElementType',
                  type: {
                    name: 'Composite',
                    className: 'StreamingPath'
                  }
              }
            }
          },
          downloadPaths: {
            required: false,
            serializedName: 'downloadPaths',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ListPathsResponse;
