/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents an output file produced.
 *
 */
class OutputFile {
  /**
   * Create a OutputFile.
   * @property {array} labels The list of labels that describe how the encoder
   * should multiplex video and audio into an output file. For example, if the
   * encoder is producing two video layers with labels v1 and v2, and one audio
   * layer with label a1, then an array like '[v1, a1]' tells the encoder to
   * produce an output file with the video track represented by v1 and the
   * audio track represented by a1.
   */
  constructor() {
  }

  /**
   * Defines the metadata of OutputFile
   *
   * @returns {object} metadata of OutputFile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'OutputFile',
      type: {
        name: 'Composite',
        className: 'OutputFile',
        modelProperties: {
          labels: {
            required: true,
            serializedName: 'labels',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = OutputFile;
