/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The presentation time range, this is asset related and not recommended for
 * Account Filter.
 *
 */
class PresentationTimeRange {
  /**
   * Create a PresentationTimeRange.
   * @property {number} [startTimestamp] The absolute start time boundary.
   * @property {number} [endTimestamp] The absolute end time boundary.
   * @property {number} [presentationWindowDuration] The relative to end
   * sliding window.
   * @property {number} [liveBackoffDuration] The relative to end right edge.
   * @property {number} [timescale] The time scale of time stamps.
   * @property {boolean} [forceEndTimestamp] The indicator of forcing exsiting
   * of end time stamp.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PresentationTimeRange
   *
   * @returns {object} metadata of PresentationTimeRange
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PresentationTimeRange',
      type: {
        name: 'Composite',
        className: 'PresentationTimeRange',
        modelProperties: {
          startTimestamp: {
            required: false,
            serializedName: 'startTimestamp',
            type: {
              name: 'Number'
            }
          },
          endTimestamp: {
            required: false,
            serializedName: 'endTimestamp',
            type: {
              name: 'Number'
            }
          },
          presentationWindowDuration: {
            required: false,
            serializedName: 'presentationWindowDuration',
            type: {
              name: 'Number'
            }
          },
          liveBackoffDuration: {
            required: false,
            serializedName: 'liveBackoffDuration',
            type: {
              name: 'Number'
            }
          },
          timescale: {
            required: false,
            serializedName: 'timescale',
            type: {
              name: 'Number'
            }
          },
          forceEndTimestamp: {
            required: false,
            serializedName: 'forceEndTimestamp',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = PresentationTimeRange;
