/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The response to a calculate baseline call.
 *
 */
class CalculateBaselineResponse {
  /**
   * Create a CalculateBaselineResponse.
   * @property {string} type the resource type of the baseline resource.
   * @property {array} [timestamps] the array of timestamps of the baselines.
   * @property {array} baseline the baseline values for each sensitivity.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CalculateBaselineResponse
   *
   * @returns {object} metadata of CalculateBaselineResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CalculateBaselineResponse',
      type: {
        name: 'Composite',
        className: 'CalculateBaselineResponse',
        modelProperties: {
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          timestamps: {
            required: false,
            serializedName: 'timestamps',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DateElementType',
                  type: {
                    name: 'DateTime'
                  }
              }
            }
          },
          baseline: {
            required: true,
            serializedName: 'baseline',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'BaselineElementType',
                  type: {
                    name: 'Composite',
                    className: 'Baseline'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = CalculateBaselineResponse;
