/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about a container with data for a given resource.
 *
 */
class DataContainer {
  /**
   * Create a DataContainer.
   * @property {object} workspace Log Analytics workspace information.
   * @property {string} [workspace.id] Azure Resource Manager identifier of the
   * Log Analytics Workspace.
   * @property {string} [workspace.location] Location of the Log Analytics
   * workspace.
   * @property {string} [workspace.customerId] Log Analytics workspace
   * identifier.
   */
  constructor() {
  }

  /**
   * Defines the metadata of DataContainer
   *
   * @returns {object} metadata of DataContainer
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DataContainer',
      type: {
        name: 'Composite',
        className: 'DataContainer',
        modelProperties: {
          workspace: {
            required: true,
            serializedName: 'workspace',
            type: {
              name: 'Composite',
              className: 'WorkspaceInfo'
            }
          }
        }
      }
    };
  }
}

module.exports = DataContainer;
