/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A logic app receiver.
 *
 */
class LogicAppReceiver {
  /**
   * Create a LogicAppReceiver.
   * @property {string} name The name of the logic app receiver. Names must be
   * unique across all receivers within an action group.
   * @property {string} resourceId The azure resource id of the logic app
   * receiver.
   * @property {string} callbackUrl The callback url where http request sent
   * to.
   * @property {boolean} useCommonAlertSchema Indicates whether to use common
   * alert schema.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LogicAppReceiver
   *
   * @returns {object} metadata of LogicAppReceiver
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LogicAppReceiver',
      type: {
        name: 'Composite',
        className: 'LogicAppReceiver',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          resourceId: {
            required: true,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          callbackUrl: {
            required: true,
            serializedName: 'callbackUrl',
            type: {
              name: 'String'
            }
          },
          useCommonAlertSchema: {
            required: true,
            serializedName: 'useCommonAlertSchema',
            type: {
              name: 'Boolean'
            }
          }
        }
      }
    };
  }
}

module.exports = LogicAppReceiver;
