/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Metric namespace class specifies the metadata for a metric namespace.
 *
 */
class MetricNamespace {
  /**
   * Create a MetricNamespace.
   * @property {string} [id] The ID of the metricNamespace.
   * @property {string} [type] The type of the namespace.
   * @property {string} [name] The name of the namespace.
   * @property {object} [properties] Properties which include the fully
   * qualified namespace name.
   * @property {string} [properties.metricNamespaceName] The metric namespace
   * name.
   */
  constructor() {
  }

  /**
   * Defines the metadata of MetricNamespace
   *
   * @returns {object} metadata of MetricNamespace
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MetricNamespace',
      type: {
        name: 'Composite',
        className: 'MetricNamespace',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          properties: {
            required: false,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              className: 'MetricNamespaceName'
            }
          }
        }
      }
    };
  }
}

module.exports = MetricNamespace;
