/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @summary Microsoft.ManagedIdentity Operation.
  *
 * Operation supported by the Microsoft.ManagedIdentity REST API.
 *
 */
class Operation {
  /**
   * Create a Operation.
   * @member {string} [name] Operation Name. The name of the REST Operation.
   * This is of the format {provider}/{resource}/{operation}.
   * @member {object} [display] Operation Display. The object that describes
   * the operation.
   * @member {string} [display.provider] Friendly name of the resource
   * provider.
   * @member {string} [display.operation] The type of operation. For example:
   * read, write, delete.
   * @member {string} [display.resource] The resource type on which the
   * operation is performed.
   * @member {string} [display.description] A description of the operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Operation
   *
   * @returns {object} metadata of Operation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Operation',
      type: {
        name: 'Composite',
        className: 'Operation',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          display: {
            required: false,
            serializedName: 'display',
            type: {
              name: 'Composite',
              className: 'OperationDisplay'
            }
          }
        }
      }
    };
  }
}

module.exports = Operation;
