/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Storage Profile properties of a server
 *
 */
class StorageProfile {
  /**
   * Create a StorageProfile.
   * @member {number} [backupRetentionDays] Backup retention days for the
   * server.
   * @member {string} [geoRedundantBackup] Enable Geo-redundant or not for
   * server backup. Possible values include: 'Enabled', 'Disabled'
   * @member {number} [storageMB] Max storage allowed for a server.
   */
  constructor() {
  }

  /**
   * Defines the metadata of StorageProfile
   *
   * @returns {object} metadata of StorageProfile
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageProfile',
      type: {
        name: 'Composite',
        className: 'StorageProfile',
        modelProperties: {
          backupRetentionDays: {
            required: false,
            serializedName: 'backupRetentionDays',
            type: {
              name: 'Number'
            }
          },
          geoRedundantBackup: {
            required: false,
            serializedName: 'geoRedundantBackup',
            type: {
              name: 'String'
            }
          },
          storageMB: {
            required: false,
            serializedName: 'storageMB',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageProfile;
