/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * ManagementAssociation properties supported by the OperationsManagement
 * resource provider.
 *
 * @extends models['BaseResource']
 */
class ManagementAssociationProperties extends models['BaseResource'] {
  /**
   * Create a ManagementAssociationProperties.
   * @member {string} applicationId The applicationId of the appliance for this
   * association.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ManagementAssociationProperties
   *
   * @returns {object} metadata of ManagementAssociationProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ManagementAssociationProperties',
      type: {
        name: 'Composite',
        className: 'ManagementAssociationProperties',
        modelProperties: {
          applicationId: {
            required: true,
            serializedName: 'applicationId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ManagementAssociationProperties;
