/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Error definition.
 *
 */
class ErrorDefinition {
  /**
   * Create a ErrorDefinition.
   * @property {string} [code] Service specific error code which serves as the
   * substatus for the HTTP error code.
   * @property {string} [message] Description of the error.
   * @property {string} [target] The target of the error.
   * @property {array} [details] Internal error details.
   * @property {array} [additionalInfo] Additional scenario specific error
   * details.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorDefinition
   *
   * @returns {object} metadata of ErrorDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ErrorDefinition',
      type: {
        name: 'Composite',
        className: 'ErrorDefinition',
        modelProperties: {
          code: {
            required: false,
            readOnly: true,
            serializedName: 'code',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            readOnly: true,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          },
          target: {
            required: false,
            readOnly: true,
            serializedName: 'target',
            type: {
              name: 'String'
            }
          },
          details: {
            required: false,
            readOnly: true,
            serializedName: 'details',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'ErrorDefinitionElementType',
                  type: {
                    name: 'Composite',
                    className: 'ErrorDefinition'
                  }
              }
            }
          },
          additionalInfo: {
            required: false,
            readOnly: true,
            serializedName: 'additionalInfo',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'TypedErrorInfoElementType',
                  type: {
                    name: 'Composite',
                    className: 'TypedErrorInfo'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorDefinition;
