/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Error response.
 *
 */
class ErrorResponse {
  /**
   * Create a ErrorResponse.
   * @property {object} [error] The error details.
   * @property {string} [error.code] Service specific error code which serves
   * as the substatus for the HTTP error code.
   * @property {string} [error.message] Description of the error.
   * @property {string} [error.target] The target of the error.
   * @property {array} [error.details] Internal error details.
   * @property {array} [error.additionalInfo] Additional scenario specific
   * error details.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ErrorResponse
   *
   * @returns {object} metadata of ErrorResponse
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ErrorResponse',
      type: {
        name: 'Composite',
        className: 'ErrorResponse',
        modelProperties: {
          error: {
            required: false,
            serializedName: 'error',
            type: {
              name: 'Composite',
              className: 'ErrorDefinition'
            }
          }
        }
      }
    };
  }
}

module.exports = ErrorResponse;
