/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Additional information on Azure Workload for SQL specific backup item.
 *
 */
class AzureVmWorkloadProtectedItemExtendedInfo {
  /**
   * Create a AzureVmWorkloadProtectedItemExtendedInfo.
   * @member {date} [oldestRecoveryPoint] The oldest backup copy available for
   * this backup item.
   * @member {number} [recoveryPointCount] Number of backup copies available
   * for this backup item.
   * @member {string} [policyState] Indicates consistency of policy object and
   * policy applied to this backup item.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureVmWorkloadProtectedItemExtendedInfo
   *
   * @returns {object} metadata of AzureVmWorkloadProtectedItemExtendedInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureVmWorkloadProtectedItemExtendedInfo',
      type: {
        name: 'Composite',
        className: 'AzureVmWorkloadProtectedItemExtendedInfo',
        modelProperties: {
          oldestRecoveryPoint: {
            required: false,
            serializedName: 'oldestRecoveryPoint',
            type: {
              name: 'DateTime'
            }
          },
          recoveryPointCount: {
            required: false,
            serializedName: 'recoveryPointCount',
            type: {
              name: 'Number'
            }
          },
          policyState: {
            required: false,
            serializedName: 'policyState',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureVmWorkloadProtectedItemExtendedInfo;
