/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * AzureWorkload SQL -specific restore. Specifically for PointInTime/Log
 * restore
 *
 * @extends models['AzureWorkloadSQLRestoreRequest']
 */
class AzureWorkloadSQLPointInTimeRestoreRequest extends models['AzureWorkloadSQLRestoreRequest'] {
  /**
   * Create a AzureWorkloadSQLPointInTimeRestoreRequest.
   * @member {date} [pointInTime] PointInTime value
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureWorkloadSQLPointInTimeRestoreRequest
   *
   * @returns {object} metadata of AzureWorkloadSQLPointInTimeRestoreRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureWorkloadSQLPointInTimeRestoreRequest',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'objectType',
          clientName: 'objectType'
        },
        uberParent: 'RestoreRequest',
        className: 'AzureWorkloadSQLPointInTimeRestoreRequest',
        modelProperties: {
          objectType: {
            required: true,
            serializedName: 'objectType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          recoveryType: {
            required: false,
            serializedName: 'recoveryType',
            type: {
              name: 'String'
            }
          },
          sourceResourceId: {
            required: false,
            serializedName: 'sourceResourceId',
            type: {
              name: 'String'
            }
          },
          propertyBag: {
            required: false,
            serializedName: 'propertyBag',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          shouldUseAlternateTargetLocation: {
            required: false,
            serializedName: 'shouldUseAlternateTargetLocation',
            type: {
              name: 'Boolean'
            }
          },
          isNonRecoverable: {
            required: false,
            serializedName: 'isNonRecoverable',
            type: {
              name: 'Boolean'
            }
          },
          targetInfo: {
            required: false,
            serializedName: 'targetInfo',
            type: {
              name: 'Composite',
              className: 'TargetRestoreInfo'
            }
          },
          alternateDirectoryPaths: {
            required: false,
            serializedName: 'alternateDirectoryPaths',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SQLDataDirectoryMappingElementType',
                  type: {
                    name: 'Composite',
                    className: 'SQLDataDirectoryMapping'
                  }
              }
            }
          },
          pointInTime: {
            required: false,
            serializedName: 'pointInTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureWorkloadSQLPointInTimeRestoreRequest;
