/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Extended info class details
 *
 */
class AzureWorkloadSQLRecoveryPointExtendedInfo {
  /**
   * Create a AzureWorkloadSQLRecoveryPointExtendedInfo.
   * @member {date} [dataDirectoryTimeInUTC] UTC time at which data directory
   * info was captured
   * @member {array} [dataDirectoryPaths] List of data directory paths during
   * restore operation.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AzureWorkloadSQLRecoveryPointExtendedInfo
   *
   * @returns {object} metadata of AzureWorkloadSQLRecoveryPointExtendedInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureWorkloadSQLRecoveryPointExtendedInfo',
      type: {
        name: 'Composite',
        className: 'AzureWorkloadSQLRecoveryPointExtendedInfo',
        modelProperties: {
          dataDirectoryTimeInUTC: {
            required: false,
            serializedName: 'dataDirectoryTimeInUTC',
            type: {
              name: 'DateTime'
            }
          },
          dataDirectoryPaths: {
            required: false,
            serializedName: 'dataDirectoryPaths',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SQLDataDirectoryElementType',
                  type: {
                    name: 'Composite',
                    className: 'SQLDataDirectory'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AzureWorkloadSQLRecoveryPointExtendedInfo;
