/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Protectable Container Class.
 *
 */
class ProtectableContainer {
  /**
   * Create a ProtectableContainer.
   * @member {string} [friendlyName] Friendly name of the container.
   * @member {string} [backupManagementType] Type of backup managemenent for
   * the container. Possible values include: 'Invalid', 'AzureIaasVM', 'MAB',
   * 'DPM', 'AzureBackupServer', 'AzureSql', 'AzureStorage', 'AzureWorkload',
   * 'DefaultBackup'
   * @member {string} [healthStatus] Status of health of the container.
   * @member {string} [containerId] Fabric Id of the container such as ARM Id.
   * @member {string} protectableContainerType Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of ProtectableContainer
   *
   * @returns {object} metadata of ProtectableContainer
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProtectableContainer',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'protectableContainerType',
          clientName: 'protectableContainerType'
        },
        uberParent: 'ProtectableContainer',
        className: 'ProtectableContainer',
        modelProperties: {
          friendlyName: {
            required: false,
            serializedName: 'friendlyName',
            type: {
              name: 'String'
            }
          },
          backupManagementType: {
            required: false,
            serializedName: 'backupManagementType',
            type: {
              name: 'String'
            }
          },
          healthStatus: {
            required: false,
            serializedName: 'healthStatus',
            type: {
              name: 'String'
            }
          },
          containerId: {
            required: false,
            serializedName: 'containerId',
            type: {
              name: 'String'
            }
          },
          protectableContainerType: {
            required: true,
            serializedName: 'protectableContainerType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ProtectableContainer;
