/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * AzureRestoreValidation request.
 *
 * @extends models['ValidateOperationRequest']
 */
class ValidateRestoreOperationRequest extends models['ValidateOperationRequest'] {
  /**
   * Create a ValidateRestoreOperationRequest.
   * @member {object} [restoreRequest] Sets restore request to be validated
   * @member {string} [restoreRequest.objectType] Polymorphic Discriminator
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ValidateRestoreOperationRequest
   *
   * @returns {object} metadata of ValidateRestoreOperationRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ValidateRestoreOperationRequest',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'objectType',
          clientName: 'objectType'
        },
        uberParent: 'ValidateOperationRequest',
        className: 'ValidateRestoreOperationRequest',
        modelProperties: {
          objectType: {
            required: true,
            serializedName: 'objectType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          restoreRequest: {
            required: false,
            serializedName: 'restoreRequest',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'objectType',
                clientName: 'objectType'
              },
              uberParent: 'RestoreRequest',
              className: 'RestoreRequest'
            }
          }
        }
      }
    };
  }
}

module.exports = ValidateRestoreOperationRequest;
