/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A2A update protection container mapping.
 *
 * @extends models['ReplicationProviderSpecificUpdateContainerMappingInput']
 */
class A2AUpdateContainerMappingInput extends models['ReplicationProviderSpecificUpdateContainerMappingInput'] {
  /**
   * Create a A2AUpdateContainerMappingInput.
   * @member {string} [agentAutoUpdateStatus] A value indicating whether the
   * auto update is enabled. Possible values include: 'Disabled', 'Enabled'
   * @member {string} [automationAccountArmId] The automation account arm id.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of A2AUpdateContainerMappingInput
   *
   * @returns {object} metadata of A2AUpdateContainerMappingInput
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'A2A',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'instanceType',
          clientName: 'instanceType'
        },
        uberParent: 'ReplicationProviderSpecificUpdateContainerMappingInput',
        className: 'A2AUpdateContainerMappingInput',
        modelProperties: {
          instanceType: {
            required: true,
            serializedName: 'instanceType',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          agentAutoUpdateStatus: {
            required: false,
            serializedName: 'agentAutoUpdateStatus',
            type: {
              name: 'String'
            }
          },
          automationAccountArmId: {
            required: false,
            serializedName: 'automationAccountArmId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = A2AUpdateContainerMappingInput;
