/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Query parameter to enumerate protected items.
 *
 */
class ProtectedItemsQueryParameter {
  /**
   * Create a ProtectedItemsQueryParameter.
   * @member {string} [sourceFabricName] The source fabric name filter.
   * @member {string} [recoveryPlanName] The recovery plan filter.
   * @member {string} [vCenterName] The vCenter name filter.
   * @member {string} [instanceType] The replication provider type.
   * @member {string} [multiVmGroupCreateOption] Whether Multi VM group is auto
   * created or specified by user. Possible values include: 'AutoCreated',
   * 'UserSpecified'
   */
  constructor() {
  }

  /**
   * Defines the metadata of ProtectedItemsQueryParameter
   *
   * @returns {object} metadata of ProtectedItemsQueryParameter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProtectedItemsQueryParameter',
      type: {
        name: 'Composite',
        className: 'ProtectedItemsQueryParameter',
        modelProperties: {
          sourceFabricName: {
            required: false,
            serializedName: 'sourceFabricName',
            type: {
              name: 'String'
            }
          },
          recoveryPlanName: {
            required: false,
            serializedName: 'recoveryPlanName',
            type: {
              name: 'String'
            }
          },
          vCenterName: {
            required: false,
            serializedName: 'vCenterName',
            type: {
              name: 'String'
            }
          },
          instanceType: {
            required: false,
            serializedName: 'instanceType',
            type: {
              name: 'String'
            }
          },
          multiVmGroupCreateOption: {
            required: false,
            serializedName: 'multiVmGroupCreateOption',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ProtectedItemsQueryParameter;
