/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a ExtendedStatusInfo.
 */
class ExtendedStatusInfo {
  /**
   * Create a ExtendedStatusInfo.
   * @property {string} [statusCode] Possible values include: 'None',
   * 'Pending', 'Active', 'PurchaseError', 'PaymentInstrumentError', 'Split',
   * 'Merged', 'Expired', 'Succeeded'
   * @property {string} [message] The message giving detailed information about
   * the status code.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExtendedStatusInfo
   *
   * @returns {object} metadata of ExtendedStatusInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExtendedStatusInfo',
      type: {
        name: 'Composite',
        className: 'ExtendedStatusInfo',
        modelProperties: {
          statusCode: {
            required: false,
            serializedName: 'statusCode',
            type: {
              name: 'String'
            }
          },
          message: {
            required: false,
            serializedName: 'message',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ExtendedStatusInfo;
