/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * @summary The external security solution properties for ATA solutions
  *
 * @extends models['ExternalSecuritySolutionProperties']
 */
class AtaSolutionProperties extends models['ExternalSecuritySolutionProperties'] {
  /**
   * Create a AtaSolutionProperties.
   * @member {string} [lastEventReceived]
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AtaSolutionProperties
   *
   * @returns {object} metadata of AtaSolutionProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AtaSolutionProperties',
      type: {
        name: 'Composite',
        className: 'AtaSolutionProperties',
        modelProperties: {
          deviceVendor: {
            required: false,
            serializedName: 'deviceVendor',
            type: {
              name: 'String'
            }
          },
          deviceType: {
            required: false,
            serializedName: 'deviceType',
            type: {
              name: 'String'
            }
          },
          workspace: {
            required: false,
            serializedName: 'workspace',
            type: {
              name: 'Composite',
              className: 'ConnectedWorkspace'
            }
          },
          lastEventReceived: {
            required: false,
            serializedName: 'lastEventReceived',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AtaSolutionProperties;
