/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a DiscoveredSecuritySolution.
 */
class DiscoveredSecuritySolution {
  /**
   * Create a DiscoveredSecuritySolution.
   * @member {string} [id] Resource Id
   * @member {string} [name] Resource name
   * @member {string} [type] Resource type
   * @member {string} [location] Location where the resource is stored
   * @member {string} securityFamily The security family of the discovered
   * solution. Possible values include: 'Waf', 'Ngfw', 'SaasWaf', 'Va'
   * @member {string} offer The security solutions' image offer
   * @member {string} publisher The security solutions' image publisher
   * @member {string} sku The security solutions' image sku
   */
  constructor() {
  }

  /**
   * Defines the metadata of DiscoveredSecuritySolution
   *
   * @returns {object} metadata of DiscoveredSecuritySolution
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DiscoveredSecuritySolution',
      type: {
        name: 'Composite',
        className: 'DiscoveredSecuritySolution',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          location: {
            required: false,
            readOnly: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          securityFamily: {
            required: true,
            serializedName: 'properties.securityFamily',
            type: {
              name: 'String'
            }
          },
          offer: {
            required: true,
            serializedName: 'properties.offer',
            type: {
              name: 'String'
            }
          },
          publisher: {
            required: true,
            serializedName: 'properties.publisher',
            type: {
              name: 'String'
            }
          },
          sku: {
            required: true,
            serializedName: 'properties.sku',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DiscoveredSecuritySolution;
