/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The solution properties (correspond to the solution kind)
 *
 */
class ExternalSecuritySolutionProperties {
  /**
   * Create a ExternalSecuritySolutionProperties.
   * @member {string} [deviceVendor]
   * @member {string} [deviceType]
   * @member {object} [workspace]
   * @member {string} [workspace.id] Azure resource ID of the connected OMS
   * workspace
   */
  constructor() {
  }

  /**
   * Defines the metadata of ExternalSecuritySolutionProperties
   *
   * @returns {object} metadata of ExternalSecuritySolutionProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ExternalSecuritySolutionProperties',
      type: {
        name: 'Composite',
        additionalProperties: {
          type: {
            name: 'Dictionary',
            value: {
                required: false,
                serializedName: 'ObjectElementType',
                type: {
                  name: 'Object'
                }
            }
          }
        },
        className: 'ExternalSecuritySolutionProperties',
        modelProperties: {
          deviceVendor: {
            required: false,
            serializedName: 'deviceVendor',
            type: {
              name: 'String'
            }
          },
          deviceType: {
            required: false,
            serializedName: 'deviceType',
            type: {
              name: 'String'
            }
          },
          workspace: {
            required: false,
            serializedName: 'workspace',
            type: {
              name: 'Composite',
              className: 'ConnectedWorkspace'
            }
          }
        }
      }
    };
  }
}

module.exports = ExternalSecuritySolutionProperties;
