/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.Resource = require('./resource');
exports.Kind = require('./kind');
exports.SecurityContact = require('./securityContact');
exports.Pricing = require('./pricing');
exports.WorkspaceSetting = require('./workspaceSetting');
exports.AutoProvisioningSetting = require('./autoProvisioningSetting');
exports.ComplianceSegment = require('./complianceSegment');
exports.Compliance = require('./compliance');
exports.AdvancedThreatProtectionSetting = require('./advancedThreatProtectionSetting');
exports.Setting = require('./setting');
exports.DataExportSetting = require('./dataExportSetting');
exports.SettingKind1 = require('./settingKind1');
exports.SensitivityLabel = require('./sensitivityLabel');
exports.InformationProtectionKeyword = require('./informationProtectionKeyword');
exports.InformationType = require('./informationType');
exports.InformationProtectionPolicy = require('./informationProtectionPolicy');
exports.Location = require('./location');
exports.OperationDisplay = require('./operationDisplay');
exports.Operation = require('./operation');
exports.SecurityTaskParameters = require('./securityTaskParameters');
exports.SecurityTask = require('./securityTask');
exports.AscLocation = require('./ascLocation');
exports.AlertEntity = require('./alertEntity');
exports.AlertConfidenceReason = require('./alertConfidenceReason');
exports.Alert = require('./alert');
exports.DiscoveredSecuritySolution = require('./discoveredSecuritySolution');
exports.TopologySingleResourceParent = require('./topologySingleResourceParent');
exports.TopologySingleResourceChild = require('./topologySingleResourceChild');
exports.TopologySingleResource = require('./topologySingleResource');
exports.TopologyResource = require('./topologyResource');
exports.JitNetworkAccessPortRule = require('./jitNetworkAccessPortRule');
exports.JitNetworkAccessPolicyVirtualMachine = require('./jitNetworkAccessPolicyVirtualMachine');
exports.JitNetworkAccessRequestPort = require('./jitNetworkAccessRequestPort');
exports.JitNetworkAccessRequestVirtualMachine = require('./jitNetworkAccessRequestVirtualMachine');
exports.JitNetworkAccessRequest = require('./jitNetworkAccessRequest');
exports.JitNetworkAccessPolicy = require('./jitNetworkAccessPolicy');
exports.JitNetworkAccessPolicyInitiatePort = require('./jitNetworkAccessPolicyInitiatePort');
exports.JitNetworkAccessPolicyInitiateVirtualMachine = require('./jitNetworkAccessPolicyInitiateVirtualMachine');
exports.JitNetworkAccessPolicyInitiateRequest = require('./jitNetworkAccessPolicyInitiateRequest');
exports.ExternalSecuritySolution = require('./externalSecuritySolution');
exports.ExternalSecuritySolutionProperties = require('./externalSecuritySolutionProperties');
exports.CefSolutionProperties = require('./cefSolutionProperties');
exports.CefExternalSecuritySolution = require('./cefExternalSecuritySolution');
exports.AtaSolutionProperties = require('./ataSolutionProperties');
exports.AtaExternalSecuritySolution = require('./ataExternalSecuritySolution');
exports.ConnectedWorkspace = require('./connectedWorkspace');
exports.AadSolutionProperties = require('./aadSolutionProperties');
exports.AadExternalSecuritySolution = require('./aadExternalSecuritySolution');
exports.ExternalSecuritySolutionKind1 = require('./externalSecuritySolutionKind1');
exports.AadConnectivityState1 = require('./aadConnectivityState1');
exports.ConnectedResource = require('./connectedResource');
exports.ConnectableResource = require('./connectableResource');
exports.AllowedConnectionsResource = require('./allowedConnectionsResource');
exports.PricingList = require('./pricingList');
exports.SecurityContactList = require('./securityContactList');
exports.WorkspaceSettingList = require('./workspaceSettingList');
exports.AutoProvisioningSettingList = require('./autoProvisioningSettingList');
exports.ComplianceList = require('./complianceList');
exports.SettingsList = require('./settingsList');
exports.InformationProtectionPolicyList = require('./informationProtectionPolicyList');
exports.OperationList = require('./operationList');
exports.AscLocationList = require('./ascLocationList');
exports.SecurityTaskList = require('./securityTaskList');
exports.AlertList = require('./alertList');
exports.DiscoveredSecuritySolutionList = require('./discoveredSecuritySolutionList');
exports.JitNetworkAccessPoliciesList = require('./jitNetworkAccessPoliciesList');
exports.ExternalSecuritySolutionList = require('./externalSecuritySolutionList');
exports.TopologyList = require('./topologyList');
exports.AllowedConnectionsList = require('./allowedConnectionsList');
exports.discriminators = {
  'Setting' : exports.Setting,
  'Setting.DataExportSetting' : exports.DataExportSetting,
  'ExternalSecuritySolution' : exports.ExternalSecuritySolution,
  'ExternalSecuritySolution.CEF' : exports.CefExternalSecuritySolution,
  'ExternalSecuritySolution.ATA' : exports.AtaExternalSecuritySolution,
  'ExternalSecuritySolution.AAD' : exports.AadExternalSecuritySolution
};
