/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a JitNetworkAccessPolicyVirtualMachine.
 */
class JitNetworkAccessPolicyVirtualMachine {
  /**
   * Create a JitNetworkAccessPolicyVirtualMachine.
   * @member {string} id Resource ID of the virtual machine that is linked to
   * this policy
   * @member {array} ports Port configurations for the virtual machine
   */
  constructor() {
  }

  /**
   * Defines the metadata of JitNetworkAccessPolicyVirtualMachine
   *
   * @returns {object} metadata of JitNetworkAccessPolicyVirtualMachine
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JitNetworkAccessPolicyVirtualMachine',
      type: {
        name: 'Composite',
        className: 'JitNetworkAccessPolicyVirtualMachine',
        modelProperties: {
          id: {
            required: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          ports: {
            required: true,
            serializedName: 'ports',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'JitNetworkAccessPortRuleElementType',
                  type: {
                    name: 'Composite',
                    className: 'JitNetworkAccessPortRule'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = JitNetworkAccessPolicyVirtualMachine;
