/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Pricing tier will be applied for the scope based on the resource ID
 *
 * @extends models['Resource']
 */
class Pricing extends models['Resource'] {
  /**
   * Create a Pricing.
   * @member {string} pricingTier Pricing tier type. Possible values include:
   * 'Free', 'Standard'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of Pricing
   *
   * @returns {object} metadata of Pricing
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Pricing',
      type: {
        name: 'Composite',
        className: 'Pricing',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          pricingTier: {
            required: true,
            serializedName: 'properties.pricingTier',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Pricing;
