/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Configures where to store the OMS agent data for workspaces under a scope
 *
 * @extends models['Resource']
 */
class WorkspaceSetting extends models['Resource'] {
  /**
   * Create a WorkspaceSetting.
   * @member {string} workspaceId The full Azure ID of the workspace to save
   * the data in
   * @member {string} scope All the VMs in this scope will send their security
   * data to the mentioned workspace unless overridden by a setting with more
   * specific scope
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of WorkspaceSetting
   *
   * @returns {object} metadata of WorkspaceSetting
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WorkspaceSetting',
      type: {
        name: 'Composite',
        className: 'WorkspaceSetting',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          workspaceId: {
            required: true,
            serializedName: 'properties.workspaceId',
            type: {
              name: 'String'
            }
          },
          scope: {
            required: true,
            serializedName: 'properties.scope',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WorkspaceSetting;
