/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes the parameters for Azure blob store used for storing and
 * enumerating backups.
 *
 * @extends models['BackupStorageDescription']
 */
class AzureBlobBackupStorageDescription extends models['BackupStorageDescription'] {
  /**
   * Create a AzureBlobBackupStorageDescription.
   * @property {string} connectionString The connection string to connect to
   * the Azure blob store.
   * @property {string} containerName The name of the container in the blob
   * store to store and enumerate backups from.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of AzureBlobBackupStorageDescription
   *
   * @returns {object} metadata of AzureBlobBackupStorageDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AzureBlobStore',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'StorageKind',
          clientName: 'storageKind'
        },
        uberParent: 'BackupStorageDescription',
        className: 'AzureBlobBackupStorageDescription',
        modelProperties: {
          friendlyName: {
            required: false,
            serializedName: 'FriendlyName',
            type: {
              name: 'String'
            }
          },
          storageKind: {
            required: true,
            serializedName: 'StorageKind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          connectionString: {
            required: true,
            serializedName: 'ConnectionString',
            type: {
              name: 'String'
            }
          },
          containerName: {
            required: true,
            serializedName: 'ContainerName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = AzureBlobBackupStorageDescription;
