/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the parameters for the backup storage.
 *
 */
class BackupStorageDescription {
  /**
   * Create a BackupStorageDescription.
   * @property {string} [friendlyName] Friendly name for this backup storage.
   * @property {string} storageKind Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of BackupStorageDescription
   *
   * @returns {object} metadata of BackupStorageDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackupStorageDescription',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'StorageKind',
          clientName: 'storageKind'
        },
        uberParent: 'BackupStorageDescription',
        className: 'BackupStorageDescription',
        modelProperties: {
          friendlyName: {
            required: false,
            serializedName: 'FriendlyName',
            type: {
              name: 'String'
            }
          },
          storageKind: {
            required: true,
            serializedName: 'StorageKind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = BackupStorageDescription;
