/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Describes a Service Fabric property value of type Binary.
 *
 * @extends models['PropertyValue']
 */
class BinaryPropertyValue extends models['PropertyValue'] {
  /**
   * Create a BinaryPropertyValue.
   * @property {array} data Array of bytes to be sent as an integer array. Each
   * element of array is a number between 0 and 255.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BinaryPropertyValue
   *
   * @returns {object} metadata of BinaryPropertyValue
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Binary',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'PropertyValue',
        className: 'BinaryPropertyValue',
        modelProperties: {
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          data: {
            required: true,
            serializedName: 'Data',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'NumberElementType',
                  type: {
                    name: 'Number'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = BinaryPropertyValue;
