/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Chaos Restart Code Package Fault Completed event.
 *
 * @extends models['ApplicationEvent']
 */
class ChaosRestartCodePackageFaultCompletedEvent extends models['ApplicationEvent'] {
  /**
   * Create a ChaosRestartCodePackageFaultCompletedEvent.
   * @property {uuid} faultGroupId Id of fault group.
   * @property {uuid} faultId Id of fault.
   * @property {string} nodeName The name of a Service Fabric node.
   * @property {string} serviceManifestName Service manifest name.
   * @property {string} codePackageName Code package name.
   * @property {string} servicePackageActivationId Id of Service package
   * activation.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ChaosRestartCodePackageFaultCompletedEvent
   *
   * @returns {object} metadata of ChaosRestartCodePackageFaultCompletedEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ChaosRestartCodePackageFaultCompleted',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'FabricEvent',
        className: 'ChaosRestartCodePackageFaultCompletedEvent',
        modelProperties: {
          eventInstanceId: {
            required: true,
            serializedName: 'EventInstanceId',
            type: {
              name: 'String'
            }
          },
          timeStamp: {
            required: true,
            serializedName: 'TimeStamp',
            type: {
              name: 'DateTime'
            }
          },
          hasCorrelatedEvents: {
            required: false,
            serializedName: 'HasCorrelatedEvents',
            type: {
              name: 'Boolean'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          applicationId: {
            required: true,
            serializedName: 'ApplicationId',
            type: {
              name: 'String'
            }
          },
          faultGroupId: {
            required: true,
            serializedName: 'FaultGroupId',
            type: {
              name: 'String'
            }
          },
          faultId: {
            required: true,
            serializedName: 'FaultId',
            type: {
              name: 'String'
            }
          },
          nodeName: {
            required: true,
            serializedName: 'NodeName',
            type: {
              name: 'String'
            }
          },
          serviceManifestName: {
            required: true,
            serializedName: 'ServiceManifestName',
            type: {
              name: 'String'
            }
          },
          codePackageName: {
            required: true,
            serializedName: 'CodePackageName',
            type: {
              name: 'String'
            }
          },
          servicePackageActivationId: {
            required: true,
            serializedName: 'ServicePackageActivationId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ChaosRestartCodePackageFaultCompletedEvent;
