/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Cluster Upgrade Domain Complete event.
 *
 * @extends models['ClusterEvent']
 */
class ClusterUpgradeDomainCompleteEvent extends models['ClusterEvent'] {
  /**
   * Create a ClusterUpgradeDomainCompleteEvent.
   * @property {string} targetClusterVersion Target Cluster version.
   * @property {string} upgradeState State of upgrade.
   * @property {string} upgradeDomains Upgrade domains.
   * @property {number} upgradeDomainElapsedTimeInMs Duration of domain upgrade
   * in milli-seconds.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ClusterUpgradeDomainCompleteEvent
   *
   * @returns {object} metadata of ClusterUpgradeDomainCompleteEvent
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ClusterUpgradeDomainComplete',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'FabricEvent',
        className: 'ClusterUpgradeDomainCompleteEvent',
        modelProperties: {
          eventInstanceId: {
            required: true,
            serializedName: 'EventInstanceId',
            type: {
              name: 'String'
            }
          },
          timeStamp: {
            required: true,
            serializedName: 'TimeStamp',
            type: {
              name: 'DateTime'
            }
          },
          hasCorrelatedEvents: {
            required: false,
            serializedName: 'HasCorrelatedEvents',
            type: {
              name: 'Boolean'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          targetClusterVersion: {
            required: true,
            serializedName: 'TargetClusterVersion',
            type: {
              name: 'String'
            }
          },
          upgradeState: {
            required: true,
            serializedName: 'UpgradeState',
            type: {
              name: 'String'
            }
          },
          upgradeDomains: {
            required: true,
            serializedName: 'UpgradeDomains',
            type: {
              name: 'String'
            }
          },
          upgradeDomainElapsedTimeInMs: {
            required: true,
            serializedName: 'UpgradeDomainElapsedTimeInMs',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ClusterUpgradeDomainCompleteEvent;
