/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Container API result.
 *
 */
class ContainerApiResult {
  /**
   * Create a ContainerApiResult.
   * @property {number} status HTTP status code returned by the target
   * container API
   * @property {string} [contentType] HTTP content type
   * @property {string} [contentEncoding] HTTP content encoding
   * @property {string} [body] container API result body
   */
  constructor() {
  }

  /**
   * Defines the metadata of ContainerApiResult
   *
   * @returns {object} metadata of ContainerApiResult
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ContainerApiResult',
      type: {
        name: 'Composite',
        className: 'ContainerApiResult',
        modelProperties: {
          status: {
            required: true,
            serializedName: 'Status',
            type: {
              name: 'Number'
            }
          },
          contentType: {
            required: false,
            serializedName: 'Content-Type',
            type: {
              name: 'String'
            }
          },
          contentEncoding: {
            required: false,
            serializedName: 'Content-Encoding',
            type: {
              name: 'String'
            }
          },
          body: {
            required: false,
            serializedName: 'Body',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ContainerApiResult;
