/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines description for creating a Service Fabric compose deployment.
 *
 */
class CreateComposeDeploymentDescription {
  /**
   * Create a CreateComposeDeploymentDescription.
   * @property {string} deploymentName The name of the deployment.
   * @property {string} composeFileContent The content of the compose file that
   * describes the deployment to create.
   * @property {object} [registryCredential] Credential information to connect
   * to container registry.
   * @property {string} [registryCredential.registryUserName] The user name to
   * connect to container registry.
   * @property {string} [registryCredential.registryPassword] The password for
   * supplied username to connect to container registry.
   * @property {boolean} [registryCredential.passwordEncrypted] Indicates that
   * supplied container registry password is encrypted.
   */
  constructor() {
  }

  /**
   * Defines the metadata of CreateComposeDeploymentDescription
   *
   * @returns {object} metadata of CreateComposeDeploymentDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'CreateComposeDeploymentDescription',
      type: {
        name: 'Composite',
        className: 'CreateComposeDeploymentDescription',
        modelProperties: {
          deploymentName: {
            required: true,
            serializedName: 'DeploymentName',
            type: {
              name: 'String'
            }
          },
          composeFileContent: {
            required: true,
            serializedName: 'ComposeFileContent',
            type: {
              name: 'String'
            }
          },
          registryCredential: {
            required: false,
            serializedName: 'RegistryCredential',
            type: {
              name: 'Composite',
              className: 'RegistryCredential'
            }
          }
        }
      }
    };
  }
}

module.exports = CreateComposeDeploymentDescription;
