/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of a DiagnosticsSink.
 *
 */
class DiagnosticsSinkProperties {
  /**
   * Create a DiagnosticsSinkProperties.
   * @property {string} [name] Name of the sink. This value is referenced by
   * DiagnosticsReferenceDescription
   * @property {string} [description] A description of the sink.
   * @property {string} kind Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of DiagnosticsSinkProperties
   *
   * @returns {object} metadata of DiagnosticsSinkProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DiagnosticsSinkProperties',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'DiagnosticsSinkProperties',
        className: 'DiagnosticsSinkProperties',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DiagnosticsSinkProperties;
