/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about load reported by replica.
 *
 */
class LoadMetricReportInfo {
  /**
   * Create a LoadMetricReportInfo.
   * @property {string} [name] The name of the metric.
   * @property {number} [value] The value of the load for the metric. In future
   * releases of Service Fabric this parameter will be deprecated in favor of
   * CurrentValue.
   * @property {string} [currentValue] The double value of the load for the
   * metric.
   * @property {date} [lastReportedUtc] The UTC time when the load is reported.
   */
  constructor() {
  }

  /**
   * Defines the metadata of LoadMetricReportInfo
   *
   * @returns {object} metadata of LoadMetricReportInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'LoadMetricReportInfo',
      type: {
        name: 'Composite',
        className: 'LoadMetricReportInfo',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'Name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'Value',
            type: {
              name: 'Number'
            }
          },
          currentValue: {
            required: false,
            serializedName: 'CurrentValue',
            type: {
              name: 'String'
            }
          },
          lastReportedUtc: {
            required: false,
            serializedName: 'LastReportedUtc',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = LoadMetricReportInfo;
