/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Information about a Service Fabric container network local to a single
 * Service Fabric cluster.
 *
 * @extends models['NetworkResourceProperties']
 */
class LocalNetworkResourceProperties extends models['NetworkResourceProperties'] {
  /**
   * Create a LocalNetworkResourceProperties.
   * @property {string} [networkAddressPrefix] Address space for the local
   * container network.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of LocalNetworkResourceProperties
   *
   * @returns {object} metadata of LocalNetworkResourceProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Local',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'NetworkResourcePropertiesBase',
        className: 'LocalNetworkResourceProperties',
        modelProperties: {
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          statusDetails: {
            required: false,
            readOnly: true,
            serializedName: 'statusDetails',
            type: {
              name: 'String'
            }
          },
          networkAddressPrefix: {
            required: false,
            serializedName: 'networkAddressPrefix',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = LocalNetworkResourceProperties;
