/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Represents the type of registration or provision requested, and if the
 * operation needs to be asynchronous or not. Supported types of provision
 * operations are from either image store or external store.
 *
 */
class ProvisionApplicationTypeDescriptionBase {
  /**
   * Create a ProvisionApplicationTypeDescriptionBase.
   * @property {boolean} async Indicates whether or not provisioning should
   * occur asynchronously. When set to true, the provision operation returns
   * when the request is accepted by the system, and the provision operation
   * continues without any timeout limit. The default value is false. For large
   * application packages, we recommend setting the value to true.
   * @property {string} kind Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of ProvisionApplicationTypeDescriptionBase
   *
   * @returns {object} metadata of ProvisionApplicationTypeDescriptionBase
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProvisionApplicationTypeDescriptionBase',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'ProvisionApplicationTypeDescriptionBase',
        className: 'ProvisionApplicationTypeDescriptionBase',
        modelProperties: {
          async: {
            required: true,
            serializedName: 'Async',
            type: {
              name: 'Boolean'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ProvisionApplicationTypeDescriptionBase;
