/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Puts the specified property under the specified name.
 * Note that if one PropertyBatchOperation in a PropertyBatch fails,
 * the entire batch fails and cannot be committed in a transactional manner.
 *
 * @extends models['PropertyBatchOperation']
 */
class PutPropertyBatchOperation extends models['PropertyBatchOperation'] {
  /**
   * Create a PutPropertyBatchOperation.
   * @property {object} value Describes a Service Fabric property value.
   * @property {string} [value.kind] Polymorphic Discriminator
   * @property {string} [customTypeId] The property's custom type ID. Using
   * this property, the user is able to tag the type of the value of the
   * property.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of PutPropertyBatchOperation
   *
   * @returns {object} metadata of PutPropertyBatchOperation
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Put',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'PropertyBatchOperation',
        className: 'PutPropertyBatchOperation',
        modelProperties: {
          propertyName: {
            required: true,
            serializedName: 'PropertyName',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'Value',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'Kind',
                clientName: 'kind'
              },
              uberParent: 'PropertyValue',
              className: 'PropertyValue'
            }
          },
          customTypeId: {
            required: false,
            serializedName: 'CustomTypeId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PutPropertyBatchOperation;
