/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This type describes the resource limits for a given container. It describes
 * the most amount of resources a container is allowed to use before being
 * restarted.
 *
 */
class ResourceLimits {
  /**
   * Create a ResourceLimits.
   * @property {number} [memoryInGB] The memory limit in GB.
   * @property {number} [cpu] CPU limits in cores. At present, only full cores
   * are supported.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceLimits
   *
   * @returns {object} metadata of ResourceLimits
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceLimits',
      type: {
        name: 'Composite',
        className: 'ResourceLimits',
        modelProperties: {
          memoryInGB: {
            required: false,
            serializedName: 'memoryInGB',
            type: {
              name: 'Number'
            }
          },
          cpu: {
            required: false,
            serializedName: 'cpu',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceLimits;
