/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Specifies the parameters needed to trigger a restore of a specific
 * partition.
 *
 */
class RestorePartitionDescription {
  /**
   * Create a RestorePartitionDescription.
   * @property {uuid} backupId Unique backup ID.
   * @property {string} backupLocation Location of the backup relative to the
   * backup storage specified/ configured.
   * @property {object} [backupStorage] Location of the backup from where the
   * partition will be restored.
   * @property {string} [backupStorage.friendlyName] Friendly name for this
   * backup storage.
   * @property {string} [backupStorage.storageKind] Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of RestorePartitionDescription
   *
   * @returns {object} metadata of RestorePartitionDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'RestorePartitionDescription',
      type: {
        name: 'Composite',
        className: 'RestorePartitionDescription',
        modelProperties: {
          backupId: {
            required: true,
            serializedName: 'BackupId',
            type: {
              name: 'String'
            }
          },
          backupLocation: {
            required: true,
            serializedName: 'BackupLocation',
            type: {
              name: 'String'
            }
          },
          backupStorage: {
            required: false,
            serializedName: 'BackupStorage',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'StorageKind',
                clientName: 'storageKind'
              },
              uberParent: 'BackupStorageDescription',
              className: 'BackupStorageDescription'
            }
          }
        }
      }
    };
  }
}

module.exports = RestorePartitionDescription;
