/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This type describes a secret resource.
 *
 */
class SecretResourceDescription {
  /**
   * Create a SecretResourceDescription.
   * @property {object} properties Describes the properties of a secret
   * resource.
   * @property {string} [properties.description] User readable description of
   * the secret.
   * @property {string} [properties.status] Status of the resource. Possible
   * values include: 'Unknown', 'Ready', 'Upgrading', 'Creating', 'Deleting',
   * 'Failed'
   * @property {string} [properties.statusDetails] Gives additional information
   * about the current status of the secret.
   * @property {string} [properties.contentType] The type of the content stored
   * in the secret value. The value of this property is opaque to Service
   * Fabric. Once set, the value of this property cannot be changed.
   * @property {string} name Name of the Secret resource.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SecretResourceDescription
   *
   * @returns {object} metadata of SecretResourceDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SecretResourceDescription',
      type: {
        name: 'Composite',
        className: 'SecretResourceDescription',
        modelProperties: {
          properties: {
            required: true,
            serializedName: 'properties',
            type: {
              name: 'Composite',
              polymorphicDiscriminator: {
                serializedName: 'kind',
                clientName: 'kind'
              },
              uberParent: 'SecretResourcePropertiesBase',
              className: 'SecretResourceProperties'
            }
          },
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SecretResourceDescription;
