/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * This type describes a value of a secret resource. The name of this resource
 * is the version identifier corresponding to this secret value.
 *
 */
class SecretValueResourceDescription {
  /**
   * Create a SecretValueResourceDescription.
   * @property {string} name Version identifier of the secret value.
   * @property {string} [value] The actual value of the secret.
   */
  constructor() {
  }

  /**
   * Defines the metadata of SecretValueResourceDescription
   *
   * @returns {object} metadata of SecretValueResourceDescription
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SecretValueResourceDescription',
      type: {
        name: 'Composite',
        className: 'SecretValueResourceDescription',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'properties.value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SecretValueResourceDescription;
