/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Backup configuration information for a specific Service Fabric service
 * specifying what backup policy is being applied and suspend description, if
 * any.
 *
 * @extends models['BackupConfigurationInfo']
 */
class ServiceBackupConfigurationInfo extends models['BackupConfigurationInfo'] {
  /**
   * Create a ServiceBackupConfigurationInfo.
   * @property {string} [serviceName] The full name of the service with
   * 'fabric:' URI scheme.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServiceBackupConfigurationInfo
   *
   * @returns {object} metadata of ServiceBackupConfigurationInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Service',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'Kind',
          clientName: 'kind'
        },
        uberParent: 'BackupConfigurationInfo',
        className: 'ServiceBackupConfigurationInfo',
        modelProperties: {
          policyName: {
            required: false,
            serializedName: 'PolicyName',
            type: {
              name: 'String'
            }
          },
          policyInheritedFrom: {
            required: false,
            serializedName: 'PolicyInheritedFrom',
            type: {
              name: 'String'
            }
          },
          suspensionInfo: {
            required: false,
            serializedName: 'SuspensionInfo',
            type: {
              name: 'Composite',
              className: 'BackupSuspensionInfo'
            }
          },
          kind: {
            required: true,
            serializedName: 'Kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          serviceName: {
            required: false,
            serializedName: 'ServiceName',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceBackupConfigurationInfo;
