/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Information about the service name.
 *
 */
class ServiceNameInfo {
  /**
   * Create a ServiceNameInfo.
   * @property {string} [id] The identity of the service. This ID is an encoded
   * representation of the service name. This is used in the REST APIs to
   * identify the service resource.
   * Starting in version 6.0, hierarchical names are delimited with the "\~"
   * character. For example, if the service name is "fabric:/myapp/app1/svc1",
   * the service identity would be "myapp~app1\~svc1" in 6.0+ and
   * "myapp/app1/svc1" in previous versions.
   * @property {string} [name] The full name of the service with 'fabric:' URI
   * scheme.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ServiceNameInfo
   *
   * @returns {object} metadata of ServiceNameInfo
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServiceNameInfo',
      type: {
        name: 'Composite',
        className: 'ServiceNameInfo',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'Id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'Name',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ServiceNameInfo;
