/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes a setting for the container. The setting file path can be fetched
 * from environment variable "Fabric_SettingPath". The path for Windows
 * container is "C:\\secrets". The path for Linux container is "/var/secrets".
 *
 */
class Setting {
  /**
   * Create a Setting.
   * @property {string} [name] The name of the setting.
   * @property {string} [value] The value of the setting.
   */
  constructor() {
  }

  /**
   * Defines the metadata of Setting
   *
   * @returns {object} metadata of Setting
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Setting',
      type: {
        name: 'Composite',
        className: 'Setting',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          value: {
            required: false,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = Setting;
