/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Defines an hour and minute of the day specified in 24 hour time.
 *
 */
class TimeOfDay {
  /**
   * Create a TimeOfDay.
   * @property {number} [hour] Represents the hour of the day. Value must be
   * between 0 and 23 inclusive.
   * @property {number} [minute] Represents the minute of the hour. Value must
   * be between 0 to 59 inclusive.
   */
  constructor() {
  }

  /**
   * Defines the metadata of TimeOfDay
   *
   * @returns {object} metadata of TimeOfDay
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TimeOfDay',
      type: {
        name: 'Composite',
        className: 'TimeOfDay',
        modelProperties: {
          hour: {
            required: false,
            serializedName: 'Hour',
            constraints: {
              InclusiveMaximum: 23,
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          },
          minute: {
            required: false,
            serializedName: 'Minute',
            constraints: {
              InclusiveMaximum: 59,
              InclusiveMinimum: 0
            },
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = TimeOfDay;
