/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the http configuration for external connectivity for this network.
 *
 */
class HttpConfig {
  /**
   * Create a HttpConfig.
   * @member {string} name http gateway config name.
   * @member {number} port Specifies the port at which the service endpoint
   * below needs to be exposed.
   * @member {array} hosts description for routing.
   */
  constructor() {
  }

  /**
   * Defines the metadata of HttpConfig
   *
   * @returns {object} metadata of HttpConfig
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'HttpConfig',
      type: {
        name: 'Composite',
        className: 'HttpConfig',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          port: {
            required: true,
            serializedName: 'port',
            type: {
              name: 'Number'
            }
          },
          hosts: {
            required: true,
            serializedName: 'hosts',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'HttpHostConfigElementType',
                  type: {
                    name: 'Composite',
                    className: 'HttpHostConfig'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = HttpConfig;
