/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

/* jshint latedef:false */
/* jshint forin:false */
/* jshint noempty:false */

'use strict';

var msRestAzure = require('ms-rest-azure');

exports.BaseResource = msRestAzure.BaseResource;
exports.CloudError = msRestAzure.CloudError;
exports.AvailableOperationDisplay = require('./availableOperationDisplay');
exports.ErrorDetailsModel = require('./errorDetailsModel');
exports.ErrorErrorModel = require('./errorErrorModel');
exports.ErrorModel = require('./errorModel');
exports.OperationResult = require('./operationResult');
exports.ProvisionedResourceProperties = require('./provisionedResourceProperties');
exports.Resource = require('./resource');
exports.ProxyResource = require('./proxyResource');
exports.ManagedProxyResource = require('./managedProxyResource');
exports.TrackedResource = require('./trackedResource');
exports.SecretResourcePropertiesBase = require('./secretResourcePropertiesBase');
exports.SecretResourceProperties = require('./secretResourceProperties');
exports.InlinedValueSecretResourceProperties = require('./inlinedValueSecretResourceProperties');
exports.SecretResourceDescription = require('./secretResourceDescription');
exports.SecretValue = require('./secretValue');
exports.SecretValueProperties = require('./secretValueProperties');
exports.SecretValueResourceDescription = require('./secretValueResourceDescription');
exports.VolumeProviderParametersAzureFile = require('./volumeProviderParametersAzureFile');
exports.VolumeProperties = require('./volumeProperties');
exports.VolumeReference = require('./volumeReference');
exports.ApplicationScopedVolumeCreationParameters = require('./applicationScopedVolumeCreationParameters');
exports.ApplicationScopedVolume = require('./applicationScopedVolume');
exports.ApplicationScopedVolumeCreationParametersServiceFabricVolumeDisk = require('./applicationScopedVolumeCreationParametersServiceFabricVolumeDisk');
exports.VolumeResourceDescription = require('./volumeResourceDescription');
exports.NetworkResourcePropertiesBase = require('./networkResourcePropertiesBase');
exports.NetworkResourceProperties = require('./networkResourceProperties');
exports.LocalNetworkResourceProperties = require('./localNetworkResourceProperties');
exports.EndpointRef = require('./endpointRef');
exports.NetworkRef = require('./networkRef');
exports.NetworkResourceDescription = require('./networkResourceDescription');
exports.GatewayDestination = require('./gatewayDestination');
exports.TcpConfig = require('./tcpConfig');
exports.HttpRouteMatchPath = require('./httpRouteMatchPath');
exports.HttpRouteMatchHeader = require('./httpRouteMatchHeader');
exports.HttpRouteMatchRule = require('./httpRouteMatchRule');
exports.HttpRouteConfig = require('./httpRouteConfig');
exports.HttpHostConfig = require('./httpHostConfig');
exports.HttpConfig = require('./httpConfig');
exports.GatewayProperties = require('./gatewayProperties');
exports.GatewayResourceDescription = require('./gatewayResourceDescription');
exports.ImageRegistryCredential = require('./imageRegistryCredential');
exports.EnvironmentVariable = require('./environmentVariable');
exports.Setting = require('./setting');
exports.ContainerLabel = require('./containerLabel');
exports.EndpointProperties = require('./endpointProperties');
exports.ResourceRequests = require('./resourceRequests');
exports.ResourceLimits = require('./resourceLimits');
exports.ResourceRequirements = require('./resourceRequirements');
exports.DiagnosticsRef = require('./diagnosticsRef');
exports.ReliableCollectionsRef = require('./reliableCollectionsRef');
exports.ContainerState = require('./containerState');
exports.ContainerEvent = require('./containerEvent');
exports.ContainerInstanceView = require('./containerInstanceView');
exports.ContainerCodePackageProperties = require('./containerCodePackageProperties');
exports.AutoScalingTrigger = require('./autoScalingTrigger');
exports.AutoScalingMechanism = require('./autoScalingMechanism');
exports.AutoScalingPolicy = require('./autoScalingPolicy');
exports.ServiceResourceDescription = require('./serviceResourceDescription');
exports.DiagnosticsSinkProperties = require('./diagnosticsSinkProperties');
exports.DiagnosticsDescription = require('./diagnosticsDescription');
exports.ApplicationProperties = require('./applicationProperties');
exports.AzureInternalMonitoringPipelineSinkDescription = require('./azureInternalMonitoringPipelineSinkDescription');
exports.ApplicationResourceDescription = require('./applicationResourceDescription');
exports.AddRemoveReplicaScalingMechanism = require('./addRemoveReplicaScalingMechanism');
exports.AutoScalingMetric = require('./autoScalingMetric');
exports.AutoScalingResourceMetric = require('./autoScalingResourceMetric');
exports.ServiceProperties = require('./serviceProperties');
exports.ServiceReplicaProperties = require('./serviceReplicaProperties');
exports.ServiceReplicaDescription = require('./serviceReplicaDescription');
exports.AverageLoadScalingTrigger = require('./averageLoadScalingTrigger');
exports.ContainerLogs = require('./containerLogs');
exports.OperationListResult = require('./operationListResult');
exports.SecretResourceDescriptionList = require('./secretResourceDescriptionList');
exports.SecretValueResourceDescriptionList = require('./secretValueResourceDescriptionList');
exports.VolumeResourceDescriptionList = require('./volumeResourceDescriptionList');
exports.NetworkResourceDescriptionList = require('./networkResourceDescriptionList');
exports.GatewayResourceDescriptionList = require('./gatewayResourceDescriptionList');
exports.ApplicationResourceDescriptionList = require('./applicationResourceDescriptionList');
exports.ServiceResourceDescriptionList = require('./serviceResourceDescriptionList');
exports.ServiceReplicaDescriptionList = require('./serviceReplicaDescriptionList');
exports.discriminators = {
  'ProvisionedResourceProperties.SecretResourceProperties' : exports.SecretResourceProperties,
  'ProvisionedResourceProperties.inlinedValue' : exports.InlinedValueSecretResourceProperties,
  'ProvisionedResourceProperties.SecretResourcePropertiesBase' : exports.SecretResourcePropertiesBase,
  'ApplicationScopedVolumeCreationParameters' : exports.ApplicationScopedVolumeCreationParameters,
  'ApplicationScopedVolumeCreationParameters.ServiceFabricVolumeDisk' : exports.ApplicationScopedVolumeCreationParametersServiceFabricVolumeDisk,
  'ProvisionedResourceProperties.NetworkResourceProperties' : exports.NetworkResourceProperties,
  'ProvisionedResourceProperties.Local' : exports.LocalNetworkResourceProperties,
  'ProvisionedResourceProperties.NetworkResourcePropertiesBase' : exports.NetworkResourcePropertiesBase,
  'AutoScalingTrigger' : exports.AutoScalingTrigger,
  'AutoScalingMechanism' : exports.AutoScalingMechanism,
  'DiagnosticsSinkProperties' : exports.DiagnosticsSinkProperties,
  'DiagnosticsSinkProperties.AzureInternalMonitoringPipeline' : exports.AzureInternalMonitoringPipelineSinkDescription,
  'AutoScalingMechanism.AddRemoveReplica' : exports.AddRemoveReplicaScalingMechanism,
  'AutoScalingMetric' : exports.AutoScalingMetric,
  'AutoScalingMetric.Resource' : exports.AutoScalingResourceMetric,
  'AutoScalingTrigger.AverageLoad' : exports.AverageLoadScalingTrigger
};
