/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes public connectivity configuration for the network.
 *
 */
class IngressConfig {
  /**
   * Create a IngressConfig.
   * @member {string} [qosLevel] The QoS tier for ingress. Possible values
   * include: 'Bronze'
   * @member {array} [layer4] Configuration for layer4 public connectivity for
   * this network.
   * @member {string} [publicIPAddress] The public IP address for reaching this
   * network.
   */
  constructor() {
  }

  /**
   * Defines the metadata of IngressConfig
   *
   * @returns {object} metadata of IngressConfig
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'IngressConfig',
      type: {
        name: 'Composite',
        className: 'IngressConfig',
        modelProperties: {
          qosLevel: {
            required: false,
            serializedName: 'qosLevel',
            type: {
              name: 'String'
            }
          },
          layer4: {
            required: false,
            serializedName: 'layer4',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'Layer4IngressConfigElementType',
                  type: {
                    name: 'Composite',
                    className: 'Layer4IngressConfig'
                  }
              }
            }
          },
          publicIPAddress: {
            required: false,
            readOnly: true,
            serializedName: 'publicIPAddress',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = IngressConfig;
