/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes properties of a volume resource.
 *
 */
class VolumeProperties {
  /**
   * Create a VolumeProperties.
   * @member {string} [description] User readable description of the volume.
   * @member {string} [status] Status of the volume. Possible values include:
   * 'Unknown', 'Ready', 'Upgrading', 'Creating', 'Deleting', 'Failed'
   * @member {string} [statusDetails] Gives additional information about the
   * current status of the volume.
   * @member {object} [azureFileParameters] This type describes a volume
   * provided by an Azure Files file share.
   * @member {string} [azureFileParameters.accountName] Name of the Azure
   * storage account for the File Share.
   * @member {string} [azureFileParameters.accountKey] Access key of the Azure
   * storage account for the File Share.
   * @member {string} [azureFileParameters.shareName] Name of the Azure Files
   * file share that provides storage for the volume.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VolumeProperties
   *
   * @returns {object} metadata of VolumeProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VolumeProperties',
      type: {
        name: 'Composite',
        className: 'VolumeProperties',
        modelProperties: {
          description: {
            required: false,
            serializedName: 'description',
            type: {
              name: 'String'
            }
          },
          status: {
            required: false,
            readOnly: true,
            serializedName: 'status',
            type: {
              name: 'String'
            }
          },
          statusDetails: {
            required: false,
            readOnly: true,
            serializedName: 'statusDetails',
            type: {
              name: 'String'
            }
          },
          provider: {
            required: true,
            isConstant: true,
            serializedName: 'provider',
            defaultValue: 'SFAzureFile',
            type: {
              name: 'String'
            }
          },
          azureFileParameters: {
            required: false,
            serializedName: 'azureFileParameters',
            type: {
              name: 'Composite',
              className: 'VolumeProviderParametersAzureFile'
            }
          }
        }
      }
    };
  }
}

module.exports = VolumeProperties;
