/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Specifies the computation of a one hope dependency map for a list of
 * machines. The resulting map includes all direct dependencies for the
 * specified machines.
 *
 * @extends models['MultipleMachinesMapRequest']
 */
class MachineListMapRequest extends models['MultipleMachinesMapRequest'] {
  /**
   * Create a MachineListMapRequest.
   * @member {array} machineIds a list of URIs of machine resources for which
   * to generate the map.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of MachineListMapRequest
   *
   * @returns {object} metadata of MachineListMapRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'map:machine-list-dependency',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'MapRequest',
        className: 'MachineListMapRequest',
        modelProperties: {
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          },
          endTime: {
            required: false,
            serializedName: 'endTime',
            type: {
              name: 'DateTime'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          filterProcesses: {
            required: false,
            serializedName: 'filterProcesses',
            type: {
              name: 'Boolean'
            }
          },
          machineIds: {
            required: true,
            serializedName: 'machineIds',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = MachineListMapRequest;
