/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Describes the hosting configuration of a process.
 *
 */
class ProcessHostingConfiguration {
  /**
   * Create a ProcessHostingConfiguration.
   * @member {string} [provider] The hosting provider of the VM. Possible
   * values include: 'azure'
   * @member {string} kind Polymorphic Discriminator
   */
  constructor() {
  }

  /**
   * Defines the metadata of ProcessHostingConfiguration
   *
   * @returns {object} metadata of ProcessHostingConfiguration
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ProcessHostingConfiguration',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: 'kind',
          clientName: 'kind'
        },
        uberParent: 'ProcessHostingConfiguration',
        className: 'ProcessHostingConfiguration',
        modelProperties: {
          provider: {
            required: false,
            serializedName: 'provider',
            type: {
              name: 'String'
            }
          },
          kind: {
            required: true,
            serializedName: 'kind',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = ProcessHostingConfiguration;
