/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The billing information of the resource.(e.g. basic vs. standard)
 *
 */
class ResourceSku {
  /**
   * Create a ResourceSku.
   * @member {string} name The name of the SKU. This is typically a letter +
   * number code, such as A0 or P3.  Required (if sku is specified)
   * @member {string} [tier] Optional tier of this particular SKU. `Basic` is
   * deprecated, use `Standard` instead for Basic tier. Possible values
   * include: 'Free', 'Basic', 'Standard', 'Premium'
   * @member {string} [size] Optional, string. When the name field is the
   * combination of tier and some other value, this would be the standalone
   * code.
   * @member {string} [family] Optional, string. If the service has different
   * generations of hardware, for the same SKU, then that can be captured here.
   * @member {number} [capacity] Optional, integer. If the SKU supports scale
   * out/in then the capacity integer should be included. If scale out/in is
   * not
   * possible for the resource this may be omitted.
   */
  constructor() {
  }

  /**
   * Defines the metadata of ResourceSku
   *
   * @returns {object} metadata of ResourceSku
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ResourceSku',
      type: {
        name: 'Composite',
        className: 'ResourceSku',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          tier: {
            required: false,
            serializedName: 'tier',
            type: {
              name: 'String'
            }
          },
          size: {
            required: false,
            serializedName: 'size',
            type: {
              name: 'String'
            }
          },
          family: {
            required: false,
            serializedName: 'family',
            type: {
              name: 'String'
            }
          },
          capacity: {
            required: false,
            serializedName: 'capacity',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = ResourceSku;
