/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing a SpellCheck.
 * @extends models['Answer']
 */
class SpellCheck extends models['Answer'] {
  /**
   * Create a SpellCheck.
   * @property {array} flaggedTokens
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of SpellCheck
   *
   * @returns {object} metadata of SpellCheck
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'SpellCheck',
      type: {
        name: 'Composite',
        polymorphicDiscriminator: {
          serializedName: '_type',
          clientName: '_type'
        },
        uberParent: 'ResponseBase',
        className: 'SpellCheck',
        modelProperties: {
          _type: {
            required: true,
            serializedName: '_type',
            isPolymorphicDiscriminator: true,
            type: {
              name: 'String'
            }
          },
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          flaggedTokens: {
            required: true,
            serializedName: 'flaggedTokens',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'SpellingFlaggedTokenElementType',
                  type: {
                    name: 'Composite',
                    className: 'SpellingFlaggedToken'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = SpellCheck;
