/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a SpellingTokenSuggestion.
 */
class SpellingTokenSuggestion {
  /**
   * Create a SpellingTokenSuggestion.
   * @property {string} suggestion
   * @property {number} [score]
   * @property {string} [pingUrlSuffix]
   */
  constructor() {
  }

  /**
   * Defines the metadata of SpellingTokenSuggestion
   *
   * @returns {object} metadata of SpellingTokenSuggestion
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'Spelling/TokenSuggestion',
      type: {
        name: 'Composite',
        className: 'SpellingTokenSuggestion',
        modelProperties: {
          suggestion: {
            required: true,
            serializedName: 'suggestion',
            type: {
              name: 'String'
            }
          },
          score: {
            required: false,
            readOnly: true,
            serializedName: 'score',
            type: {
              name: 'Number'
            }
          },
          pingUrlSuffix: {
            required: false,
            readOnly: true,
            serializedName: 'pingUrlSuffix',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = SpellingTokenSuggestion;
