/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Automatic tuning properties for individual advisors.
 *
 */
class AutomaticTuningOptions {
  /**
   * Create a AutomaticTuningOptions.
   * @property {string} [desiredState] Automatic tuning option desired state.
   * Possible values include: 'Off', 'On', 'Default'
   * @property {string} [actualState] Automatic tuning option actual state.
   * Possible values include: 'Off', 'On'
   * @property {number} [reasonCode] Reason code if desired and actual state
   * are different.
   * @property {string} [reasonDesc] Reason description if desired and actual
   * state are different. Possible values include: 'Default', 'Disabled',
   * 'AutoConfigured', 'InheritedFromServer', 'QueryStoreOff',
   * 'QueryStoreReadOnly', 'NotSupported'
   */
  constructor() {
  }

  /**
   * Defines the metadata of AutomaticTuningOptions
   *
   * @returns {object} metadata of AutomaticTuningOptions
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AutomaticTuningOptions',
      type: {
        name: 'Composite',
        className: 'AutomaticTuningOptions',
        modelProperties: {
          desiredState: {
            required: false,
            serializedName: 'desiredState',
            type: {
              name: 'Enum',
              allowedValues: [ 'Off', 'On', 'Default' ]
            }
          },
          actualState: {
            required: false,
            readOnly: true,
            serializedName: 'actualState',
            type: {
              name: 'Enum',
              allowedValues: [ 'Off', 'On' ]
            }
          },
          reasonCode: {
            required: false,
            readOnly: true,
            serializedName: 'reasonCode',
            type: {
              name: 'Number'
            }
          },
          reasonDesc: {
            required: false,
            readOnly: true,
            serializedName: 'reasonDesc',
            type: {
              name: 'Enum',
              allowedValues: [ 'Default', 'Disabled', 'AutoConfigured', 'InheritedFromServer', 'QueryStoreOff', 'QueryStoreReadOnly', 'NotSupported' ]
            }
          }
        }
      }
    };
  }
}

module.exports = AutomaticTuningOptions;
