/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A long term retention policy.
 *
 * @extends models['ProxyResource']
 */
class BackupLongTermRetentionPolicy extends models['ProxyResource'] {
  /**
   * Create a BackupLongTermRetentionPolicy.
   * @property {string} [weeklyRetention] The weekly retention policy for an
   * LTR backup in an ISO 8601 format.
   * @property {string} [monthlyRetention] The monthly retention policy for an
   * LTR backup in an ISO 8601 format.
   * @property {string} [yearlyRetention] The yearly retention policy for an
   * LTR backup in an ISO 8601 format.
   * @property {number} [weekOfYear] The week of year to take the yearly backup
   * in an ISO 8601 format.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BackupLongTermRetentionPolicy
   *
   * @returns {object} metadata of BackupLongTermRetentionPolicy
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackupLongTermRetentionPolicy',
      type: {
        name: 'Composite',
        className: 'BackupLongTermRetentionPolicy',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          weeklyRetention: {
            required: false,
            serializedName: 'properties.weeklyRetention',
            type: {
              name: 'String'
            }
          },
          monthlyRetention: {
            required: false,
            serializedName: 'properties.monthlyRetention',
            type: {
              name: 'String'
            }
          },
          yearlyRetention: {
            required: false,
            serializedName: 'properties.yearlyRetention',
            type: {
              name: 'String'
            }
          },
          weekOfYear: {
            required: false,
            serializedName: 'properties.weekOfYear',
            type: {
              name: 'Number'
            }
          }
        }
      }
    };
  }
}

module.exports = BackupLongTermRetentionPolicy;
