/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * The action to be executed by a job step.
 *
 */
class JobStepAction {
  /**
   * Create a JobStepAction.
   * @property {string} [type] Type of action being executed by the job step.
   * Possible values include: 'TSql'. Default value: 'TSql' .
   * @property {string} [source] The source of the action to execute. Possible
   * values include: 'Inline'. Default value: 'Inline' .
   * @property {string} value The action value, for example the text of the
   * T-SQL script to execute.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobStepAction
   *
   * @returns {object} metadata of JobStepAction
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobStepAction',
      type: {
        name: 'Composite',
        className: 'JobStepAction',
        modelProperties: {
          type: {
            required: false,
            serializedName: 'type',
            defaultValue: 'TSql',
            type: {
              name: 'String'
            }
          },
          source: {
            required: false,
            serializedName: 'source',
            defaultValue: 'Inline',
            type: {
              name: 'String'
            }
          },
          value: {
            required: true,
            serializedName: 'value',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = JobStepAction;
