/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Server-level Automatic Tuning.
 *
 * @extends models['ProxyResource']
 */
class ServerAutomaticTuning extends models['ProxyResource'] {
  /**
   * Create a ServerAutomaticTuning.
   * @property {string} [desiredState] Automatic tuning desired state. Possible
   * values include: 'Custom', 'Auto', 'Unspecified'
   * @property {string} [actualState] Automatic tuning actual state. Possible
   * values include: 'Custom', 'Auto', 'Unspecified'
   * @property {object} [options] Automatic tuning options definition.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ServerAutomaticTuning
   *
   * @returns {object} metadata of ServerAutomaticTuning
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ServerAutomaticTuning',
      type: {
        name: 'Composite',
        className: 'ServerAutomaticTuning',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          desiredState: {
            required: false,
            serializedName: 'properties.desiredState',
            type: {
              name: 'Enum',
              allowedValues: [ 'Custom', 'Auto', 'Unspecified' ]
            }
          },
          actualState: {
            required: false,
            readOnly: true,
            serializedName: 'properties.actualState',
            type: {
              name: 'Enum',
              allowedValues: [ 'Custom', 'Auto', 'Unspecified' ]
            }
          },
          options: {
            required: false,
            serializedName: 'properties.options',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'AutomaticTuningServerOptionsElementType',
                  type: {
                    name: 'Composite',
                    className: 'AutomaticTuningServerOptions'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = ServerAutomaticTuning;
