/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A TDE certificate that can be uploaded into a server.
 *
 * @extends models['ProxyResource']
 */
class TdeCertificate extends models['ProxyResource'] {
  /**
   * Create a TdeCertificate.
   * @property {string} privateBlob The base64 encoded certificate private
   * blob.
   * @property {string} [certPassword] The certificate password.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of TdeCertificate
   *
   * @returns {object} metadata of TdeCertificate
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'TdeCertificate',
      type: {
        name: 'Composite',
        className: 'TdeCertificate',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          privateBlob: {
            required: true,
            serializedName: 'properties.privateBlob',
            type: {
              name: 'String'
            }
          },
          certPassword: {
            required: false,
            serializedName: 'properties.certPassword',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = TdeCertificate;
