/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A private IP address bound to the availability group listener.
 *
 */
class PrivateIPAddress {
  /**
   * Create a PrivateIPAddress.
   * @property {string} [ipAddress] Private IP address bound to the
   * availability group listener.
   * @property {string} [subnetResourceId] Subnet used to include private IP.
   */
  constructor() {
  }

  /**
   * Defines the metadata of PrivateIPAddress
   *
   * @returns {object} metadata of PrivateIPAddress
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'PrivateIPAddress',
      type: {
        name: 'Composite',
        className: 'PrivateIPAddress',
        modelProperties: {
          ipAddress: {
            required: false,
            serializedName: 'ipAddress',
            type: {
              name: 'String'
            }
          },
          subnetResourceId: {
            required: false,
            serializedName: 'subnetResourceId',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = PrivateIPAddress;
