/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Domain credentials for setting up Windows Server Failover Cluster for SQL
 * availability group.
 *
 */
class WsfcDomainCredentials {
  /**
   * Create a WsfcDomainCredentials.
   * @property {string} [clusterBootstrapAccountPassword] Cluster bootstrap
   * account password.
   * @property {string} [clusterOperatorAccountPassword] Cluster operator
   * account password.
   * @property {string} [sqlServiceAccountPassword] SQL service account
   * password.
   */
  constructor() {
  }

  /**
   * Defines the metadata of WsfcDomainCredentials
   *
   * @returns {object} metadata of WsfcDomainCredentials
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'WsfcDomainCredentials',
      type: {
        name: 'Composite',
        className: 'WsfcDomainCredentials',
        modelProperties: {
          clusterBootstrapAccountPassword: {
            required: false,
            serializedName: 'clusterBootstrapAccountPassword',
            type: {
              name: 'String'
            }
          },
          clusterOperatorAccountPassword: {
            required: false,
            serializedName: 'clusterOperatorAccountPassword',
            type: {
              name: 'String'
            }
          },
          sqlServiceAccountPassword: {
            required: false,
            serializedName: 'sqlServiceAccountPassword',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = WsfcDomainCredentials;
