/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * source at which the alert can be raised
 *
 */
class AlertSource {
  /**
   * Create a AlertSource.
   * @member {string} [name] Name of the source.
   * @member {string} [timeZone] The time zone.
   * @member {string} [alertSourceType] Source type of the alert. Possible
   * values include: 'Resource', 'Device'
   */
  constructor() {
  }

  /**
   * Defines the metadata of AlertSource
   *
   * @returns {object} metadata of AlertSource
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AlertSource',
      type: {
        name: 'Composite',
        className: 'AlertSource',
        modelProperties: {
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          timeZone: {
            required: false,
            serializedName: 'timeZone',
            type: {
              name: 'String'
            }
          },
          alertSourceType: {
            required: false,
            serializedName: 'alertSourceType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Resource', 'Device' ]
            }
          }
        }
      }
    };
  }
}

module.exports = AlertSource;
