/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The Backup Schedule Group
 *
 * @extends models['BaseModel']
 */
class BackupScheduleGroup extends models['BaseModel'] {
  /**
   * Create a BackupScheduleGroup.
   * @member {object} startTime The start time. When this field is specified we
   * will generate Default GrandFather Father Son Backup Schedules.
   * @member {number} [startTime.hour] The hour.
   * @member {number} [startTime.minute] The minute.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of BackupScheduleGroup
   *
   * @returns {object} metadata of BackupScheduleGroup
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'BackupScheduleGroup',
      type: {
        name: 'Composite',
        className: 'BackupScheduleGroup',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          startTime: {
            required: true,
            serializedName: 'properties.startTime',
            type: {
              name: 'Composite',
              className: 'Time'
            }
          }
        }
      }
    };
  }
}

module.exports = BackupScheduleGroup;
