/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The file server.
 *
 * @extends models['BaseModel']
 */
class FileServer extends models['BaseModel'] {
  /**
   * Create a FileServer.
   * @member {string} domainName Domain of the file server
   * @member {string} storageDomainId The storage domain id.
   * @member {string} backupScheduleGroupId The backup policy id.
   * @member {string} [description] The description of the file server
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of FileServer
   *
   * @returns {object} metadata of FileServer
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'FileServer',
      type: {
        name: 'Composite',
        className: 'FileServer',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          domainName: {
            required: true,
            serializedName: 'properties.domainName',
            type: {
              name: 'String'
            }
          },
          storageDomainId: {
            required: true,
            serializedName: 'properties.storageDomainId',
            type: {
              name: 'String'
            }
          },
          backupScheduleGroupId: {
            required: true,
            serializedName: 'properties.backupScheduleGroupId',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = FileServer;
