/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * The iscsi disk.
 *
 * @extends models['BaseModel']
 */
class ISCSIDisk extends models['BaseModel'] {
  /**
   * Create a ISCSIDisk.
   * @member {string} [description] The description.
   * @member {string} diskStatus The disk status. Possible values include:
   * 'Online', 'Offline'
   * @member {array} accessControlRecords The access control records.
   * @member {string} dataPolicy The data policy. Possible values include:
   * 'Invalid', 'Local', 'Tiered', 'Cloud'
   * @member {number} provisionedCapacityInBytes The provisioned capacity in
   * bytes.
   * @member {number} [usedCapacityInBytes] The used capacity in bytes.
   * @member {number} [localUsedCapacityInBytes] The local used capacity in
   * bytes.
   * @member {string} monitoringStatus The monitoring. Possible values include:
   * 'Enabled', 'Disabled'
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of ISCSIDisk
   *
   * @returns {object} metadata of ISCSIDisk
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'ISCSIDisk',
      type: {
        name: 'Composite',
        className: 'ISCSIDisk',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          diskStatus: {
            required: true,
            serializedName: 'properties.diskStatus',
            type: {
              name: 'Enum',
              allowedValues: [ 'Online', 'Offline' ]
            }
          },
          accessControlRecords: {
            required: true,
            serializedName: 'properties.accessControlRecords',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          dataPolicy: {
            required: true,
            serializedName: 'properties.dataPolicy',
            type: {
              name: 'Enum',
              allowedValues: [ 'Invalid', 'Local', 'Tiered', 'Cloud' ]
            }
          },
          provisionedCapacityInBytes: {
            required: true,
            serializedName: 'properties.provisionedCapacityInBytes',
            type: {
              name: 'Number'
            }
          },
          usedCapacityInBytes: {
            required: false,
            readOnly: true,
            serializedName: 'properties.usedCapacityInBytes',
            type: {
              name: 'Number'
            }
          },
          localUsedCapacityInBytes: {
            required: false,
            readOnly: true,
            serializedName: 'properties.localUsedCapacityInBytes',
            type: {
              name: 'Number'
            }
          },
          monitoringStatus: {
            required: true,
            serializedName: 'properties.monitoringStatus',
            type: {
              name: 'Enum',
              allowedValues: [ 'Enabled', 'Disabled' ]
            }
          }
        }
      }
    };
  }
}

module.exports = ISCSIDisk;
