/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Filters that can be specified for the job
 *
 */
class JobFilter {
  /**
   * Create a JobFilter.
   * @member {string} jobType The job type. Possible values include: 'Backup',
   * 'Clone', 'Failover', 'DownloadUpdates', 'InstallUpdates'
   * @member {string} status The job status. Possible values include:
   * 'Invalid', 'Running', 'Succeeded', 'Failed', 'Canceled', 'Paused',
   * 'Scheduled'
   * @member {date} [startTime] The start time of the job.
   */
  constructor() {
  }

  /**
   * Defines the metadata of JobFilter
   *
   * @returns {object} metadata of JobFilter
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'JobFilter',
      type: {
        name: 'Composite',
        className: 'JobFilter',
        modelProperties: {
          jobType: {
            required: true,
            serializedName: 'jobType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Backup', 'Clone', 'Failover', 'DownloadUpdates', 'InstallUpdates' ]
            }
          },
          status: {
            required: true,
            serializedName: 'status',
            type: {
              name: 'Enum',
              allowedValues: [ 'Invalid', 'Running', 'Succeeded', 'Failed', 'Canceled', 'Paused', 'Scheduled' ]
            }
          },
          startTime: {
            required: false,
            serializedName: 'startTime',
            type: {
              name: 'DateTime'
            }
          }
        }
      }
    };
  }
}

module.exports = JobFilter;
