/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Monitoring metric definition represents the metadata of the metrics.
 *
 */
class MetricDefinition {
  /**
   * Create a MetricDefinition.
   * @member {object} name The metric name
   * @member {string} [name.value] Name of the metric
   * @member {string} [name.localizedValue] Localized name of the metric
   * @member {string} unit The metric unit. Possible values include: 'Bytes',
   * 'BytesPerSecond', 'Count', 'CountPerSecond', 'Percent', 'Seconds'
   * @member {string} primaryAggregationType The metric aggregation type.
   * Possible values include: 'Average', 'Last', 'Maximum', 'Minimum', 'None',
   * 'Total'
   * @member {string} resourceId The metric source id
   * @member {array} metricAvailabilities The available metric granularities
   * @member {array} dimensions The supported dimensions
   * @member {string} type The metric definition type
   */
  constructor() {
  }

  /**
   * Defines the metadata of MetricDefinition
   *
   * @returns {object} metadata of MetricDefinition
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'MetricDefinition',
      type: {
        name: 'Composite',
        className: 'MetricDefinition',
        modelProperties: {
          name: {
            required: true,
            serializedName: 'name',
            type: {
              name: 'Composite',
              className: 'MetricName'
            }
          },
          unit: {
            required: true,
            serializedName: 'unit',
            type: {
              name: 'Enum',
              allowedValues: [ 'Bytes', 'BytesPerSecond', 'Count', 'CountPerSecond', 'Percent', 'Seconds' ]
            }
          },
          primaryAggregationType: {
            required: true,
            serializedName: 'primaryAggregationType',
            type: {
              name: 'Enum',
              allowedValues: [ 'Average', 'Last', 'Maximum', 'Minimum', 'None', 'Total' ]
            }
          },
          resourceId: {
            required: true,
            serializedName: 'resourceId',
            type: {
              name: 'String'
            }
          },
          metricAvailabilities: {
            required: true,
            serializedName: 'metricAvailabilities',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'MetricAvailablityElementType',
                  type: {
                    name: 'Composite',
                    className: 'MetricAvailablity'
                  }
              }
            }
          },
          dimensions: {
            required: true,
            serializedName: 'dimensions',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'MetricDimensionElementType',
                  type: {
                    name: 'Composite',
                    className: 'MetricDimension'
                  }
              }
            }
          },
          type: {
            required: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = MetricDefinition;
