/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Storage Sync Service object.
 *
 * @extends models['TrackedResource']
 */
class StorageSyncService extends models['TrackedResource'] {
  /**
   * Create a StorageSyncService.
   * @property {number} [storageSyncServiceStatus] Storage Sync service status.
   * @property {string} [storageSyncServiceUid] Storage Sync service Uid
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of StorageSyncService
   *
   * @returns {object} metadata of StorageSyncService
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'StorageSyncService',
      type: {
        name: 'Composite',
        className: 'StorageSyncService',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          tags: {
            required: false,
            serializedName: 'tags',
            type: {
              name: 'Dictionary',
              value: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          },
          location: {
            required: true,
            serializedName: 'location',
            type: {
              name: 'String'
            }
          },
          storageSyncServiceStatus: {
            required: false,
            readOnly: true,
            serializedName: 'properties.storageSyncServiceStatus',
            type: {
              name: 'Number'
            }
          },
          storageSyncServiceUid: {
            required: false,
            readOnly: true,
            serializedName: 'properties.storageSyncServiceUid',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = StorageSyncService;
