/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Class representing a AccessPolicyCreateOrUpdateParameters.
 */
class AccessPolicyCreateOrUpdateParameters {
  /**
   * Create a AccessPolicyCreateOrUpdateParameters.
   * @member {string} [principalObjectId] The objectId of the principal in
   * Azure Active Directory.
   * @member {string} [description] An description of the access policy.
   * @member {array} [roles] The list of roles the principal is assigned on the
   * environment.
   */
  constructor() {
  }

  /**
   * Defines the metadata of AccessPolicyCreateOrUpdateParameters
   *
   * @returns {object} metadata of AccessPolicyCreateOrUpdateParameters
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'AccessPolicyCreateOrUpdateParameters',
      type: {
        name: 'Composite',
        className: 'AccessPolicyCreateOrUpdateParameters',
        modelProperties: {
          principalObjectId: {
            required: false,
            serializedName: 'properties.principalObjectId',
            type: {
              name: 'String'
            }
          },
          description: {
            required: false,
            serializedName: 'properties.description',
            type: {
              name: 'String'
            }
          },
          roles: {
            required: false,
            serializedName: 'properties.roles',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'AccessPolicyRoleElementType',
                  type: {
                    name: 'Enum',
                    allowedValues: [ 'Reader', 'Contributor' ]
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = AccessPolicyCreateOrUpdateParameters;
