/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * An object that represents the status of the environment, and its internal
 * state in the Time Series Insights service.
 *
 */
class EnvironmentStatus {
  /**
   * Create a EnvironmentStatus.
   * @member {object} [ingress] An object that represents the status of ingress
   * on an environment.
   * @member {string} [ingress.state] This string represents the state of
   * ingress operations on an environment. It can be "Disabled", "Ready",
   * "Running", "Paused" or "Unknown". Possible values include: 'Disabled',
   * 'Ready', 'Running', 'Paused', 'Unknown'
   * @member {object} [ingress.stateDetails] An object that contains the
   * details about an environment's state.
   * @member {string} [ingress.stateDetails.code] Contains the code that
   * represents the reason of an environment being in a particular state. Can
   * be used to programatically handle specific cases.
   * @member {string} [ingress.stateDetails.message] A message that describes
   * the state in detail.
   */
  constructor() {
  }

  /**
   * Defines the metadata of EnvironmentStatus
   *
   * @returns {object} metadata of EnvironmentStatus
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'EnvironmentStatus',
      type: {
        name: 'Composite',
        className: 'EnvironmentStatus',
        modelProperties: {
          ingress: {
            required: false,
            serializedName: 'ingress',
            type: {
              name: 'Composite',
              className: 'IngressEnvironmentStatus'
            }
          }
        }
      }
    };
  }
}

module.exports = EnvironmentStatus;
