/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * Class representing Traffic Manager User Metrics.
 *
 * @extends models['ProxyResource']
 */
class UserMetricsModel extends models['ProxyResource'] {
  /**
   * Create a UserMetricsModel.
   * @member {string} [key] The key returned by the User Metrics operation.
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of UserMetricsModel
   *
   * @returns {object} metadata of UserMetricsModel
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'UserMetricsModel',
      type: {
        name: 'Composite',
        className: 'UserMetricsModel',
        modelProperties: {
          id: {
            required: false,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          key: {
            required: false,
            serializedName: 'properties.key',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = UserMetricsModel;
