/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * A JSON object containing information about the request, such as filters for
 * the resulting actions.
 *
 */
class KnowledgeRequest {
  /**
   * Create a KnowledgeRequest.
   * @property {object} [filters] A key-value object consisting of filters that
   * may be specified to limit the results returned by the API.
   * @property {string} [filters.site] The URL of the site to return similar
   * images and similar products from. (e.g., "www.bing.com", "bing.com").
   */
  constructor() {
  }

  /**
   * Defines the metadata of KnowledgeRequest
   *
   * @returns {object} metadata of KnowledgeRequest
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'KnowledgeRequest',
      type: {
        name: 'Composite',
        className: 'KnowledgeRequest',
        modelProperties: {
          filters: {
            required: false,
            serializedName: 'filters',
            type: {
              name: 'Composite',
              className: 'Filters'
            }
          }
        }
      }
    };
  }
}

module.exports = KnowledgeRequest;
