/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A database vulnerability assessment rule baseline.
 *
 * @extends models['ProxyResource']
 */
class DatabaseVulnerabilityAssessmentRuleBaseline extends models['ProxyResource'] {
  /**
   * Create a DatabaseVulnerabilityAssessmentRuleBaseline.
   * @property {array} baselineResults The rule baseline result
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DatabaseVulnerabilityAssessmentRuleBaseline
   *
   * @returns {object} metadata of DatabaseVulnerabilityAssessmentRuleBaseline
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DatabaseVulnerabilityAssessmentRuleBaseline',
      type: {
        name: 'Composite',
        className: 'DatabaseVulnerabilityAssessmentRuleBaseline',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          baselineResults: {
            required: true,
            serializedName: 'properties.baselineResults',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'DatabaseVulnerabilityAssessmentRuleBaselineItemElementType',
                  type: {
                    name: 'Composite',
                    className: 'DatabaseVulnerabilityAssessmentRuleBaselineItem'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = DatabaseVulnerabilityAssessmentRuleBaseline;
