/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

const models = require('./index');

/**
 * A database Vulnerability Assessment scan export resource.
 *
 * @extends models['ProxyResource']
 */
class DatabaseVulnerabilityAssessmentScansExport extends models['ProxyResource'] {
  /**
   * Create a DatabaseVulnerabilityAssessmentScansExport.
   * @property {string} [exportedReportLocation] Location of the exported
   * report (e.g.
   * https://myStorage.blob.core.windows.net/VaScans/scans/serverName/databaseName/scan_scanId.xlsx).
   */
  constructor() {
    super();
  }

  /**
   * Defines the metadata of DatabaseVulnerabilityAssessmentScansExport
   *
   * @returns {object} metadata of DatabaseVulnerabilityAssessmentScansExport
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'DatabaseVulnerabilityAssessmentScansExport',
      type: {
        name: 'Composite',
        className: 'DatabaseVulnerabilityAssessmentScansExport',
        modelProperties: {
          id: {
            required: false,
            readOnly: true,
            serializedName: 'id',
            type: {
              name: 'String'
            }
          },
          name: {
            required: false,
            readOnly: true,
            serializedName: 'name',
            type: {
              name: 'String'
            }
          },
          type: {
            required: false,
            readOnly: true,
            serializedName: 'type',
            type: {
              name: 'String'
            }
          },
          exportedReportLocation: {
            required: false,
            readOnly: true,
            serializedName: 'properties.exportedReportLocation',
            type: {
              name: 'String'
            }
          }
        }
      }
    };
  }
}

module.exports = DatabaseVulnerabilityAssessmentScansExport;
