/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * Properties of a Vulnerability Assessment recurring scans.
 *
 */
class VulnerabilityAssessmentRecurringScansProperties {
  /**
   * Create a VulnerabilityAssessmentRecurringScansProperties.
   * @property {boolean} [isEnabled] Recurring scans state.
   * @property {boolean} [emailSubscriptionAdmins] Specifies that the schedule
   * scan notification will be is sent to the subscription administrators.
   * Default value: true .
   * @property {array} [emails] Specifies an array of e-mail addresses to which
   * the scan notification is sent.
   */
  constructor() {
  }

  /**
   * Defines the metadata of VulnerabilityAssessmentRecurringScansProperties
   *
   * @returns {object} metadata of VulnerabilityAssessmentRecurringScansProperties
   *
   */
  mapper() {
    return {
      required: false,
      serializedName: 'VulnerabilityAssessmentRecurringScansProperties',
      type: {
        name: 'Composite',
        className: 'VulnerabilityAssessmentRecurringScansProperties',
        modelProperties: {
          isEnabled: {
            required: false,
            serializedName: 'isEnabled',
            type: {
              name: 'Boolean'
            }
          },
          emailSubscriptionAdmins: {
            required: false,
            serializedName: 'emailSubscriptionAdmins',
            defaultValue: true,
            type: {
              name: 'Boolean'
            }
          },
          emails: {
            required: false,
            serializedName: 'emails',
            type: {
              name: 'Sequence',
              element: {
                  required: false,
                  serializedName: 'StringElementType',
                  type: {
                    name: 'String'
                  }
              }
            }
          }
        }
      }
    };
  }
}

module.exports = VulnerabilityAssessmentRecurringScansProperties;
